(in-package :om)
;(require-library "OM-SuperVP")

(defvar *OM-AURO?* 
  (if (find-package "OM-AURO") t nil))

(if *OM-AURO?*
  (in-package "OM-AURO")
  (progn
    (defpackage "OM-AURO" 
      (:nicknames "MO" "MAO" "MAU" "M" "MA"))
    (in-package "OM-AURO")))

(defvar *OM4CSOUND-version* "1.3")

(defvar *OM4CSOUND-pathname* nil)
(setf *OM4CSOUND-pathname*
      (append (pathname-directory *load-pathname*) (list "sources")))

(setf *OM4CSOUND-UDOs-pathname*
      (make-pathname :directory
                     (append (pathname-directory *load-pathname*) (list "Resources" "UDOs"))))

(defvar *OM4CSOUND-lib-files* nil)

(setf *OM4CSOUND-lib-files*
      (if om::*OM-AURO?*
        (list
         "01-csound"
         "02-opcodes"
         "03-UDOs"
         "04-Tools")
        (list
         "00-omauro"
         "01-csound"
         "02-opcodes"
         "03-UDOs"
         "04-Tools")))
  
(mapc #'(lambda (file) (om::compile&load (make-pathname :directory *OM4CSOUND-pathname* :name file))) *OM4CSOUND-lib-files*)

(defvar *om4csound-subpackages-list* nil)

(in-package "OM-AURO")

(setf  *om4csound-subpackages-list*
       `(("Csound Opcodes" 
          ,(list 
            *Additive_menu*
            *basic_oscillators_menu*
            *dynamic_oscillators_menu*
            *FM_menu*
            *Granular_Synth_menu*
            *Hyper_Vectorial_Synthesis_menu*
            *Scanned_Synthesis_menu*
            *Noise_Generators_menu*
            *Lin_and_Expt_Gens_menu*
            *Env_Generators_menu*
            *Models_menu*
            *Sample_Playback_menu*
            *Phasors_menu*
            *Table_Access_menu*
            *Table_Read/Write_menu*
            *Waveguides_menu*
            *Signal_Input_menu*
            *Signal_Output_menu*
            *Filters_menu*
            *Amplitude_Modifiers_menu*
            *Delays_menu*
            *Special_Effects_menu*
            *Convolution_&_Morph_menu*
            *Spectral_Processing_menu*
            *Analysis_menu*
            *Reverberation_menu*
            *Panning_&_Spat_menu*
            *Sample_Level_Ops_menu*
            *Comparators_&_Accumulators_menu*
            *Math_Opcodes_menu*
            *Tools_menu*
            *udos_menu*)   
          nil nil nil)
         ("Lib Functions"
          (("Basic"
            nil nil
            (make-csd
             table
             csd->synth
             easynth) nil)
           ("Tools"
            nil nil
            (cs_help
             bpf2seg
             easy-bpf
             read-table
             round2closerpowof2
             make_waveform
             split_soundfile
             join_soundfiles
             mix_soundfiles
             folder->aiff_files
             open-textfiles
             open-soundfile) 
            nil))
          nil nil nil)))

(om::fill-library *om4csound-subpackages-list*)

