(in-package "OM-AURO")

(setf *default-sample-size* 24)
(setf *default-sample-rate* 44100)
(setf *def-table-size* 8192)
(setf *krate* 0.01)
(setf *csound-path* "/usr/local/bin/csound")

;;;;; AIFF FILES ;;;;;

(om::defmethod! om::get-sound-data ((self pathname))
  :icon 221
  ;(make-instance 'om::om-sound-data 
  ;  :buffer (las::MakeReadSound (om::om-path2cmdpath self))))

  (om::get-om-sound-data (om::om-path2cmdpath self)))

(in-package "OM")

(om::defclass! om::m_snd ()
  ((path :initform nil :accessor path :initarg :path :type string)
   (nchan :initform 1 :accessor nchan :initarg :nchan :type integer)
   (ssize :initform 24 :accessor ssize :initarg :ssize :type integer)
   (srate :initform 44100 :accessor srate :initarg :srate :type number)
   (nsamples :initform 999999 :accessor nsamples :initarg :nsamples :type integer)
   (dur :initform 0.0 :accessor dur :initarg :dur :type number)
   (stringa :initform "" :accessor stringa :initarg :stringa :type string)))

(in-package "OM-AURO")

;(defun path->sndclass (path)
;  (let* ((lista (multiple-value-list (om-audio::om-sound-get-info path))))
;    (make-instance 'om::m_snd
;                   :path path
;                   :nchan (cadr lista)
;                   :ssize (cadddr lista)
;                   :srate (caddr lista)
;                   :nsamples (fifth lista)
;                   :dur (float (/ (fifth lista) (caddr lista))))))

;(defun path->sndclass (path)
;  (let ((data (om::objfromobjs path (make-instance 'om::sound))))
;    (make-instance 'om::m_snd
;                   :path path
;                   :nchan (om::number-of-channels data)
;                   :ssize (om::sample-size data)
;                   :srate (om::sample-rate data)
;                   :nsamples (om::number-of-samples data)
;                   :dur (float (/ (om::number-of-samples data) (om::sample-rate data))))))

(defun path->sndclass (path)
  (let ((data (cdr (multiple-value-list (audio-io::om-get-sound-info (namestring path))))))
    (make-instance 'om::m_snd
                   :path path
                   :nchan (car data)
                   :ssize (caddr data)
                   :srate (cadr data)
                   :nsamples (cadddr data)
                   :dur (float (/ (cadddr data) (cadr data)))
                   :stringa (namestring path))))

(om::defmethod* om::objFromObjs ((self pathname) (type om::m_snd))
  (path->sndclass self))

(om::defmethod* om::objFromObjs ((self string) (type om::m_snd))
  (path->sndclass self))

(om::defmethod* om::objFromObjs ((self om::m_snd) (type om::sound))
  (om::load-sound (pathname (om::path self))))

(om::defmethod* om::objFromObjs ((self om::sound) (type om::m_snd))
  (make-instance 'om::m_snd
                   :path (om::om-sound-file-name self)
                   :nchan (om::om-sound-n-channels self)
                   :ssize (om::om-sound-sample-size self)
                   :srate (om::om-sound-sample-rate self)   
                   :nsamples (om::om-sound-n-samples self)
                   :dur (sound-dur self)
                   :stringa (namestring (om::om-sound-file-name self))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(setf *m_snd_class* (make-instance 'om::m_snd))

;(defmethod inputsndfile ((item om::sound) &optional (pathname? nil) (stringa nil)) 
;  (if pathname? (om::om-sound-file-name item) item))

(defmethod om::get-src-path ((item om::m_snd)) (pathname (om::path item)))

(defmethod inputsndfile ((item om::sound) &optional (pathname? nil) (stringa nil)) 
  (if pathname? (om::om-sound-file-name item) (om::objfromobjs item *m_snd_class*)))

(defmethod inputsndfile ((item om::m_snd) &optional (pathname? nil) (stringa nil)) 
  (if pathname? (om::path item) item))

(defmethod inputsndfile ((item pathname) &optional (pathname? nil) (stringa nil))
  (if pathname? item
    (path->sndclass item)))

(defmethod inputsndfile ((item string) &optional (pathname? nil) (stringa nil)) 
  (if pathname? (pathname item)
    (path->sndclass item)))

(defmethod inputsndfile ((item null) &optional (pathname? nil) (stringa nil)) (error "no soundfile to open"))
  ;(let ((pathname (om::om-choose-file-dialog)))
  ;  (inputsndfile pathname pathname?)))

(defmethod inputsndfile ((item om::om-sound-data) &optional (pathname? nil) (stringa nil)) 
  (let* ((stringa (if stringa stringa "snd"))
         (name (format nil "~D.aiff" (gensym stringa)))
         (pth (pathname (om::save-sound item (om::outfile name)))))
    (if pathname? pth (inputsndfile pth))))

(om::defmethod* om::objFromObjs ((self om::om-sound-data) (type om::m_snd)) (inputsndfile self))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defmethod inputsndfile-om ((item om::sound)) item)

(defun 2om-s0und (item)
  (om::objfromobjs (inputsndfile item)
                   (make-instance 'om::sound)))

(defmethod inputsndfile-om ((item pathname)) (2om-s0und item))
(defmethod inputsndfile-om ((item string)) (2om-s0und item))
(defmethod inputsndfile-om ((item om::om-sound-data)) (2om-s0und item))
(defmethod inputsndfile-om ((item om::m_snd)) (2om-s0und item))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defmethod sound-dur ((s om::sound))
  (float (/ (om::om-sound-n-samples s) (om::om-sound-sample-rate s))))

(defmethod sound-dur ((s om::m_snd)) (om::dur s))
(defmethod sound-dur ((s pathname)) (sound-dur (inputsndfile s)))
(defmethod sound-dur ((s string)) (sound-dur (inputsndfile s)))

(defmethod sound-name ((s om::m_snd)) (namestring (om::path s)))
(defmethod sound-name ((s om::sound)) (namestring (om::om-sound-file-name s)))
(defmethod sound-name ((s pathname)) (sound-name (inputsndfile s)))
(defmethod sound-name ((s string)) (sound-name (inputsndfile s)))

(in-package "OM")

(defmethod om::om-sound-file-name ((self om::m_snd)) (m::sound-name self))
(defmethod om::om-sound-file-name ((self pathname)) (m::sound-name (m::inputsndfile self)))
(defmethod om::om-sound-file-name ((self string)) (m::sound-name (m::inputsndfile self)))
(defmethod om::om-sound-sample-rate ((self om::m_snd)) (om::srate self))
(defmethod om::om-sound-sample-rate ((self pathname)) (om::srate (m::inputsndfile self)))
(defmethod om::om-sound-sample-rate ((self string)) (om::srate (m::inputsndfile self)))
(defmethod om::om-sound-sample-size ((self om::m_snd)) (om::ssize self))
(defmethod om::om-sound-sample-size ((self pathname)) (om::ssize (m::inputsndfile self)))
(defmethod om::om-sound-sample-size ((self string)) (om::ssize (m::inputsndfile self)))
(defmethod om::om-sound-n-samples ((self om::m_snd)) (om::nsamples self))
(defmethod om::om-sound-n-samples ((self pathname)) (om::nsamples (m::inputsndfile self)))
(defmethod om::om-sound-n-samples ((self string)) (om::nsamples (m::inputsndfile self)))
(defmethod om::om-sound-n-channels ((self om::m_snd)) (om::nchan self))
(defmethod om::om-sound-n-channels ((self pathname)) (om::nchan (m::inputsndfile self)))
(defmethod om::om-sound-n-channels ((self string)) (om::nchan (m::inputsndfile self)))
(defmethod om::sound-name ((self om::m_snd)) (m::sound-name self))
(defmethod om::sound-name ((self pathname)) (m::sound-name (m::inputsndfile self)))
(defmethod om::sound-name ((self string)) (m::sound-name (m::inputsndfile self)))
(defmethod om::get-name ((self om::m_snd)) (m::sound-name self))
(defmethod om::get-name ((self pathname)) (m::sound-name (m::inputsndfile self)))
(defmethod om::get-name ((self string)) (m::sound-name (m::inputsndfile self)))
(defmethod om::sound-path ((self om::m_snd)) (m::sound-name self))
(defmethod om::sound-path ((self pathname)) (m::sound-name (m::inputsndfile self)))
(defmethod om::sound-path ((self string)) (m::sound-name (m::inputsndfile self)))

(in-package "OM-AURO")

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defun make_variable_name (n type &optional (name "var"))
  (let ((n (if (and (plusp n) (integerp n)) n 1))
        (varname (format nil "~D" (gensym name))))
    (if (= 1 n)
      (list (om::string+ type "_" varname))
      (mapcar #'(lambda (x)
                  (om::string+ type "_" varname (format nil "_~D" x)))
              (om::arithm-ser 1 n 1)))))

;;;;; classi ;;;;;

(defclass cs () nil)

(om::defclass! cs_class (cs)
  ((var_name :type list :initform nil :accessor var_name :initarg :var_name)
   (args :type list :initform nil :accessor args :initarg :args))
  (:icon 606))

(defmethod cs_class_p ((item cs_class)) t)
(defmethod cs_class_p ((item t)) nil)

(om::defclass! cs_opcode (cs_class)
  ((opcode_name :type string :initform "bubu" :accessor opcode_name :initarg :opcode_name)
   (args_name :type list :initform nil :accessor args_name :initarg :args_name))
  (:icon 606))

(defmethod cs_opcode_p ((item cs_opcode)) t)
(defmethod cs_opcode_p ((item t)) nil)

(om::defclass! cs_simple_operator (cs_class)
  ((operator :type string :initform "+" :accessor operator :initarg :operator))
  (:icon 606))

(om::defclass! cs_pfield (cs)
  ((p_num :type integer :initform 4 :accessor p_num :initarg :p_num)
   (dimension :type integer :initform 1 :accessor dimension :initarg :dimension))
  (:icon 606))

(om::defclass! cs_gen (cs)
  ((f_num :type integer :initform 1 :accessor f_num :initarg :f_num)
   (size :type integer :initform 65536 :accessor size :initarg :size)
   (gen_num :type integer :initform 1 :accessor gen_num :initarg :gen_num)
   (args :type list :initform nil :accessor args :initarg :args))
  (:icon 606))

(defmethod genp ((item cs_gen)) t)
(defmethod genp ((item t)) nil)

(om::defclass! cs_dimension_mapping (cs)
  ((idxs :type list :initform '(0) :accessor idxs :initarg :idxs)
   (opcode :type cs_opcode :initform nil :accessor opcode :initarg :opcode))
  (:icon 606))

(om::defclass! cs_multi_opc (cs_class) nil
  (:icon 606))

;;;;;;;;;;;; GLOBAL VARIABLES ;;;;;;;;;;;;;;;;;

(om::defclass! cs_global (cs_class) ())

(defun ->global (opcode &optional (name nil))
  (let* ((stringa0 (om::string+ "g" (vartypestrng opcode)))
         (stringa1 (if (stringp name) (om::string+ stringa0 "_" name)
                     (string (gensym stringa0)))))                    
    (make-instance 'm::cs_global
                   :var_name (list stringa1)
                   :args (list opcode))))

(defmethod g-in ((item cs_global))
  (make-instance 'm::cs_global
                 :var_name (var_name item)
                 :args nil))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defmethod get_var_name ((item cs))
  (var_name item))
(defmethod get_var_name ((item cs_dimension_mapping))
  (om::posn-match (var_name (opcode item)) (idxs item)))
(defmethod get_var_name ((item list))
  (om::flat (mapcar #'get_var_name item)))

(defun make_multi_opc (opc_list)
  (make-instance 'cs_multi_opc
                 :var_name (get_var_name opc_list)
                 :args opc_list))

(om::defmethod* om::x-append ((l1? cs_class) (l2? cs_class) &rest lst?)
  (make_multi_opc (om::flat (append (list l1? l2?) lst?))))

(om::defmethod* om::x-append ((l1? list) (l2? cs_class) &rest lst?)
  (make_multi_opc (om::flat (append (list l1? l2?) lst?))))

(om::defmethod* om::x-append ((l1? cs_class) (l2? list) &rest lst?)
  (make_multi_opc (om::flat (append (list l1? l2?) lst?))))
               
(om::defclass! cs_instr (cs)
  ((i_num :type integer :initform 1 :accessor i_num :initarg :i_num)
   (inside :type t :initform nil :accessor inside :initarg :inside))
  (:icon 606))

;;;;; metodo per conoscere la "dimensione" di una classe ;;;;;

(defmethod get_dim ((item cs_class))
  (length (var_name item)))

(defmethod get_dim ((item cs_pfield))
  (dimension item))

(defmethod get_dim ((item om::sound))
  (om::om-sound-n-channels item))

(defmethod get_dim ((item om::m_snd))
  (om::nchan item))

(defmethod get_dim ((item cs_dimension_mapping))
  (length (idxs item)))

(defmethod get_dim ((item cs_multi_opc))
  (length (var_name item)))

; new

(defmethod get_dim ((item list))
  (length item))

(defmethod get_dim ((item t)) 1)

(defmethod get_dim ((item null)) 1)

(defmethod mono_dimension_p ((item t))
  (= 1 (get_dim item)))

(defmethod mono_dimension_p ((item list))
  (eval (cons 'and (mapcar #'mono_dimension_p item))))

;;;;; funzione per trasformare una stringa del manuale csound in un metodo om ;;;;;

;;;;; numero di variabili istanziate da un opcode (di norma una sola) ;;;;;;;

(defun string2nvar (string &optional (docstring ""))
  (let ((lista (m::read-string 
                (coerce 
                 (om::flat 
                  (subst 
                   '(#\Space #\c #\o #\m #\m #\a) 
                   #\, 
                   (coerce string 'list) 
                   :test #'equalp)) 
                 'string)))
        (opcodename (read-from-string docstring)))
    (if (equalp (car lista) opcodename)
      0
      (let ((modlista (om::mat-trans 
                       (om::list-modulo lista 2))))
        (do ((lista- modlista (cdr lista-))
             (n 1 (1+ n)))
            ((not (equalp (cadar lista-) 'comma))
             n))))))

(defun stringa2stringhe (stringa)
  (do ((lista- (coerce stringa 'list) (cdr lista-))
       (lista+ nil (cond ((null lista+) (cons (list (car lista-)) lista+))
                         ((equalp #\Space (car lista-)) (cons nil lista+))
                         (t (cons (cons (car lista-) (car lista+)) (cdr lista+))))))
      ((endp lista-) (reverse (mapcar #'(lambda (x) (coerce (reverse x) 'string)) lista+)))))

(defun clean-string (stringa)
  (do ((lista- (coerce stringa 'list) (cdr lista-))
       (lista+ nil 
               (cond ((member (car lista-) '(#\Newline #\,) :test #'char=) lista+)
                     ((char= (car lista-) #\[) (cons #\( lista+))
                     ((char= (car lista-) #\]) (cons #\) lista+))
                     ((char= (car lista-) #\.) (cons #\1 lista+))
                     (t (cons (car lista-) lista+)))))
      ((endp lista-) (coerce (reverse lista+) 'string))))
    ;;;  ((endp lista-) (m::read-string (coerce (reverse lista+) 'string)))))

(defun args->real_and_optional (arglist &optional (n 1))
  (let* ((lista (nthcdr (1+ n) arglist))
         (realargs_n
          (do ((n 0 (1+ n))
               (lista- lista (cdr lista-)))
              ((or
                (consp (car lista-))
                (endp lista-))
               n)))
         (optionalargs_n (- (length lista) realargs_n)))
    (list realargs_n optionalargs_n)))

(defun args->methodinputs (arglist &optional (n 1))
  (let* ((nn (args->real_and_optional arglist n))
         (types 
          (om::flat
           (mapcar #'(lambda (x y)
                       (make-list x :initial-element y))
                   nn '(t nil))))
         (names (om::flat (nthcdr (1+ n) arglist)))
         (listona (mapcar #'list names types))
         (inputs
          (append (om::first-n listona (car nn))
                  (list '&optional)
                  (om::last-n listona (cadr nn)))))
    (cond ((atom (car (last inputs))) (butlast inputs))
          ((integerp (caar (last inputs)))
           (append (butlast inputs) (list '&rest 'opt_args)))
          (t
           inputs))))

;;;; metodo che determina il tipo di un oggetto (audio, krate, i o x)

(defmethod vartypestrng ((string string) &optional (string2add ""))
  (let* ((puppa (coerce (om::first-n (coerce string 'list) 1) 'string))
         (test (member puppa '("a" "k" "i" "x" "f" "w" "g") :test #'string=)))
    (cond ((null test) (error "non  la stringa di un opcode !"))
          ((string-equal "g" puppa)
           (om::string+ (coerce (list (cadr (coerce string 'list))) 'string) string2add))
          (t (om::string+ puppa string2add)))))

(defmethod vartypestrng ((string number) &optional (string2add ""))
  (om::string+ "i" string2add))

(defmethod vartypestrng ((string cs_pfield) &optional (string2add ""))
  (om::string+ "i" string2add))

(defmethod vartypestrng ((string number) &optional (string2add ""))
  (om::string+ "i" string2add))

(defmethod vartypestrng ((string om::sound) &optional (string2add ""))
  (om::string+ "a" string2add))

(defmethod vartypestrng ((string om::m_snd) &optional (string2add ""))
  (om::string+ "a" string2add))

(defmethod vartypestrng ((string cs_class) &optional (string2add ""))
  (vartypestrng (car (var_name string))))

(defmethod vartypestrng ((string om::bpf) &optional (string2add ""))
  (vartypestrng (format nil "~D" (car *bpf2seg*))))

(defmethod vartypestrng ((string list) &optional (string2add ""))
  (let ((puppa (mapcar #'vartypestrng string)))
    (cond ((member "a" puppa :test #'string=) "a")
          ((member "k" puppa :test #'string=) "k")
          ((member "f" puppa :test #'string=) "f")
          ((member "g" puppa :test #'string=) "g")
          ((member "w" puppa :test #'string=) "w")
          (t "i"))))

(defmethod vartypestrng ((string cs_dimension_mapping) &optional (string2add ""))
  (vartypestrng (opcode string) string2add))

;;;;;;;

(defun getfirstletter (string &optional (n 2))
  (coerce (om::first-n (coerce string 'list) n) 'string))

(defun args->methodname (arglist &optional (n 1))
  (let ((name (format nil "~D" (car (nthcdr n arglist)))))
    (if (zerop n)
      (read-from-string name)
      (let* ((firstarg (format nil "~D" (car arglist)))
             (vartype (vartypestrng firstarg "_")))
        (read-from-string (om::string+ vartype name))))))

(defun args->varname (arglist &optional (n 1))
  (if (zerop n) 
    (list "")    
    (let* ((firstarg (format nil "~D" (car arglist)))
           (vartype (vartypestrng firstarg)))
      (make_variable_name n vartype (format nil "~D" (car (nthcdr n arglist)))))))
    
(defun removenilfromend (lista)
  (do ((lista- (reverse lista) (cdr lista-)))
      ((car lista-) (reverse lista-))))

(defun methodname2icon_number (mname)
  (let ((bubu
         (cadr
          (assoc
           (getfirstletter (format nil "~D" mname))
           '(("a_" 221)
             ("i_" 189)
             ("k_" 657)
             ("f_" 172)
             ("w_" 191))
           :test #'string=))))
    (if bubu bubu 189)))

;; nuovo !!!

(defmethod unpacca ((item cs_class)) (if (= 1 (get_dim item)) item (unpack item)))
(defmethod unpacca ((item t)) item)

(defun args2classe_opc (args arglist n opcname cddrarglist test &optional opt_args)
  (let* ((argomenti (mapcar #'(lambda (x) (unpacca (check_opc_input x))) args))
         (dims (mapcar #'get_dim argomenti))
         (max (om::list-max dims))
         (argomm
          (if (= 1 max) 
              (list argomenti)
            (om::mat-trans
             (mapcar #'(lambda (x)
                         (check-length x max))
                     argomenti))))
         (listaa
          (mapcar #'(lambda (xxx)
                      (if test
                          (make-instance 'cs_opcode
                                         :var_name (args->varname arglist n)
                                         :opcode_name opcname
                                         :args_name (mapcar #'(lambda (x)
                                                                (format nil "~D" x))
                                                            cddrarglist)
                                         :args (removenilfromend xxx))
                        (make-instance 'cs_opcode
                                       :var_name (args->varname arglist n)
                                       :opcode_name opcname
                                       :args_name 
                                       (append
                                        (mapcar #'(lambda (x)
                                                    (format nil "~D" x))
                                                (butlast cddrarglist))
                                        (mapcar #'(lambda (x) (format nil "irest~D" x))
                                                (om::arithm-ser 1 (length opt_args) 1)))                     
                                       :args (append (butlast args) opt_args))))
                  argomm)))
    (if (= 1 (length argomm)) (car listaa) listaa)))

(defun string2method (stringa &optional (docstring "") (menu nil))
  (let* ((n (string2nvar stringa docstring))
         (stringaaa (clean-string stringa))
         (arglist0 (stringa2stringhe stringaaa))
         (arglist (read-string stringaaa))
         (opcname (nth n arglist0))
         (cddrarglist (om::flat (nthcdr (1+ n) arglist)))
         (args (cons 'list cddrarglist))
         (methodname (args->methodname arglist n))
         (methodinputs (args->methodinputs arglist n))
         (initvals (make-list (car (args->real_and_optional arglist n)) :initial-element 0))
         (varname (car (args->varname arglist n)))
         (icon_n (methodname2icon_number methodname))
         (test (not (numberp (car (last args))))))
    (if test
        (eval
         `(om::defmethod! ,methodname ,methodinputs
                          :icon ,icon_n
                          :doc ,docstring
                          :initvals ',initvals
                          (args2classe_opc ,args ',arglist ,n ,opcname ',cddrarglist ,test)))
      (eval
         `(om::defmethod! ,methodname ,methodinputs
                          :icon ,icon_n
                          :doc ,docstring
                          :initvals ',initvals
                          (args2classe_opc ,args ',arglist ,n ,opcname ',cddrarglist ,test opt_args))))
    (when menu 
      (eval `(setf ,menu (append ,menu (list ',methodname)))))))
      
#|

(defun string2method (stringa &optional (docstring "") (menu nil))
  (let* ((n (string2nvar stringa docstring))
         (stringaaa (clean-string stringa))
         (arglist0 (stringa2stringhe stringaaa))
         (arglist (read-string stringaaa))
         (opcname (nth n arglist0))
         (cddrarglist (om::flat (nthcdr (1+ n) arglist)))
         (args (cons 'list cddrarglist))
         (methodname (args->methodname arglist n))
         (methodinputs (args->methodinputs arglist n))
         (initvals (make-list (car (args->real_and_optional arglist n)) :initial-element 0))
         (varname (car (args->varname arglist n)))
         (icon_n (methodname2icon_number methodname)))
         
    (if (not (numberp (car (last args))))
      (eval
       `(om::defmethod! ,methodname ,methodinputs
          :icon ,icon_n
          :doc ,docstring
          :initvals ',initvals
          (if (mono_dimension_p ,args)
            (make-instance 'cs_opcode
              :var_name (args->varname ',arglist ,n)
              :opcode_name ,opcname
              :args_name ',(mapcar #'(lambda (x)
                                       (format nil "~D" x))
                                   cddrarglist)
              :args (removenilfromend ,args))
            (error "args have to be mono-dimensional"))))
      (eval
       `(om::defmethod! ,methodname ,methodinputs
          :icon ,icon_n
          :doc ,docstring
          :initvals ',initvals
          (if (mono_dimension_p ,args)
            (make-instance 'cs_opcode
              :var_name (args->varname ',arglist ,n)
              :opcode_name ,opcname
              :args_name 
              (append
               ',(mapcar #'(lambda (x)
                             (format nil "~D" x))
                         (butlast cddrarglist))
               (mapcar #'(lambda (x) (format nil "irest~D" x))
                       (om::arithm-ser 1 (length opt_args) 1)))                     
              :args (append (butlast ,args) opt_args))
            (error "args have to be mono-dimensional")))))
    (when menu 
      (eval `(setf ,menu (append ,menu (list ',methodname)))))))

|#


(defmethod csman_string2method ((item string) &optional (menu nil))
  (string2method item "" menu))

(defmethod csman_string2method ((item list) &optional (menu nil))
  (if (cadr item)
    (string2method (car item) (cadr item) menu)
    (csman_string2method (car item) menu)))

(defun csman2om (lista globvarname)
  (let ((stringa (coerce 
                  (subst #\Space #\_ 
                         (butlast (cdr (coerce (format nil "~D" globvarname) 'list)) 6)
                         :test #'equalp)
                  'string)))
    (mapcar #'(lambda (x) (csman_string2method x globvarname)) lista)
    (eval
     `(setf ,globvarname
            (list ,stringa nil nil ,globvarname nil)))))

;;;;;;; gli operatori matematici essenziali

(om::defmethod! make_cs_simple_operator ((operator string) (args list))
         
  :menuins (list (list 0 (mapcar #'(lambda (x) (list x x))
                                 '("+" "-" "/" "*" "^"))))
  :icon 606
  :doc "perform a math operation on a list of arguments (ex. \"+\" = x1+x2+x3+x4 ... +xn)"
  
  (let* ((len (remove-duplicates (mapcar #'get_dim args)))
         (op
          (cond ((mono_dimension_p args)    
                 (make-instance 'cs_simple_operator
                                :var_name (make_variable_name 1 (vartypestrng args))
                                :operator operator
                                :args args))
                ((and (= 2 (length args))
                      (mono_dimension_p (car args)))
                 (mapcar #'(lambda (x)
                             (make-instance 'cs_simple_operator
                                            :var_name (make_variable_name 1 (vartypestrng args))
                                            :operator operator
                                            :args (list (car args) x)))
                         (om::posn-match (cadr args) (om::arithm-ser 0 (1- (get_dim (cadr args))) 1))))
                ((and (= 2 (length args))
                      (mono_dimension_p (cadr args)))
                 (mapcar #'(lambda (x)
                             (make-instance 'cs_simple_operator
                                            :var_name (make_variable_name 1 (vartypestrng args))
                                            :operator operator
                                            :args (list x (cadr args))))
                         (om::posn-match (car args) (om::arithm-ser 0 (1- (get_dim (car args))) 1))))
                ((= 1 (length len))
                 (let ((pos (om::arithm-ser 0 (1- (car len)) 1)))
                   (mapcar #'(lambda (y)
                               (make-instance 'cs_simple_operator
                                              :var_name (make_variable_name 1 (vartypestrng y))
                                              :operator operator
                                              :args y))
                           (om::mat-trans
                            (mapcar #'(lambda (x)
                                        (om::posn-match x pos))
                                    args)))))
                (t (error "args are more than two and they do not have the same dimension")))))
    (if (listp op)
        (make_multi_opc op)
      op)))

(defmethod 2math_op ((item om::bpf))
  (bpf2opcode item))

(defmethod 2math_op ((item om::sound))
  (snd2opcode item))

(defmethod 2math_op ((item om::m_snd))
  (snd2opcode item))

(defmethod 2math_op ((item t)) item)

(defun simple_math_op_method (operator)
  (let ((operatore (read-from-string (om::string+ "om::om" operator))))
    (eval
     `(om::defmethod* ,operatore ((self cs) (num t))
        (make_cs_simple_operator ,operator (list self (2math_op num)))))
    (eval
     `(om::defmethod* ,operatore ((self cs) (num cs))
        (make_cs_simple_operator ,operator (list self num))))
    (eval
     `(om::defmethod* ,operatore ((self t) (num cs))
        (make_cs_simple_operator ,operator (list (2math_op self) num))))
    (eval
     `(om::defmethod* ,operatore ((self cs) (num list))
        (mapcar #'(lambda (x) (make_cs_simple_operator ,operator (list self x))) num)))
    (eval
     `(om::defmethod* ,operatore ((self list) (num cs))
        (mapcar #'(lambda (x) (make_cs_simple_operator ,operator (list x num))) self)))
    (eval
     `(om::defmethod* ,operatore ((self om::m_snd) (num om::m_snd))
        (make_cs_simple_operator ,operator (list (2math_op self) (2math_op num)))))
    (eval
     `(om::defmethod* ,operatore ((self om::sound) (num om::sound))
        (make_cs_simple_operator ,operator (list (2math_op self) (2math_op num)))))))

(mapcar #'simple_math_op_method '("+" "-" "/" "*" "^"))

(om::defmethod* om::om-round ((self cs) &optional (decimals 0) (divisor 1))
  (make_cs_simple_operator "round" (list self)))

(om::defmethod* om::om-abs ((self cs))
  (make_cs_simple_operator "abs" (list self)))

(defmethod om// ((self t) (num t))
  (list
   (make_cs_simple_operator "/" (list (2math_op self) (2math_op num)))
   (make_cs_simple_operator "%" (list (2math_op self) (2math_op num)))))

(om::defmethod* om::om// ((self cs) (num t)) (values-list (om// self num)))
(om::defmethod* om::om// ((self t) (num cs)) (values-list (om// self num)))
(om::defmethod* om::om// ((self cs) (num cs)) (values-list (om// self num)))
(om::defmethod* om::om// ((self cs) (num list)) 
                (values-list
                 (om::mat-trans (mapcar #'(lambda (x) (om// self x)) num))))
(om::defmethod* om::om// ((self list) (num cs)) 
                (values-list
                 (om::mat-trans (mapcar #'(lambda (x) (om// x num)) self))))

(defmethod om::initialize-instance :after  ((self m::cs_simple_operator) &key show-cont)
  (setf (args self)
        (mapcar #'check_opc_input (args self))))

;;;;;;;;;;;;;;;;;;;;

(defmethod 2string ((item cs_class))
  (m::list->string (var_name item) "~D" ", "))

(defmethod 2string ((item integer))
  (format nil "~D" item))

(defmethod 2string ((item float))
  (format nil "~F" item))

(defmethod 2string ((item string))
  (format nil "~S" item))

(defmethod 2string ((item null)) "")

(defmethod 2string ((item cs_pfield))
  (format nil "p~D" (p_num item)))

(defmethod 2string ((item cs_gen))
  (format nil "gifn~D" (f_num item)))

(defmethod 2string ((item cs_dimension_mapping))
  (m::list->string 
   (om::posn-match (var_name (opcode item))
                   (idxs item))
   "~D" ", "))

(defmethod 2string ((item pathname))
  (format nil "~S" (namestring item)))

(defmethod 2string ((item om::sound))
  (format nil "~S" (namestring (om::om-sound-file-name item))))

(defmethod 2string ((item om::m_snd))
  (format nil "~S" (namestring (om::path item))))

;;;;;;;;;;;;;;;;;;;;

(defmethod cs2string ((item cs_simple_operator))
  (om::string+
   (car (var_name item))
   " = "
   (if (= 1 (length (args item)))
     (om::string+ (operator item) "(" (2string (car (args item))) ")")
     (m::list->string 
      (mapcar #'2string (args item)) "~D" (operator item)))))

(defmethod cs2string ((item cs_opcode))
  (if (not (string= (opcode_name item) "opcode"))
      (om::string+
       (m::list->string
        (var_name item) "~D" ", ")
       " "
       (opcode_name item) 
       " "
       (m::list->string 
        (mapcar #'2string (args item)) "~D" ", "))
    (car (args item))))

(defmethod cs2string ((item cs_dimension_mapping))
  (cs2string (opcode item)))

(defmethod cs2string ((item cs_multi_opc))
  (reduce #'om::string+ (mapcar #'(lambda (x) (om::string+ (cs2string x) "~%")) (args item))))

(defmethod cs2string ((item string)) item)

(defmethod cs2string ((item cs_global))
  (if (args item)
      (om::string+
       (car (var_name item))
       " = " (2string (car (args item))))
    (om::string+
     (car (var_name item))
     " = " (car (var_name item)))))
  
;;;;;;;;;; out

(setf 
 *out_alist*
 '(("out" 1 1)
   ("outs" 2 2)
   ("outs1" 1 2) ("outs2" 1 2)
   ("out32" 32 32)
   ("outh" 6 6)
   ("outo" 8 8)
   ("outq" 4 4)
   ("outq1" 1 4) ("outq2" 1 4) ("outq3" 1 4) ("outq4" 1 4)
   ("outx" 16 16)
   ("outc" nil)))

(setf *out_alist_reverse*
      (mapcar #'(lambda (x)
                  (reverse (om::first-n x 2)))
              *out_alist*))

(defun dim_out (args)
  (reduce #'+ (mapcar #'get_dim args)))

(defmethod 2csout ((item list))
  (make_cs_simple_operator "+" item))
(defmethod 2csout ((item t)) item)

(defun get_out_type (n)
  (let ((bubu (cadr (assoc n *out_alist_reverse*))))
    (if bubu bubu "outc")))

(om::defmethod! cs_out ((out_type string) (arg0 t) &rest args)
  :icon 606
  :initvals '("outc" nil)
  :indoc '("out type" "args")
  :doc ""
  
  :menuins `((0 ,(mapcar #'(lambda (x)
                             (list (car x) (car x)))
                         *out_alist*)))
  (let* ((arguments (cons arg0 args))
         (arguments_pack (mapcar #'2csout arguments))
         (n_out (dim_out arguments_pack))
         (n1 (cadr (assoc out_type *out_alist* :test #'string=)))
         (n (if n1 n1 n_out)))
    (progn
      (when
        (not (= n n_out))
        (error "il numero di variabili audio non corrisponde all'opcode per l'output selezionato"))
      (make-instance 'cs_opcode
        :var_name (list "")
        :opcode_name out_type
        :args_name (mapcar #'(lambda (x)
                               (format nil "asig~D" x))
                           (om::arithm-ser 1 n 1))
        :args arguments_pack))))

(om::defmethod! cs_easy-out ((opcodes list) &optional (mix_outputs? t))
  :icon 606
  :initvals '(nil t)
  :indoc '("a list of opcodes (obviously with the same dimension if you want to mix the outputs ...)")
  :doc ""
  :menuins '((1 (("mix outputs" t)
                 ("append outputs" nil))))

  (let* ((listaa (remove-if #'init_class_p opcodes))
         (opc 
          (if mix_outputs?
              (make_cs_simple_operator 
               "+"
               listaa)
            (make_multi_opc listaa)))
         (dim (get_dim opc))
         (outype (get_out_type dim)))
    (apply #'cs_out 
           (cons outype
                 (mapcar #'(lambda (n)
                             (om::posn-match opc n))
                         (om::arithm-ser 0 (1- dim) 1))))))

(om::defmethod! cs_easy-out ((opcodes cs_class) &optional (mix_outputs? t))
  (cs_easy-out (list opcodes)))

(om::defmethod! easynth ((opcodes t) 
                         &optional (p2 (list 0)) (p3 5)
                         &key 
                         (name "easy") (sample-rate *default-sample-rate*) (sample-size *default-sample-size*)
                         (control-rate nil) (rescale nil)
                         p4 p5 p6 p7 p8 p9 p10 p11 p12 p13 p14 p15 p16 p17 p18 p19 p20
                         p21 p22 p23 p24 p25 p26 p27 p28 p29 p30 p31 p32 p33 p34 p35 p36 p37 p38 p39 p40)
  :icon 606

  (let* ((opc (om::flat (list opcodes)))
         (out (cs_easy-out opc))
         (init (remove-if-not #'init_class_p opc))
         (ok (append init (list out)))
         (pf (remove nil (append
                          (list p2 p3)
                          (list
                           p4 p5 p6 p7 p8 p9 p10 p11 p12 p13 p14 p15 p16 p17 p18 p19 p20
                           p21 p22 p23 p24 p25 p26 p27 p28 p29 p30 p31 p32 p33 p34 p35 p36 p37 p38 p39 p40))))
         (args (cons ok pf)))
    (csd->synth  
     (apply #'make-csd args) 
     name sample-rate sample-size control-rate rescale)))

    
;;;;;;;;;;;;;;;;;;;;;;;;; GEN functions ;;;;;;;;;;;;;;;;;;;;;;;;;


(setf 
 *gen_menu*
 (mapcar 
  #'list
  '("GEN01 - Transfers data from a soundfile into a function table"
    "GEN02 - Transfers data from immediate pfields into a function table"
    "GEN03 - Generates a stored function table by evaluating a polynomial"
    "GEN04 - Generates a normalizing function"
    "GEN05 - Constructs functions from segments of exponential curves"
    "GEN06 - Generates a function comprised of segments of cubic polynomials"
    "GEN07 - Constructs functions from segments of straight lines"
    "GEN08 - Generate a piecewise cubic spline curve"
    "GEN09 - Generate composite waveforms made up of weighted sums of simple sinusoids"
    "GEN10 - Generate composite waveforms made up of weighted sums of simple sinusoids"
    "GEN11 - Generates an additive set of cosine partials"
    "GEN12 - Generates the log of a modified Bessel function of the second kind"
    "GEN13 - Stores a polynomial whose coeffs derive from the Chebyshev polynomials of the 1st kind"
    "GEN14 - Stores a polynomial whose coeffs derive from Chebyshevs of the 2nd kind"
    "GEN15 - Creates two tables of stored polynomial functions"
    "GEN16 - Creates a table from a starting value to an ending value"
    "GEN17 - Creates a step function from given x-y pairs"
    "GEN18 - Writes composite waveforms made up of pre-existing waveforms"
    "GEN19 - Generate composite waveforms made up of weighted sums of simple sinusoids"
    "GEN20 - Generates functions of different windows"
    "GEN21 - Generates tables of different random distributions"
    "GEN23 - Reads numeric values from a text file"
    "GEN24 - Reads numeric values from another allocated function-table and rescales them"
    "GEN25 - Construct functions from segments of exponential curves in breakpoint fashion"
    "GEN27 - Construct functions from segments of straight lines in breakpoint fashion"
    "GEN28 - Reads a text file which contains a time-tagged trajectory"
    "GEN30 - Generates harmonic partials by analyzing an existing table"
    "GEN31 - Mixes any waveform specified in an existing table"
    "GEN32 - Mixes any waveform, resampled with either FFT or linear interpolation"
    "GEN33 - Generate composite waveforms by mixing simple sinusoids"
    "GEN34 - Generate composite waveforms by mixing simple sinusoids"
    "GEN40 - Generates a random distribution using a distribution histogram"
    "GEN41 - Generates a random list of numerical pairs"
    "GEN42 - Generates a random distribution of discrete ranges of values"
    "GEN43 - Loads a PVOCEX file containing a PV analysis"
    "GEN51 - This subroutine fills a table with a fully customized micro-tuning scale"
    "GEN52 - Creates an interleaved multichannel table from the specified source tables")
  '(1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 23 24 25 27 28 30 31 32 33 34 40 41 42 43 51 52)))

(setf 
 *size_menu*
 (let* ((bitnum (om::arithm-ser 1 24 1))
        (sizes (om::om^ 2 bitnum)))
   (cons (list "0bit (0)" 0)
         (mapcar #'(lambda (x y)
                     (list (format nil "~Dbit (~D)" y x)
                           x))
                 sizes bitnum))))

(defun table_w_list (gen pargen size post-normalized?)
  (make-instance 'm::cs_gen
    :f_num (read-from-string (coerce (cdr (coerce (format nil "~D" (gensym)) 'list)) 'string))
    :size size
    :gen_num (* gen post-normalized?)
    :args pargen))
       
(om::defmethod! table ((gen integer) 
                       (pargen list)
                       &optional 
                       (size *def-table-size*)
                       (post-normalized? 1))
  :icon 425
  :indoc '("gen number" "pargen" "size")
  :initvals (list 10 (list 1) *def-table-size* 1)
  :menuins (list 
            (list 0 *gen_menu*)
            (list 2 *size_menu*)
            (list 3 '(("yes" 1)
                      ("no" -1))))
  :doc "    generates parameters for a Csound ftable.

   <gen>    number of the GEN subroutine (p4)
   <pargen> list containing auxiliary parameters (p5, p6, p7, ...), specifying values
            for the GEN subroutine  
   <size>   points in the table (p3)
   <time>   moment, in seconds, for triggering off the table (p2)   "
  
  (if
    (not (eval (cons 'and (mapcar #'genp pargen))))
    (table_w_list gen pargen size post-normalized?)
    (progn
      (when (not 
             (or (= 2 (length pargen))
                 (exactp (sqrt (length pargen)))))
        (error "~%~%Table length must be a power of 2 !~%~%"))
      (cons
       (table_w_list 2 (mapcar #'2sco pargen) (length pargen) -1)
       pargen))))

(om::defmethod! table ((gen integer) 
                       (pargen number)
                       &optional 
                       (size *def-table-size*)
                       (post-normalized? 1))
  (table gen (list pargen) size post-normalized?))
  
(defun paramXY (Xlist Ylist)
  (let ((lstxy (list Xlist Ylist ))(auxlist) (x) (y))
    (setf x (om::x->dx (first lstxy)))
    (setf y (second lstxy))
    (dotimes (z (length x))
      (push (nth z y) auxlist)
      (push (nth z x) auxlist))
    (push (nth (- (length y) 1) y) auxlist)
    (reverse auxlist)))

(defun om-scale/max (list max)
  (om::less-tree-mapcar #'(lambda (x y) (om::om* x (/ y (om::list-max x)))) list max t))

(defun filter_pargen (lista)
  (let* ((listona (om::mat-trans (om::list-modulo lista 2)))
         (listona2 (remove-if #'(lambda (x) (ignore-errors (zerop (cadr x)))) listona))
         (listona3 (do ((lista- listona2 (cdr lista-))
                        (lista+ nil (cond ((null lista+) (cons (list (car lista-)) lista+))
                                          ((= (caaar lista+) (caar lista-))
                                           (cons (cons (car lista-) (car lista+))
                                                 (cdr lista+)))
                                          (t (cons (list (car lista-)) lista+)))))
                       ((endp lista-) (reverse (mapcar #'reverse lista+)))))
         (listona4 (mapcar #'(lambda (x)
                               (if (<= (length x) 2)
                                 x (cons 
                                    (list (caar x)
                                          (reduce #'+ (mapcar #'cadr (butlast x))))
                                    (last x))))
                           listona3)))
    (om::flat listona4)))

(defmethod pargen57 ((bpf0 om::bpf) (pnts integer) &optional (ndec 4))
  (let* ((Ly (copy-list (om::x-points bpf0)))
         (Lx (copy-list (om::y-points bpf0))))
    (remove nil
            (filter_pargen
             (paramxy (om::om-round (om-scale/max Ly pnts))
                      (om::om-round Lx ndec))))))

(om::defmethod! table ((gen integer) 
                       (pargen om::bpf)
                       &optional 
                       (size *def-table-size*)
                       (post-normalized? 1))
  (case gen
    (5 (table gen (pargen57 pargen size) size post-normalized?))
    (7 (table gen (pargen57 pargen size) size post-normalized?))
    (t (error "bpfs work just with gen5 and gen7"))))
    
(om::defmethod! table ((gen integer) 
                       (pargen om::chord-seq)
                       &optional 
                       (size *def-table-size*)
                       (post-normalized? 1))
  (case gen
    (5 (table gen 
              (om::mc->f (om::objfromobjs pargen (make-instance 'om::bpf)))
              size post-normalized?))
    (7 (table gen 
              (om::mc->f (om::objfromobjs pargen (make-instance 'om::bpf)))
              size post-normalized?))
    (t (error "chord-seqs work just with gen5 and gen7"))))

(om::defmethod! table ((gen integer) 
                       (pargen om::voice)
                       &optional 
                       (size *def-table-size*)
                       (post-normalized? 1))
  (case gen
    (5 (table gen 
              (om::objfromobjs pargen (make-instance 'om::chord-seq))
              size post-normalized?))
    (7 (table gen 
              (om::objfromobjs pargen (make-instance 'om::chord-seq))
              size post-normalized?))
    (t (error "voices work just with gen5 and gen7"))))

(om::defmethod! table ((gen integer) 
                       (pargen pathname)
                       &optional 
                       (size *def-table-size*)
                       (post-normalized? 1))
  (if (= 1 gen)              
      (let ((snd (om::load-sound pargen)))
        (table gen 
               (list
                snd 0 0 0)
               size post-normalized?))
    (error "with a pathname you probably need a gen1")))

(om::defmethod! table ((gen integer) 
                       (pargen om::sound)
                       &optional 
                       (size *def-table-size*)
                       (post-normalized? 1))
  (if (= 1 gen) 
      (table gen 
             (list
              pargen 0 0 0)
             size post-normalized?)
    (error "with a sound you probably need a gen1")))

(om::defmethod* om::Objfromobjs ((Self om::sound) (Type cs_gen))
  (table 1 Self (round2closerpowof2 Self) -1))   

(defun gen2opcode (cs_gen)
  (make-instance 'm::cs_opcode
    :var_name (list (2string cs_gen))
    :opcode_name "ftgen"
    :args (append (list 0 0 (size cs_gen) (gen_num cs_gen)) 
                  (args cs_gen))))

(defmethod cs2string ((item cs_gen))
  (cs2string 
   (gen2opcode item)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; dimension mapping

(om::defmethod* om::posn-match ((list m::cs_class) (positions list))
  (mapcar #'(lambda (x)
              (make-instance 'm::cs_dimension_mapping
                             :idxs (list x)
                             :opcode list))
          positions))

(om::defmethod* om::posn-match ((list m::cs_class) (positions integer))
  (make-instance 'm::cs_dimension_mapping
    :idxs (list positions)
    :opcode list))

(om::defmethod* om::first-n ((list m::cs_class) (n integer))
  (om::posn-match list (om::arithm-ser 0 (1- n) 1)))

(om::defmethod* om::posn-match ((list m::cs_simple_operator) (positions integer))
  (if (= 0 positions)
    list
    (format t "~%   Warning!!! : Indexes do not match the opcode dimension~%")))

(om::defmethod* om::last-n ((list m::cs_class) (n integer))
  (let ((posns (om::arithm-ser 0 (1- (length (var_name list))) 1)))
    (om::posn-match list posns)))

(defmethod om::initialize-instance :after ((self m::cs_dimension_mapping) &key show-cont)
  (let ((vars (var_name (opcode self))))
    (when (member nil
                  (mapcar #'(lambda (x)
                              (nth x vars))
                          (idxs self)))
      (format t "~%   Warning!!! : Indexes do not match the opcode dimension~%"))))

(mapcar 
 #'(lambda (x)
     (eval
      `(om::defmethod! 
        ,(read-from-string (format nil "unpack~D" x)) ((items m::cs))
        :icon 425
        :initvals ',(list (om::arithm-ser 1 x 1))
        :numouts ,x
        :indoc '("list")
        :doc "a max-like unpack"
        (apply #'values (mapcar #'(lambda (y) 
                                    (om::posn-match items y))
                                (om::arithm-ser 0 (1- ,x) 1))))))
 (om::arithm-ser 2 50 1))

(om::defmethod! unpack ((item m::cs_class))
  :icon 425
  :doc "opcode multidimensionale -> lista di opcodes monodimensionali"
  (mapcar #'(lambda (y) 
              (om::posn-match item y))
          (om::arithm-ser 0 (1- (get_dim item)) 1)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(setf *p3* (make-instance 'cs_pfield :p_num 3))

(setf *seg_alist*
      (list 
       (list 'a_linseg 'a_line)
       (list 'k_linseg 'k_line)
       (list 'a_expseg 'a_expon)
       (list 'a_expsega 'a_expon)
       (list 'k_expseg 'k_expon)
       (list 'a_transeg 'a_transeg)
       (list 'k_transeg 'k_transeg)))

(om::defmethod! m::bpf2seg ((bpf om::bpf) &optional (lin_or_exp 'k_linseg) (p3rescale nil) (itype 2))
  :initvals '((make-instance 'om::bpf) 'k_linseg nil 2)
  :indoc '("a bpf" "type of envelope generator" "rescale the duration of the bpf according to p3" "itype (if transeg)")       
  :menuins '((1 (("a_linseg" 'a_linseg) 
                 ("k_linseg" 'k_linseg)
                 ("a_expseg" 'a_expseg)
                 ("k_expseg" 'k_expseg)
                 ("a_expsega" 'a_expsega)
                 ("a_transeg" 'a_transeg)
                 ("k_transeg" 'k_transeg)))
             (2 (("yep" *p3*)
                 ("nope" nil))))       
  :icon 606 
  :doc "      convert a bpf into an envelope generator"
  
  (let* ((yp (om::y-points bpf))
         (dxp (om::x->dx (om::x-points bpf)))
         (dx (if (null p3rescale)
               (om::om-round dxp *decimals*)
               (let* ((dxscaled (om::om-round (om::om-scale/sum dxp 1.0) *decimals*))
                      (dxalist (mapcar #'(lambda (x)
                                           (list x (om::om* p3rescale x)))
                                       (remove-duplicates dxscaled))))
                 (mapcar #'(lambda (x)
                             (cadr (assoc x dxalist)))
                         dxscaled))))
         (lista (cons
                 (car yp)
                 (om::flat
                  (mapcar #'list 
                          dx
                          (cdr yp)))))
         (it (check-length itype (length lista)))
         (lista2 (if (or (equalp lin_or_exp 'k_transeg)
                         (equalp lin_or_exp 'a_transeg))
                     (butlast 
                      (om::flat
                       (mapcar #'(lambda (x y)
                                   (append x (list y)))
                               (om::group-list lista (make-list (ceiling (/ (length lista) 2)) :initial-element 2) 'om::linear)
                               it)))
                   lista))
         (fun (if (<= (length lista2) 3)
                  (cadr (assoc lin_or_exp *seg_alist* :test #'equalp))
                lin_or_exp)))
    
    (eval
     (cons fun
           lista2))))

(om::defmethod! bpf2seg ((bpf list) &optional (lin_or_exp 'k_linseg) (p3rescale nil) (itype 2))
  (bpf2seg (easy-bpf bpf) lin_or_exp p3rescale))

(setf *bpf2seg*
      (list 'k_linseg *p3*))

(defun bpf2opcode (bpf)
  (apply #'bpf2seg (cons bpf *bpf2seg*)))

(defun snd2opcode (snd)
  (a_diskin2 snd 1.0))

(defmethod check_opc_input ((input om::bpf)) (bpf2opcode input))

(defmethod check_opc_input ((input om::bpf-lib))
  (check_opc_input (om::bpf-list input)))

(defmethod check_opc_input ((input om::note))
  (om::mc->f (om::midic input)))

(defmethod check_opc_input ((input om::chord))
  (let* ((midic0 (om::lmidic input))
         (midic1 (if (= 1 (length midic0)) (car midic0) midic0)))
    (om::mc->f midic1)))

(defmethod check_opc_input ((input om::chord-seq))
  (om::flat (mapcar #'check_opc_input (om::inside input))))

(defmethod check_opc_input ((input om::voice))
  (om::flat (mapcar #'check_opc_input (om::chords input))))

(defmethod check_opc_input ((input ratio))
  (float input))

(defmethod check_opc_input ((input om::sound))
  (om::om-sound-file-name input))

(defmethod check_opc_input ((input t)) input)

(defmethod check_opc_input ((input list))
  (mapcar #'check_opc_input input))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defmethod ivar_p ((item cs_class))
  (ignore-errors (zerop (search "i" (car (var_name item))))))

(defmethod ivar_p ((item cs_dimension_mapping))
  (ivar_p (opcode item)))

(defmethod ivar_p ((item number)) t)

(defmethod ivar_p ((item cs_gen)) t)

(defmethod ivar_p ((item cs_pfield)) t)

(defmethod ivar_p ((item t)) nil)

(defmethod avar_p ((item cs_class))
  (ignore-errors (zerop (search "a" (car (var_name item))))))

(defmethod avar_p ((item cs_dimension_mapping))
  (avar_p (opcode item)))

(defmethod avar_p ((item om::bpf))
  (ignore-errors (zerop (search "a" (format nil "~D" (car *bpf2seg*))))))

(defmethod avar_p ((item t)) nil)

(defmethod kvar_p ((item cs_class))
  (or
   (ignore-errors (zerop (search "k" (car (var_name item)))))
   (ignore-errors (zerop (search "i" (car (var_name item)))))))

(defmethod kvar_p ((item cs_dimension_mapping))
  (kvar_p (opcode item)))

(defmethod kvar_p ((item om::bpf))
  (ignore-errors (zerop (search "k" (format nil "~D" (car *bpf2seg*))))))

(defmethod kvar_p ((item t)) nil)

(defmethod xvar_p ((item t))
  (or (kvar_p item) (avar_p item) (ivar_p item)))

(defmethod fvar_p ((item cs_class))
  (ignore-errors (zerop (search "f" (car (var_name item))))))

(defmethod fvar_p ((item cs_dimension_mapping))
  (fvar_p (opcode item)))

(defmethod fvar_p ((item t)) nil)

(defmethod wvar_p ((item cs_class))
  (ignore-errors (zerop (search "w" (car (var_name item))))))

(defmethod wvar_p ((item cs_dimension_mapping))
  (wvar_p (opcode item)))

(defmethod wvar_p ((item t)) nil)

(defun check_input_type (input_name item)
  (let ((funname (read-from-string (format nil "m::~Dvar_p" (getfirstletter input_name 1)))))
    (when
      (not (funcall funname item))
      (format t "~%   Warning!!! : bad argument type for input ~S~%" input_name))))

(defmethod om::initialize-instance :after  ((self m::cs_opcode) &key show-cont)
  ;(mapcar #'check_input_type 
  ;        (args_name self)
  ;        (args self))
  (setf (args self)
        (mapcar #'check_opc_input (args self))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


(defmethod class2explode_p ((class cs_class)) t)
(defmethod class2explode_p ((class cs_gen)) t)
(defmethod class2explode_p ((class cs_dimension_mapping)) t)
(defmethod class2explode_p ((class t)) nil)

(defmethod get_nested_cs_classes ((item cs_class))
  (remove-if-not
   #'class2explode_p    
   (args item)))

(defmethod get_nested_cs_classes ((item cs_gen)) nil)

(defmethod get_nested_cs_classes ((item string)) nil)

(defmethod get_nested_cs_classes ((item cs_dimension_mapping))
  (opcode item))

(defmethod get_nested_cs_classes ((item cs_multi_opc))
  (args item))

(defmethod get_nested_cs_classes ((item list))
  (remove nil (om::flat (mapcar #'get_nested_cs_classes item))))

(defmethod get_all_nested_classes ((item t))
  (do ((lista+ (list item) (cons (get_nested_cs_classes (car lista+))
                                 lista+)))
      ((null (car lista+)) (om::flat (cdr lista+)))))

(defmethod get_all_nested_classes ((item list))
  (om::flat 
   (mapcar #'get_all_nested_classes item)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;; SCORE ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(setf *decimals* 6)

(defmethod 2sco ((item number))
  (om::om-round item *decimals*))

(defmethod 2sco ((item t))
  (2string item))

(defmethod 2sco ((item cs_gen))
  (f_num item))

(defmethod 2sco ((item list))
  (2sco (car item)))

(defmethod 2sco ((item null)) "")

(defmethod list2sco ((item list))
  (list (remove-if-not #'genp (om::flat item))
        (mapcar #'2sco item))) 

(defun 35plodics3q (cseq)
  (om::mat-trans
   (om::flat
    (mapcar #'(lambda (x y z k)
                (mapcar #'list
                        (check-length x (length y))
                        y z k))
            (om::lonset cseq)
            (om::lmidic cseq)
            (om::ldur cseq)
            (om::lvel cseq)) 1)))

(defmethod pre_process_pfield ((pnumber integer) (item om::chord))
  (om::mc->f (om::lmidic item)))

(defmethod pre_process_pfield ((pnumber integer) (item om::chord-seq))
  (let ((pacc0 (35plodics3q item)))
    (cond ((= 2 pnumber)
           (om::om/ (car pacc0) 1000.0))
          ((= 3 pnumber)
           (om::om/ (caddr pacc0) 1000.0))
          (t (om::mc->f (cadr pacc0))))))

(defmethod pre_process_pfield ((pnumber integer) (item om::voice))
  (pre_process_pfield pnumber (om::objfromobjs item (make-instance 'om::chord-seq))))

(defmethod pre_process_pfield ((pnumber integer) (item om::poly))
  (om::flat
   (mapcar #'(lambda (x)
               (pre_process_pfield pnumber x))
           (om::voices item))))

(defmethod pre_process_pfield ((pnumber integer) (item om::bpf))
  (cond ((= 2 pnumber)
         (om::x-points item)) 
        (t (om::y-points item))))

(defmethod pre_process_pfield ((pnumber integer) (item om::bpf-lib))
  (mapcar #'(lambda (x)
              (om::objfromobjs x (make-instance 'cs_gen)))
          (om::bpf-list item)))

(defmethod pre_process_pfield ((pnumber integer) (item t)) item)

(defmethod pre_process_pfield ((pnumber integer) (item list)) (om::expand-lst item))

(defmethod eval-pfield ((n_rows integer) (pfield list))
  (list2sco (m::check-length (om::expand-lst pfield) n_rows)))

(defmethod eval-pfield ((n_rows integer) (pfield t))
  (list2sco (m::check-length pfield n_rows)))

(defun function_args (fun)
  (length (om::function-lambda-list fun)))

(defmethod eval-pfield ((n_rows integer) (pfield function))
  (let* ((fun 
          (cond 
           ((zerop (function_args pfield))
            #'(lambda ()
                (funcall pfield)))
           ((= 1 (function_args pfield))
            #'(lambda ()
                (funcall pfield n_rows)))
           (t (error "function must have 0 or 1 args ! ~%"))))
         (result
          (if (= 1 (function_args pfield))
            (funcall fun)
            (do ((i 0 (1+ i))
                 (lista+ nil (cons (funcall fun) lista+)))
                ((= i n_rows) (reverse lista+))))))
    (list2sco result)))

(defmethod eval-p2 ((n_rows integer) (pfield list))
  (if (= 1 (length pfield))
    (om::om-round pfield *decimals*)
    (om::om-round (butlast (om::dx->x (car pfield) (m::check-length (om::x->dx pfield) n_rows)))
                  *decimals*)))

(defmethod eval-p2 ((n_rows integer) (pfield t))
  (eval-pfield n_rows pfield))

(defmethod eval-p3 ((n_rows integer) (pfield t))
  (cadr (eval-pfield n_rows pfield)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

#|

classe CSD : 
1) instr_n
2) variabili globali (g) 
3) variabili locali (i) 
4) strumento (una lista di opcodes)
5) GENs (lista di cs_gen)
6) score (lista di liste ordinata alla maniera di Stroppa (in colonne))

|#

(om::defclass! csd (cs)
  ((instr_n :type integer :initform 0 :accessor instr_n :initarg :instr_n)
   (g_var :type t :initform nil :accessor g_var :initarg :g_var)
   ;;;;;;;;;; (i_var :type t :initform nil :accessor i_var :initarg :i_var)
   (instr :type t :initform nil :accessor instr :initarg :instr)
   (gens :type t :initform nil :accessor gens :initarg :gens)
   (score :type list :initform nil :accessor score :initarg :score))  
  (:icon 606))

(defmethod mylength ((item list)) (length item))
(defmethod mylength ((item t)) 1)

(defmethod init_class_p ((item cs_gen)) t)
(defmethod init_class_p ((item cs_global)) nil)
(defmethod init_class_p ((item cs_opcode))
  (member (opcode_name item)
          '("vbaplsinit" "opcode")
          :test #'equalp))
(defmethod init_class_p ((item t)) nil)
(defmethod global_p ((item cs_global)) t)
(defmethod global_p ((item t)) nil)

;=========================== pfields method ===========================;

(mapcar #'(lambda (x)
            (eval
             `(om::defmethod! ,(read-from-string (format nil "p~D" x)) (&optional (dimension 1))
                :icon 154
                :doc ,(format nil "     pfield #~D" x)
                (make-instance 'cs_pfield
                  :p_num ,x
                  :dimension dimension))))
        (om::arithm-ser 2 100 1))

;=========================== make CSD class ===========================;

(om::defmethod! make-csd ((instrument t) 
                          (p2 t) (p3 t)
                          &optional 
                          p4 p5 p6 p7 p8 p9 p10 p11 p12 p13 p14 p15 p16 p17 p18 p19 p20 p21 p22 p23 p24 p25 
                          p26 p27 p28 p29 p30 p31 p32 p33 p34 p35 p36 p37 p38 p39 p40 p41 p42 p43 p44 p45 p46 
                          p47 p48 p49 p50 p51 p52 p53 p54 p55 p56 p57 p58 p59 p60 p61 p62 p63 p64 p65 p66 p67 
                          p68 p69 p70 p71 p72 p73 p74 p75 p76 p77 p78 p79 p80 p81 p82 p83 p84 p85 p86 p87 p88 
                          p89 p90 p91 p92 p93 p94 p95 p96 p97 p98 p99 p100)
  :icon 425
  :indoc '("instrument : an opcode or a list of opcodes, pr a lambda function with at least one input (p3)" "p2" "p3"
           "p4" "p5" "p6" "p7" "p8" "p9" "p10" "p11" "p12" "p13" "p14" "p15" "p16" "p17" "p18" "p19" "p20" "p21" "p22" "p23" 
           "p24" "p25" "p26" "p27" "p28" "p29" "p30" "p31" "p32" "p33" "p34" "p35" "p36" "p37" "p38" "p39" "p40" "p41" "p42" 
           "p43" "p44" "p45" "p46" "p47" "p48" "p49" "p50" "p51" "p52" "p53" "p54" "p55" "p56" "p57" "p58" "p59" "p60" "p61" 
           "p62" "p63" "p64" "p65" "p66" "p67" "p68" "p69" "p70" "p71" "p72" "p73" "p74" "p75" "p76" "p77" "p78" "p79" "p80" 
           "p81" "p82" "p83" "p84" "p85" "p86" "p87" "p88" "p89" "p90" "p91" "p92" "p93" "p94" "p95" "p96" "p97" "p98" "p99" "p100")                                                                                               
  :doc "    create a CSD class (score+orchestra for a single instrument)"
  :initvals (list nil (list 0) 10 nil)
  
  (let* ((opcode (get_all_nested_classes instrument))
         (gvar (remove-if-not #'init_class_p opcode))
         (instr (remove-if #'init_class_p opcode))
         (p2 (pre_process_pfield 2 p2))
         (p3 (pre_process_pfield 3 p3))
         (listapf 
          (remove nil
                  (list p4 p5 p6 p7 p8 p9 p10 p11 p12 p13 p14 p15 p16 p17 p18 p19 p20 p21 p22 p23 p24 p25 
                        p26 p27 p28 p29 p30 p31 p32 p33 p34 p35 p36 p37 p38 p39 p40 p41 p42 p43 p44 p45 p46 
                        p47 p48 p49 p50 p51 p52 p53 p54 p55 p56 p57 p58 p59 p60 p61 p62 p63 p64 p65 p66 p67 
                        p68 p69 p70 p71 p72 p73 p74 p75 p76 p77 p78 p79 p80 p81 p82 p83 p84 p85 p86 p87 p88 
                        p89 p90 p91 p92 p93 p94 p95 p96 p97 p98 p99 p100)))
         (pfields (mapcar #'(lambda (x)
                              (pre_process_pfield 4 x)) listapf))
         (nrows (om::list-max (mapcar #'mylength (cons p2 (cons p3 pfields)))))
         (p2eval (eval-p2 nrows p2))
         (p3eval (eval-p3 nrows p3))
         (pn (mapcar #'(lambda (x)
                         (eval-pfield nrows x))
                     pfields))
         (gens (om::flat 
                (remove nil
                        (mapcar #'car pn))))
         (score 
          (append
           (list p2eval p3eval)
           (mapcar #'cadr pn))))
    (make-instance 'csd
      :g_var gvar
      :instr instr
      :gens gens
      :score score)))

(om::defmethod! make-csd ((instrument function) 
                          (p2 t) (p3 t)
                          &optional 
                          p4 p5 p6 p7 p8 p9 p10 p11 p12 p13 p14 p15 p16 p17 p18 p19 p20 p21 p22 p23 p24 p25 
                          p26 p27 p28 p29 p30 p31 p32 p33 p34 p35 p36 p37 p38 p39 p40 p41 p42 p43 p44 p45 p46 
                          p47 p48 p49 p50 p51 p52 p53 p54 p55 p56 p57 p58 p59 p60 p61 p62 p63 p64 p65 p66 p67 
                          p68 p69 p70 p71 p72 p73 p74 p75 p76 p77 p78 p79 p80 p81 p82 p83 p84 p85 p86 p87 p88 
                          p89 p90 p91 p92 p93 p94 p95 p96 p97 p98 p99 p100)

  (let ((n_args (function_args instrument))
        (pfields (list p4 p5 p6 p7 p8 p9 p10 p11 p12 p13 p14 p15 p16 p17 p18 p19 p20 p21 p22 p23 p24 p25 
                       p26 p27 p28 p29 p30 p31 p32 p33 p34 p35 p36 p37 p38 p39 p40 p41 p42 p43 p44 p45 p46 
                       p47 p48 p49 p50 p51 p52 p53 p54 p55 p56 p57 p58 p59 p60 p61 p62 p63 p64 p65 p66 p67 
                       p68 p69 p70 p71 p72 p73 p74 p75 p76 p77 p78 p79 p80 p81 p82 p83 p84 p85 p86 p87 p88 
                       p89 p90 p91 p92 p93 p94 p95 p96 p97 p98 p99 p100))
        (npfields (length pfields)))
    (if (not (= n_args (1+ npfields)))
      (error "~%      Wrong number of pfields    ~%")
      (let* ((pflds (mapcar #'(lambda (x)
                                (make-instance 'm::cs_pfield
                                  :p_num x))
                            (om::arithm-ser 3 (+ 2 n_args) 1)))
             (opcode (apply instrument pflds)))
        (apply #'make-csd (append (list opcode p2 p3)
                                  pfields))))))     

(defun gen2score (gen)
  (om::string+ 
   "f"
   (m::list->string  
    (list (f_num gen) 0 (size gen) (gen_num gen))
    "~D" " ") " "
   (m::list->string 
    (mapcar #'(lambda (x)
                (if (numberp x) 
                    (om::om-round x *decimals*) 
                  (2string x)))
            (args gen))
    "~F" " ")))

(defun eval_score (lista n)
  (mapcar #'(lambda (x)
              (om::string+ (format nil "i~D " n) 
                           (m::list->string x "~F" "  ")))
          (remove-if #'(lambda (y)
                         (member nil y :test #'equalp))
                     (om::mat-trans lista))))

(defun eval_instr (lista n)
  (append
   (list (format nil "instr ~D~%" n))
   (remove-duplicates 
    (mapcar #'cs2string lista)
    :test #'string=
    :from-end 0)
   (list "~%endin~%")))

(defun joinmanystrings (lista)
  (reduce #'om::string+
          (butlast
           (om::flat
            (mapcar #'list 
                    lista 
                    (make-list (length lista) :initial-element "~%"))))))

(defun csdlist2orc (lista)
  (joinmanystrings
   (append
    (remove-duplicates 
     (om::flat
      (mapcar #'(lambda (x)
                  (mapcar #'cs2string (g_var x)))
              lista))
     :test #'string=
     :from-end 0)
    (list "~%~%")
    (om::flat
     (mapcar #'(lambda (x n)
                 (eval_instr (instr x) n))
             lista (om::arithm-ser 1 (length lista) 1))))))
  
(defun csdlist2sco (lista)
  (joinmanystrings
   (append 
    (remove-duplicates
     (om::flat
      (mapcar #'(lambda (x)
                  (mapcar #'gen2score (gens x)))
              lista))
     :test #'string=
     :from-end 0)
    (list "~%~%")
    (om::flat 
     (mapcar #'(lambda (x n)
                 (eval_score (score x) n))
             lista (om::arithm-ser 1 (length lista) 1))))))

(defun header (nchnls sr &optional (kr nil))
  (let* ((kr (if (numberp kr) kr sr))
         (ksmps (/ sr kr)))
    (format nil "sr = ~D~%kr = ~D~%ksmps = ~D~%nchnls = ~D~%~%" sr kr ksmps nchnls)))
   
(setf *sr_menu*
      (list (list "44100" 44100)
            (list "48000" 48000)
            (list "96000" 96000)
            (list "192000" 192000)))

(setf *bd_menu*
      (list (list "16 bit" 16)
            (list "24 bit" 24)
            (list "32 bit" 32)
            (list "64 bit" 64)))

(defun string->file (string pathname)      
  (with-open-file (outstream pathname
                             :direction :output
                             :if-exists :overwrite
                             :if-does-not-exist :create)
    (format outstream string))    
  pathname)

(defun no-extension (pathname &optional (whole-pathname nil))
  "pathname->file-namestring senza l'estensione del file"
  (let* ((stringa 
          (if whole-pathname 
              (namestring pathname)
            (file-namestring pathname)))
         (pos (search "." stringa :from-end 0)))
    (if pos
        (coerce (om::first-n (coerce stringa 'list) pos) 'string)
      stringa)))

(defun only-extension (pathname &optional (whole-pathname nil))
  "pathname->file-namestring senza l'estensione del file"
  (let* ((stringa 
          (if whole-pathname 
              (namestring pathname)
            (file-namestring pathname)))
         (pos (search "." stringa :from-end t)))
    (if pos
        (coerce (nthcdr pos (coerce stringa 'list)) 'string)
      stringa)))

(setf *intermediates* nil)

(defun om::delete-intermediates (lista)
  (mapcar #'om::om-delete-file lista))

(setf om::*svp-path* (when (ignore-errors om::*svp-path*) om::*svp-path*))
(setf *svp?* (ignore-errors (probe-file om::*SVP-PATH*)))

(defun svp-rescale (path newpath &optional (rescale 0.0) (resolution 16))
  (if *svp?*
    (progn
      (om::handle-new-file-exists newpath)
      (om::om-print "==========================")
      (om::om-print "SUPERVP NORMALIZATION")
      (om::om-print "==========================")
      
      (om::om-print (format nil "Input file: ~s" (namestring path)))
      (om::om-print (format nil "Level: ~D dB" rescale))
      (om::om-print (format nil "Resolution: ~D bits" resolution))
      
      (if rescale
          (om::om-cmd-line (format nil "~s -S~S -norm ~D -Osa~D ~S" 
                               (om::om-path2cmdpath om::*svp-path*)
                               (om::om-path2cmdpath path) 
                               (abs rescale)
                               resolution
                               (om::om-path2cmdpath newpath)) ;om::*sys-console*)
                           t nil)
        (om::om-cmd-line (format nil "~s -S~S -Osa~D ~S" 
                             (om::om-path2cmdpath om::*svp-path*)
                             (om::om-path2cmdpath path) 
                             resolution
                             (om::om-path2cmdpath newpath)) ;om::*sys-console*)
                         t nil)
        ))
    (progn 
      (om::om-beep-msg "NORMALIZE: SuperVP not found. Set path in Preferences.")
      nil
      ))
  (or (probe-file newpath)
      (om::om-beep-msg "NORMALIZE: Error in SuperVP processing. No output file created."))
      )

(expt 2 15)

(defmethod orc&sco2synth ((sco pathname) (orc pathname) (outpath pathname) 
                          &optional (rescale nil) (bit-depth 24) (n-threads nil) (display t)) 
  (let* (;(flags "-3 -A -N -g -b8192 -B8192") 
         (threads? (if (integerp n-threads) (format nil " -j~D" n-threads) ""))
         (display? (if display "" " -O null "))
         (flags (om::string+ "-l -Z -A -d -b32768 -B32768" display? threads?)) ;(om::string+ "-f -A -d -b8192 -B8192" display? threads?))
         (tmpout (pathname (om::string+ (no-extension outpath t) "-tmp.aiff")))
         (resolution bit-depth))
    (print "CSOUND SYNTHESIS...")
    (om::om-cmd-line (print (format nil "~s ~A ~s ~s -o ~s" 
                                    (om::om-path2cmdpath *csound-path*)
                                    flags
                                    (om::om-path2cmdpath orc)
                                    (om::om-path2cmdpath sco)
                                    (om::om-path2cmdpath (om::om-namestring tmpout)))) t)
    (cond ((not *svp?*) (om::rename-file tmpout outpath))
          ((or rescale (not (= 64 resolution)))
           (progn
             (print "SOUND RESCALE")
             (svp-rescale
              (pathname (om::om-path2cmdpath (om::om-namestring tmpout)))
              (pathname (om::om-path2cmdpath outpath))
              rescale resolution)
             (om::delete-intermediates (list tmpout))))
          (t (om::rename-file tmpout outpath)))
    (push sco *intermediates*)
    (push orc *intermediates*)
    (om::om-namestring outpath)))

(defun unique-pathname (dir name &optional (ext ""))
  (let ((pathname (make-pathname :directory (pathname-directory dir) :name name :type ext)))
    (loop while (probe-file pathname)
          for i = 1 then (+ i 1) do
          (setf pathname (make-pathname :directory (pathname-directory dir) :name (om::string+ name (format nil "~D" i)) :type ext)))
    pathname))

;;;;;;; il numero di canali viene automaticamente preso dall'opcode "out" ;;;;;;

(defmethod csd->nchans ((item csd))
  (let* ((outopc
          (do ((lista- (reverse (instr item)) (cdr lista-)))
              ((ignore-errors (search "out" (opcode_name (car lista-))))
               (car lista-))))
         (n1 (caddr (assoc (opcode_name outopc) *out_alist* :test #'string=)))
         (n (if n1 n1 (length (args_name outopc)))))
    n))
    
(defmethod csd->nchans ((item list))
  (om::list-max (mapcar #'csd->nchans item)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(setf *default_sf_out_name*
      (list
       "geppo"
       "nonna_abelarda"
       "soldino"
       "tiramolla"
       "lando"
       "metternich"
       "ratzinger"
       "mazinga"
       "gabonzo"
       "marguati"
       "tartaglia"
       "bazinga"
       "ragr"))

(defmethod outfile! ((name string) &optional (extension "aiff"))
  (unique-pathname om::*om-outfiles-folder* name extension))
(defmethod outfile! ((name pathname) &optional (extension "aiff")) name)
(defmethod outfile! ((name null) &optional (extension "aiff"))
  (om::om-choose-new-file-dialog :name (om::string+ (om::nth-random *default_sf_out_name*) "." extension)))

(setf *last_cs_files* nil)

(setf *thread-menu*
      '(("1" nil) ("2" 2) ("4" 4) ("8" 8)))

(setf *display-menu*
      '(("Display CSound Shit" t)
        ("Noooo please" nil))) 

(om::defmethod! csd->synth ((csd list) (name t)
                            &optional (sr 44100) (bd 24) (kr nil) (rescale -0.5) (n-threads nil) (display t))
  :icon 425
  :indoc '("a list of 'csd' classes" "name (a simple string) for .sco .orc and .aiff file (outpath from preferences)"
           "sample rate" "bit depth" "control rate (if nil kr=sr)" "rescale (in dB, avoid 0)" "number of threads"
           "display csound messages")
  :doc "    create a score file, an orchestra file and run csound and supervp"
  :menuins `((2 ,*sr_menu*)
             (3 ,*bd_menu*)
             (6 ,*thread-menu*)
             (7 ,*display-menu*))
  :initvals (list nil (om::nth-random *default_sf_out_name*) 44100 24 nil -0.5 nil t)

  (let* ((head (header (csd->nchans csd) sr kr))
         (orc (om::string+ 
               head
               (csdlist2orc csd)))
         (sco (csdlist2sco csd))
         (orcfile (outfile! name "orc"))
         (scorefile (outfile! name "sco"))
         (aiffile (outfile! name "aiff")))
    (string->file orc orcfile)
    (string->file sco scorefile)
    (setf *last_cs_files* (list orcfile scorefile))
    (orc&sco2synth scorefile orcfile aiffile rescale bd n-threads display)))
    
(om::defmethod! csd->synth ((csd csd) (name t)
                            &optional (sr 44100) (bd 24) (kr nil) (rescale -0.5) (n-threads nil) (display t))
  (csd->synth (list csd) name sr bd kr rescale n-threads display))

(defun open_last_orc_and_sco ()
  (mapcar #'(lambda (x)
              (om::om-shell (format nil "open -e ~S" (namestring x))))
          *last_cs_files*))

(om::defmethod! open-textfiles ()
  :icon 425
  :doc "open the last created orchestra and score files"
  (open_last_orc_and_sco))

(om::defmethod! open-soundfile ((item t) &optional (app nil))
  :icon 425
  :doc "open a soundfile"
  :menuins '((1 (("Peak Pro 5.2" "Peak Pro 5.2")
                 ("AudioSculpt" "AudioSculpt")
                 ("iTunes" "iTunes")
                 ("Sample Manager" "Sample Manager")
                 ("VLC" "VLC")
                 ("Default Audio Application" nil))))
  
  (let ((sname (namestring (sound-name item))))
    (if (stringp app)
        (om::om-shell (format nil "open -a ~S ~S" app sname))
      (om::om-shell (format nil "open ~S" sname)))))

(om::defmethod! open-soundfile ((item list) &optional (app nil))
  (mapcar #'(lambda (x) (open-soundfile x app)) item))


;;;;;;;;;;;;;;;;;;;;;;;;;; apertura automatica pagina del menu ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


(setf *cs_man_path_mac* 
      (namestring 
       (make-pathname :directory 
                      '(:absolute "Library" "Frameworks" "CsoundLib64.framework" "Versions" "Current" "Resources" "Manual"))))

(setf *cs_udo_path* (namestring *OM4CSOUND-UDOs-pathname*))

(defun get_info (string)
  (let ((path1 (om::string+ *cs_man_path_mac* string ".html"))
        (path2 (om::string+ *cs_udo_path* string ".html")))
    (cond ((probe-file path1)
           (om::om-shell
            (format nil "open ~S" path1)))
          ((probe-file path2)
           (om::om-shell
            (format nil "open ~S" path2)))
          (t nil))))

(defun cs_man ()
  (get_info "index"))

(setf *cs_help_menu*
      (mapcar #'(lambda (x)
                  (make-list 
                   2 :initial-element
                   (coerce (butlast (coerce (file-namestring x) 'list) 5) 'string)))   
              (append
               (directory 
                (om::string+ (namestring *cs_man_path_mac*) "*.html") 
                :directories nil)
               (directory 
                (om::string+ (namestring *cs_udo_path*) "*.html") 
                :directories nil))))

(om::defmethod! cs_help ((opcode_name string))
  :icon 425
  :indoc '("name of an opcode")
  :doc "    open the html csound help manual"
  :menuins `((0 ,*cs_help_menu*))
  :initvals '("index")
  
  (get_info opcode_name))

(om::defmethod! cs_help ((opcode_name om::omgenericfunction))
  (get_info 
   (if 
     (search "_" (om::name opcode_name))
     (coerce (cddr (coerce (om::name opcode_name) 'list)) 'string)
     (om::name opcode_name))))

(om::defmethod! cs_help ((opcode_name cs_opcode))
  (get_info 
   (opcode_name opcode_name)))

(om::defmethod! cs_help ((opcode_name cs_simple_operator))
  (get_info 
   (operator opcode_name)))

(om::defmethod! cs_help ((opcode_name cs_gen))
  (get_info 
   (format nil "GEN~2,'0D" (gen_num opcode_name))))

(om::defmethod! cs_help ((opcode_name symbol))
  (let* ((stringa (format nil "~D" opcode_name))
         (pos (search "_" stringa))
         (stringa2 (if (ignore-errors (/= pos 1)) stringa 
                     (coerce (nthcdr 2 (coerce stringa 'list)) 'string))))
    (get_info stringa2)))


(defmethod om-show-reference-doc-old ((symbol symbol) &optional dir)
  (let ((file (make-pathname :directory (pathname-directory (or dir om::*om-reference-dir*))
                             :name (om::special-path-check (string-downcase (string symbol)))
                             :type "html")))
    (if (probe-file file)
        ;(om-shell (concatenate 'string "open " (namestring file)))
      (sys:open-url (namestring file))
      (om::om-show-documentation symbol))))

(defmethod om::om-show-reference-doc ((symbol symbol) &optional dir)
  (let* ((test (eql (symbol-package symbol)
                    (symbol-package 'm::cs_help)))
         (cs? (if test (cs_help symbol)
                (om-show-reference-doc-old symbol dir))))
    (when (null cs?) (om-show-reference-doc-old symbol dir))))

;;;;;;;

(setf *math_op_menu*
      (mapcar #'(lambda (x)
                  (list x x))
              (list
               "abs" "ceil" "exp" "floor" "frac" "int" "log" "log10" "logbtwo" "powoftwo" "round" 
               "sqrt" "cos" "cosh" "cosinv" "sin" "sinh" "sininv" "tan" "tanh" "taninv" "ampdb" 
               "ampdbfs" "dbamp" "db" "dbfsamp" "0dbfs" "birnd" "rnd")))

(om::defmethod! cs_math_operation ((operation string) (self cs))
  :icon 425
  :indoc '("operation" "item to process")
  :doc "    perform a math operation on a cs item"
  :menuins `((0 ,*math_op_menu*))
  :initvals '("tanh" nil)
  
  (make_cs_simple_operator operation (list self)))

(om::defmethod! cs_math_operation ((operation string) (self list))
  (mapcar #'(lambda (x) (cs_math_operation operation x)) self))

(om::defmethod! cs_math_operation ((operation string) (self t))
   (make_cs_simple_operator operation (list (2math_op self))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; opcodes che danno origine ad un numero variabile di variabili ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defmethod get_n_channels ((item om::m_snd))
  (om::nchan item))

(defmethod get_n_channels ((item t))
  (ignore-errors (get_n_channels (inputsndfile item))))

(defmethod get_n_channels ((item cs_gen))
  (if (= 1 (gen_num item))
      (get_n_channels (car (args item)))
    1))

(defmethod get_dim ((item cs_gen))
  (get_n_channels item))

(defmethod get_n_channels ((item cs_class))
  (get_dim item))

(defmethod get_n_channels ((item cs_class))
  (get_dim item))

(defmethod get_n_channels ((item cs_pfield))
  (dimension item))

(om::defmethod! a_loscil 
  ((xamp t) (kcps t) (ifn t) &optional (ibas nil) (imod1 nil) (ibeg1 nil) (iend1 nil) (imod2 nil) (ibeg2 nil) (iend2 nil) (n_var 1))
  :icon 221
  :doc "loscil - Read sampled sound from a table"
  :initvals '(1 1 1)
  (let* ((n1 (get_n_channels ifn))
         (n (if n1 n1 n_var)))
    (progn
      (when (> n 2)
        (format t "~%     non sono sicuro che loscil funzioni con file a + di 2 canali ...~%"))
      (make-instance 'cs_opcode
        :var_name (args->varname (append (make-list n :initial-element "a") (list "loscil")) n)
        :opcode_name "loscil"
        :args_name '("xamp" "kcps" "ifn" "ibas" "imod1" "ibeg1" "iend1" "imod2" "ibeg2" "iend2")
        :args (removenilfromend (list xamp kcps ifn ibas imod1 ibeg1 iend1 imod2 ibeg2 iend2))))))

(om::defmethod! a_loscil3
  ((xamp t) (kcps t) (ifn t) &optional (ibas nil) (imod1 nil) (ibeg1 nil) (iend1 nil) (imod2 nil) (ibeg2 nil) (iend2 nil) (n_var 1))
  :icon 221
  :doc "loscil3 - Read sampled sound from a table using cubic interpolation"
  :initvals '(1 1 1)
  (let* ((n1 (get_n_channels ifn))
         (n (if n1 n1 n_var)))
    (progn
      (when (> n 2)
        (format t "~%     non sono sicuro che loscil3 funzioni con file a + di 2 canali ...~%"))
      (make-instance 'cs_opcode
        :var_name (args->varname (append (make-list n :initial-element "a") (list "loscil3")) n)
        :opcode_name "loscil3"
        :args_name '("xamp" "kcps" "ifn" "ibas" "imod1" "ibeg1" "iend1" "imod2" "ibeg2" "iend2")
        :args (removenilfromend (list xamp kcps ifn ibas imod1 ibeg1 iend1 imod2 ibeg2 iend2))))))

(om::defmethod! a_loscilx
  ((xamp t) (kcps t) (ifn t)
   &optional (iwsize nil) (ibas nil) (istrt nil) (imod1 nil) (ibeg1 nil) (iend1 nil))
  :icon 221
  :doc "loscilx - Loop oscillator"
  :initvals '(1 1 1)
  (let ((n (get_n_channels ifn)))
    (progn
      (when (> n 16)
        (format t "~%     non sono sicuro che loscilx funzioni con forme d'onda a + di 16 canali ...~%"))
      (make-instance 'cs_opcode
        :var_name (args->varname (append (make-list n :initial-element "a") (list "loscilx")) n)
        :opcode_name "loscilx"
        :args_name '("xamp" "kcps" "ifn" "iwsize" "ibas" "istrt" "imod1" "ibeg1" "iend1")
        :args (removenilfromend (list xamp kcps ifn iwsize ibas istrt imod1 ibeg1 iend1))))))

(om::defmethod! a_soundin
  ((ifilcod t) &optional (iskptim nil) (iformat nil) (iskipinit nil) (ibufsize nil))
  :icon 221
  :doc "soundin - Reads audio data from an external device or stream"
  :initvals '(1)
  (let ((n (get_n_channels ifilcod)))
    (if n
      (progn
        (when (> n 24)
          (format t "~%     non sono sicuro che soundin funzioni con file a + di 24 canali ...~%"))
        (make-instance 'cs_opcode
          :var_name (args->varname (append (make-list n :initial-element "a") (list "soundin")) n)
          :opcode_name "soundin"
          :args_name '("ifilcod" "iskiptim" "iformat" "iskipinit" "ibufsize")
          :args (removenilfromend (list ifilcod iskiptim iformat iskipinit ibufsize))))
      (error "~%    ifilcod must be a soundfile"))))

(om::defmethod! a_diskin
  ((ifilcod t) (kpitch t) &optional (iskiptim nil) (iwraparound nil) (iformat nil) (iskipinit nil))
  :icon 221
  :doc "diskin - Reads audio data from an external device or stream and can alter its pitch"
  :initvals '(1 1)
  (let ((n (get_n_channels ifilcod)))
    (if n
      (progn
        (when (> n 24)
          (format t "~%     non sono sicuro che diskin funzioni con file a + di 24 canali ...~%"))
        (make-instance 'cs_opcode
          :var_name (args->varname (append (make-list n :initial-element "a") (list "diskin")) n)
          :opcode_name "diskin"
          :args_name '("ifilcod" "kpitch" "iskiptim" "iwraparound" "iformat" "iskipinit")
          :args (removenilfromend (list ifilcod kpitch iskiptim iwraparound iformat iskipinit))))
      (error "~%    ifilcod must be a soundfile"))))

(om::defmethod! a_diskin2
  ((ifilcod t) (kpitch t) &optional (iskiptim nil) (iwrap nil) (iformat nil) (iwsize nil) (ibufsize nil) (iskipinit nil))
  :icon 221
  :doc "diskin2 - Reads audio data from a file, and can alter its pitch using one of several available interpolation types, 
as well as convert the sample rate to match the orchestra sr setting"
  :initvals '(1 1)
  (let ((n (get_n_channels ifilcod)))
    (if n
      (progn
        (when (> n 24)
          (format t "~%     non sono sicuro che diskin2 funzioni con file a + di 24 canali ...~%"))
        (make-instance 'cs_opcode
          :var_name (args->varname (append (make-list n :initial-element "a") (list "diskin2")) n)
          :opcode_name "diskin2"
          :args_name '("ifilcod" "kpitch" "iskiptim" "iwrap" "iformat" "iwsize" "ibufsize" "iskipinit")
          :args (removenilfromend (list ifilcod kpitch iskiptim iwrap iformat iwsize ibufsize iskipinit))))
      (error "~%    ifilcod must be a soundfile"))))

(om::defmethod! a_partikkel
                ((agrainfreq t) (kdistribution t) (idisttab t) (async t) (kenv2amt t) (ienv2tab t) (ienv_attack t)
                 (ienv_decay t) (ksustain_amount t) (ka_d_ratio t) (kduration t) (kamp t) (igainmasks t)
                 (kwavfreq t) (ksweepshape t) (iwavfreqstarttab t) (iwavfreqendtab t) (awavfm t)
                 (ifmamptab t) (kfmenv t) (icosine t) (ktraincps t) (knumpartials t) (kchroma t)
                 (ichannelmasks t) (krandommask t) (kwaveform1 t) (kwaveform2 t) (kwaveform3 t)
                 (kwaveform4 t) (iwaveamptab t) (asamplepos1 t) (asamplepos2 t) (asamplepos3 t)
                 (asamplepos4 t) (kwavekey1 t) (kwavekey2 t) (kwavekey3 t) (kwavekey4 t) (imax_grains t) &optional (iopcode_id nil))
  :icon 221
  :doc "partikkel - Granular synthesizer with \"per grain\" control over many of its parameters. 
Has a sync input to sychronize its internal grain scheduler clock to an external clock source"
  :initvals (make-list 40 :initial-element 1)
  (let ((n (get_n_channels ichannelmasks)))
    (progn
      (when (> n 8)
        (format t "~%     non sono sicuro che partikkel funzioni con forme d'onda a + di 8 canali ...~%"))
      (make-instance 'cs_opcode
        :var_name (args->varname (append (make-list n :initial-element "a") (list "partikkel")) n)
        :opcode_name "partikkel"
        :args_name 
        '("agrainfreq" "kdistribution" "idisttab" "async" "kenv2amt" "ienv2tab" "ienv_attack" "ienv_decay" "ksustain_amount" "ka_d_ratio" "kduration" "kamp" 
          "igainmasks" "kwavfreq" "ksweepshape" "iwavfreqstarttab" "iwavfreqendtab" "awavfm" "ifmamptab" "kfmenv" "icosine" "ktraincps" "knumpartials" "kchroma" 
          "ichannelmasks" "krandommask" "kwaveform1" "kwaveform2" "kwaveform3" "kwaveform4" "iwaveamptab" "asamplepos1" "asamplepos2" "asamplepos3" "asamplepos4" 
          "kwavekey1" "kwavekey2" "kwavekey3" "kwavekey4" "imax_grains" "iopcode_id")
        :args (removenilfromend 
               (list
                agrainfreq kdistribution idisttab async kenv2amt ienv2tab ienv_attack 
                ienv_decay ksustain_amount ka_d_ratio kduration kamp igainmasks 
                kwavfreq ksweepshape iwavfreqstarttab iwavfreqendtab awavfm 
                ifmamptab kfmenv icosine ktraincps knumpartials kchroma 
                ichannelmasks krandommask kwaveform1 kwaveform2 kwaveform3 
                kwaveform4 iwaveamptab asamplepos1 asamplepos2 asamplepos3 
                asamplepos4 kwavekey1 kwavekey2 kwavekey3 kwavekey4 imax_grains 
                iopcode_id))))))

(om::defmethod! a_convolve ((ain t) (ifilcod t) &optional (ichannel nil) (n_var nil))
  :icon 221
  :doc "
convolve - Convolves a signal and an impulse response
Output is the convolution of signal ain and the impulse response contained in ifilcod. If more than one output signal is supplied, each will be convolved with the same impulse response.
Ifilcod can be a sound (in that case 'cvanal' is called) or the result of 'cvanal' (in that case you need to specify 'n_var' in order to get the right number of variables)"
  :initvals '(1 1)

  (let* ((snd (ignore-errors (inputsndfile ifilcod)))
         (n0 (cond (snd (get_n_channels snd))
                   ((integerp n_var) n_var)
                   (t 1)))
         (n (if (and (integerp ichannel) (<= ichannel n0))
                ichannel n0))
         (anal (if snd
                   (cvanal snd 
                           (om::string+ (no-extension (sound-name snd)) "-cv"))
                 ifilcod)))
    (progn
      (when (> n 4)
        (format t "~%     non sono sicuro che convolve funzioni con file a + di 4 canali ...~%"))
      (make-instance 'cs_opcode
                     :var_name (args->varname (append (make-list n :initial-element "a") (list "convolve")) n)
                     :opcode_name "convolve"
                     :args_name '("ain" "ifilcod" "ichannel")
                     :args 
                     (removenilfromend 
                      (list ain anal ichannel))))))

(om::defmethod! a_pconvolve
  ((ain t) (ifilcod t) &optional (ipartitionsize nil) (ichannel nil))
  :icon 221
  :doc "
pconvolve - Convolution based on a uniformly partitioned overlap-save algorithm

Convolution based on a uniformly partitioned overlap-save algorithm. Compared to the convolve opcode, 'pconvolve' has these benefits:

 1) small delay
 2) possible to run in real-time for shorter impulse files
 3) no pre-process analysis pass
 4) can often render faster than convolve"

  :initvals '(1 1)
  :menuins `((2 ,*size_menu*))

  (let* ((snd ifilcod)
         (n0 (get_n_channels snd))
         (n (if (and (integerp ichannel) (<= ichannel n0))
                ichannel n0)))
    (progn
      (when (> n 4)
        (format t "~%     non sono sicuro che pconvolve funzioni con file a + di 4 canali ...~%"))
      (make-instance 'cs_opcode
                     :var_name (args->varname (append (make-list n :initial-element "a") (list "pconvolve")) n)
                     :opcode_name "pconvolve"
                     :args_name '("ain" "ifilcod" "ipartitionsize" "ichannel")
                     :args (removenilfromend (list ain ifilcod ipartitionsize ichannel))))))

(om::defmethod! a_ftconv
  ((ain t) (ift t) (iplen integer) &optional (iskipsamples nil) (iirlen nil) (iskipinit nil))
  :icon 221
  :doc "
ftconv - Low latency multichannel convolution, using a function table as impulse response source

Low latency multichannel convolution, using a function table as impulse response source. The algorithm is to split the impulse response to partitions of length determined by the 'iplen' parameter, and delay and mix partitions so that the original, full length impulse response is reconstructed without gaps. The output delay (latency) is 'iplen' samples, and does not depend on the control rate, unlike in the case of other convolve opcodes"

  :initvals '(1 1)
  :menuins `((2 ,*size_menu*))

  (let ((n (get_n_channels ift)))
    (progn
      (when (> n 8)
        (format t "~%     non sono sicuro che ftconv funzioni con file a + di 8 canali ...~%"))
      (make-instance 'cs_opcode
                     :var_name (args->varname (append (make-list n :initial-element "a") (list "ftconv")) n)
                     :opcode_name "ftconv"
                     :args_name '("ain" "ift" "iplen" "iskipsamples" "iirlen" "iskipinit")
                     :args (removenilfromend (list ain ift iplen iskipsamples iirlen iskipinit))))))

;;;;;;; panning & spat

(setf 
 *Panning_&_Spat*
 (mapcar #'list
         (list
          "ar1, ar2, ar3, ar4, ar5, ar6, ar7, ar8, ar9, ar10, ar11, ar12, ar13, ar14, ar15, ar16 vbap16 asig, iazim [, ielev] [, ispread]"
          "ar1, ar2, ar3, ar4, ar5, ar6, ar7, ar8, ar9, ar10, ar11, ar12, ar13, ar14, ar15, ar16 vbap16move asig, idur, ispread, ifldnum, ifld1 [, ifld2] [...]"
          "ar1, ar2, ar3, ar4, ar5, ar6, ar7, ar8 vbap8 asig, iazim [, ielev] [, ispread]"
          "ar1, ar2, ar3, ar4, ar5, ar6, ar7, ar8 vbap8move asig, idur, ispread, ifldnum, ifld1 [, ifld2] [...]"
          "ar1, ar2, ar3, ar4 vbap4 asig, iazim [, ielev] [, ispread]"
          "ar1, ar2, ar3, ar4 vbap4move asig, idur, ispread, ifldnum, ifld1 [, ifld2] [...]"
          "vbaplsinit idim, ilsnum [, idir1] [, idir2] [...]"
          "a1, a2, a3, a4 pan asig, kx, ky, ifn [, imode] [, ioffset]"
          "k1 spdist ifn, ktime, kx, ky"
          "aW, aX, aY, aZ spat3d ain, kX, kY, kZ, idist, ift, imode, imdel, iovr [, istor]"
          "aW, aX, aY, aZ spat3di ain, iX, iY, iZ, idist, ift, imode [, istor]"
          "spat3dt ioutft, iX, iY, iZ, idist, ift, imode, irlen [, iftnocl]"
          "a1, a2, a3, a4  space asig, ifn, ktime, kreverbsend, kx, ky"
          "a1, a2 pan2 asig, xp [, imode]" )
         (list
          "vbap16 - Distributes an audio signal among 16 channels"
          "vbap16move - Distribute an audio signal among 16 channels with moving virtual sources"
          "vbap8 - Distributes an audio signal among 8 channels"
          "vbap8move - Distributes an audio signal among 8 channels with moving virtual sources"
          "vbap4 - Distributes an audio signal among 4 channels"
          "vbap4move - Distributes an audio signal among 4 channels with moving virtual sources"
          "vbaplsinit - Configures VBAP output according to loudspeaker parameters"
          "pan - Distribute an audio signal amongst four channels"
          "spdist - Calculates distance values from xy coordinates"
          "spat3d - Positions the input sound in a 3D space and allows moving the sound at k-rate"
          "spat3di - Positions the input sound in a 3D space with the sound source position set at i-time"
          "spat3dt - Can be used to render an impulse response for a 3D space at i-time"
          "space - Distributes an input signal among 4 channels using cartesian coordinates"
          "pan2 - Distribute an audio signal across two channels" )))

;;;;;;;;; manca : locsend, locsig, space, spsend, e tutto ci che  binaurale e ambisonics


(setf *Panning_&_Spat_menu* nil)
(csman2om *Panning_&_Spat* '*Panning_&_Spat_menu*)


;========================================= VBAP =========================================;


(setf *vbap_alist*
      '((4 a_vbap4 a_vbap4move)
        (8 a_vbap8 a_vbap8move)
        (16 a_vbap16 a_vbap16move)))

(defmethod 2vbap ((asig cs) (n_chan integer) (azimut t) (elevation t) (spread t) &optional (bpf_krate nil))
  (let ((fun (cadr (assoc n_chan *vbap_alist*))))
    (if fun
        (eval
         `(,fun ,asig ,azimut ,elevation ,spread))
      (make-instance 'cs_opcode
                     :var_name (args->varname (append (make-list n_chan :initial-element "a") (list "vbap")) n_chan)
                     :opcode_name "vbap"
                     :args_name '("asig" "kazim" "kelev" "kspread" "ilayout")
                     :args (removenilfromend (list asig azimut elevation spread))))))

(defmethod 2vbap ((asig cs) (n_chan integer) (azimut t) (elevation null) (spread t) &optional (bpf_krate nil))
  (2vbap asig n_chan azimut 0 spread bpf_krate))

(defmethod 2vbap ((asig cs) (n_chan integer) (azimut list) (elevation null) (spread t) &optional (bpf_krate nil))
  (let ((fun (caddr (assoc n_chan *vbap_alist*)))
        (idur *p3*)
        (ifldnum (length azimut)))
    (eval
     (append
      `(,fun ,asig ,idur ,spread ,ifldnum)
      azimut))))

(defmethod 2vbap ((asig cs_class) (n_chan integer) (azimut om::bpf) (elevation null) (spread t) &optional (bpf_krate nil))
  (let ((az (om::y-points 
             (if bpf_krate 
               (bpf-resample azimut bpf_krate) 
               azimut))))
    (2vbap asig n_chan az elevation spread bpf_krate)))
    
(defmethod 2vbap ((asig cs) (n_chan integer) (azimut list) (elevation t) (spread t) &optional (bpf_krate nil))
  (let ((fun (caddr (assoc n_chan *vbap_alist*)))
        (idur *p3*)
        (ifldnum (length azimut))
        (lista (om::flat (mapcar #'(lambda (x) (list x elevation)) azimut)))) 
    (eval
     (append
      `(,fun ,asig ,idur ,spread ,ifldnum)
      lista))))

(defmethod 2vbap ((asig cs) (n_chan integer) (azimut om::bpf) (elevation t) (spread number) &optional (bpf_krate nil))
  (let ((az (om::y-points 
             (if bpf_krate 
               (bpf-resample azimut bpf_krate) 
               azimut))))
    (2vbap asig n_chan az elevation spread bpf_krate)))
    
(defmethod 2vbap ((asig cs) (n_chan integer) (azimut list) (elevation list) (spread t) &optional (bpf_krate nil))
  (let* ((fun (caddr (assoc n_chan *vbap_alist*)))
         (idur *p3*)
         (ifldnum (om::list-max (list (length azimut) (length elevation))))
         (az (check-length azimut ifldnum))
         (elev (check-length elevation ifldnum))
         (lista (om::flat (mapcar #'list az elev))))
    (eval
     (append
      `(,fun ,asig ,idur ,spread ,ifldnum)
      lista))))

(defmethod 2vbap ((asig cs) (n_chan integer) (azimut om::bpf) (elevation om::bpf) (spread t) &optional (bpf_krate nil))
  (let ((az (om::y-points (if bpf_krate (bpf-resample azimut bpf_krate) azimut)))
        (elev (om::y-points (if bpf_krate (bpf-resample elevation bpf_krate) elevation))))
    (2vbap asig n_chan az elev spread bpf_krate)))

(defmethod 2vbap ((asig cs) (n_chan integer) (azimut t) (elevation list) (spread t) &optional (bpf_krate nil))
  (let ((fun (caddr (assoc n_chan *vbap_alist*)))
        (idur *p3*)
        (ifldnum (length elevation))
        (lista (om::flat (mapcar #'(lambda (x) (list azimut x)) elevation)))) 
    (eval
     (append
      `(,fun ,asig ,idur ,spread ,ifldnum)
      lista))))

(defmethod 2vbap ((asig cs) (n_chan integer) (azimut t) (elevation om::bpf) (spread t) &optional (bpf_krate nil))
  (let ((elev (om::y-points 
               (if bpf_krate 
                 (bpf-resample elevation bpf_krate) 
                 elevation))))
    (2vbap asig n_chan azimut elev spread bpf_krate)))

(om::defmethod! vbap ((init list) (asig cs) (spread t) (azimut t) &optional (elevation nil) (bpf_krate nil))
  
  :initvals '((list 2 4 0 90 180 270) nil 20 0 nil nil)
  :indoc '("args for vbaplsinit (idim, ilsnum, etc ...)"
           "a signal" "spread" "azimut (number or bpf)" "elevation, if idim=3 (number or bpf)" 
           "control rate for bpfs")
  :menuins '((0 (("2D 4ch circle"  '(2 4 0 90 180 270)) 
                 ("2D 4ch front narrow"  '(2 4 -60 -20 20 60))
                 ("2D 4ch front wide"  '(2 4 -90 -30 30 90))
                 ("2D 5ch front"  '(2 5 -90 -45 0 45 90))
                 ("2D 8ch circle"  '(2 8 0 45 90 135 180 225 270 315))
                 ("2D 16ch circle"  '(2 16 0 22 45 67 90 112 135 157 180 202 225 247 270 292 315 337)))))
  
  :icon 606 
  :numouts 2
  :doc "      a high-level control for the VBAP family opcodes. In case of mouvements 'idur=p3"
  
  (om::values 
   (apply #'vbaplsinit init)
   (2vbap asig (cadr init) azimut elevation spread bpf_krate)))

(setf *Panning_&_Spat_menu*
      (list (car *Panning_&_Spat_menu*)
            nil nil
            (cons 'vbap
                  (cadddr *Panning_&_Spat_menu*))
            nil))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(om::defmethod* om::objFromObjs ((self cs_gen) (type om::bpf))
  (when (= 7 (abs (gen_num self)))
    (let* ((puppa (om::list-modulo (args self) 2))
           (xp (om::dx->x 0 (cadr puppa)))
           (yp (car puppa))
           (bpf (make-instance 'om::bpf
                  :decimals 10)))
      (progn
        (setf (om::x-points bpf) xp)
        (setf (om::y-points bpf) yp)
        bpf))))

(om::defmethod* om::objFromObjs ((self om::bpf) (type cs_gen))
  (table 7 self *def-table-size* -1))

;;;;;;;;;;;;;;; PREDICATES ;;;;;;;;;;;;;;;;

(om::defclass! cs_predicate (cs)
  ((predicate :type string :initform ">" :accessor predicate :initarg
:predicate)
   (arg0 :type t :initform nil :accessor arg0 :initarg :arg0)
   (arg1 :type t :initform nil :accessor arg1 :initarg :arg1))
  (:icon 606))

(defmethod cs2string ((item cs_predicate)) "")
(defmethod 2string ((item cs_predicate)) "")
(defmethod init_class_p ((item cs_predicate)) nil)
(defmethod class2explode_p ((class cs_predicate)) t)
(defmethod get_nested_cs_classes ((item cs_predicate))
  (remove-if-not
   #'class2explode_p
   (list (arg0 item) (arg1 item))))

(defmethod make_cs_predicate ((predicate string)
                              (arg0 t) (arg1 t))
  (make-instance 'cs_predicate
      :predicate predicate
      :arg0 arg0
      :arg1 arg1))

(om::defclass! cs_conditional (cs_class)
  ((testp :type cs_predicate :initform nil :accessor testp :initarg :testp))
  (:icon 606))

(defmethod get_dim ((item cs_conditional)) 1)

(defmethod cs2string ((item cs_conditional))
  (om::string+
   (car (var_name item))
   " = ("
   (2string (arg0 (testp item))) " "
   (predicate (testp item)) " "
   (2string (arg1 (testp item))) " ? "
   (2string (car (args item))) " : "
   (2string (cadr (args item))) ")"))

(defmethod get_nested_cs_classes ((item cs_conditional))
  (remove-if-not
   #'class2explode_p
   (cons (testp item) (args item))))

(defmethod make_cs_conditional ((testp cs_predicate)
                                (arg0 t) (arg1 t))
    (make-instance 'cs_conditional
      :testp testp
      :var_name (make_variable_name 1 (vartypestrng (list arg0 arg1)))
      :args (list arg0 arg1)))

(defun simple_predicates_method (omstring cstring)
  (let ((operatore (read-from-string (om::string+ "om::om" omstring))))
    (eval
     `(om::defmethod* ,operatore ((self cs) (num t))
        (make_cs_predicate ,cstring self num)))
    (eval
     `(om::defmethod* ,operatore ((self cs) (num cs))
        (make_cs_predicate ,cstring self num)))
    (eval
     `(om::defmethod* ,operatore ((self t) (num cs))
        (make_cs_predicate ,cstring self num)))))

(mapcar #'(lambda (x y)
            (simple_predicates_method x y))
        '(">" "<" ">=" "<=" "/=")
        '(">" "<" ">=" "<=" "!="))

(om::defmethod* om::om= ((self cs) (num t) &optional (test-predicate '=)) 
  (make_cs_predicate "==" self num))

(om::defmethod! csif ((test cs_predicate) (action t) (else t))
  :icon 180
  :doc "
works like omif but \"else\" is not optional ... 
test is the output of one of the following predicates :
\"om=\", \"om>\", \"om>=\", \"om<\", \"om<=\", \"om/=\" "

  (make_cs_conditional test action else))

;;;;;;;;;;;;;;;;;;; FT info ;;;;;;;;;;;;;;;;;;;

(setf *gen_nfo_menu*
      (mapcar #'(lambda (x)
                  (list x x))
              (list
               "ftchnls" "ftlen" "ftlptim" "ftsr" "nsamp")))

(om::defmethod! cs_gen_info ((operation string) (self cs_gen))
  :icon 425
  :indoc '("operation" "function table")
  :doc "get info from a function table"
  :menuins `((0 ,*gen_nfo_menu*))
  :initvals '("ftchnls" nil)
  
  (make-instance 'cs_simple_operator
      :var_name (make_variable_name 1 "i")
      :operator operation
      :args (list self)))

(om::defmethod! cs_gen_info ((operation string) (self cs_pfield))
  (make-instance 'cs_simple_operator
      :var_name (make_variable_name 1 "i")
      :operator operation
      :args (list self)))

(setf *change_rate_menu*
      (mapcar #'(lambda (x)
                  (list x x))
              (list "a" "k" "i")))

(om::defmethod! cs_change_rate ((rate string) (self t))
  :icon 425
  :indoc '("rate" "item to process")
  :doc "change the rate of an opcode"
  :menuins `((0 ,*change_rate_menu*))
  :initvals '("a" nil)
  
  (make-instance 'cs_simple_operator
                 :var_name (make_variable_name 1 rate)
                 :operator rate
                 :args (list self)))

;;;;;;; easy-bpf

(om::defmethod! easy-bpf ((lista list) 
                          &optional 
                          (krate (eval *krate*)))
                                  
                :icon 277
                :initvals '((list (list 0.0 0.0)
                                  (list 1.0 0.0)
                                  (list 2.3 0.6 0.618)
                                  (list 3.1 1.0 2.0)
                                  (list 5.5 1.0)
                                  (list 6.6 0.0)) 0.05)

  (let ((lista (mapcar #'(lambda (x)
                           (cons (* krate (om::om-round (/ (car x) krate)))
                                 (cdr x)))
                       lista)))
    (defun 1nt3rp-2lst (lista1 lista2 kr)
      (if (or (= (cadr lista1)
                 (cadr lista2))
              (null (caddr lista2))
              (zerop (caddr lista2)))
        (list (om::first-n lista1 2)
              (om::first-n lista2 2))
        (let* ((times
                (om::arithm-ser (car lista1) (car lista2) kr))
               (vals (om::interpolation (cadr lista1) 
                                        (cadr lista2) 
                                        (length times) 
                                        (caddr lista2))))
          (mapcar #'list times vals))))
    (let*
      ((listona
        (mapcar #'(lambda (x y)
                    (1nt3rp-2lst x y krate))
                lista
                (cdr lista)))
       (listona2
        (cons (car listona)
              (mapcar #'cdr (cdr listona))))
       (listona3 (om::flat listona2 1))
       (listona4 (if (zerop (caar listona3)) 
                   listona3 
                   (cons (list 0.0 (cadar listona3)) listona3)))
       (bpf (make-instance 'om::bpf
                      :decimals 5)))
      (progn
        (setf 
         (om::x-points bpf) (mapcar #'car listona4))
        (setf 
         (om::y-points bpf) (mapcar #'cadr listona4))
        bpf))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(om::defmethod! round2closerpowof2 ((n number) &optional (fun #'round))
  :icon 425
  :doc "round to the closer power of 2, works with cs_gen too"
  :menuins '((1 (("round" #'round)
                 ("floor" #'floor)
                 ("ceiling" #'ceiling))))
  (expt 2 (funcall fun (log n 2))))

(om::defmethod! round2closerpowof2 ((n om::sound) &optional (fun #'round))
  (round2closerpowof2 (om::om-sound-n-samples n) fun))

(om::defmethod! round2closerpowof2 ((n cs_gen) &optional (fun #'round))
  (let ((newgen (om::clone n)))
    (progn
      (setf (size newgen) (round2closerpowof2 (size n) fun))
      newgen)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(om::defmethod! read-table ((gen cs) (rate t) (time t))
  :icon 425
  :indoc '("a table or a bpf" "rate of reading" "time of reading") 
  :doc "linear reader of a table (combination of the opcodes 'line and 'table)"
  :menuins '((1 (("control" nil)
                 ("audio" t))))
    (if rate
        (a_table 
         (a_line 0 time 1)
         gen 1)
      (k_table 
       (k_line 0 time 1)
       gen 1)))

(om::defmethod! read-table ((gen t) (rate t) (time t))
  (let ((gen (om::objfromobjs gen (make-instance 'cs_gen))))
    (read-table gen rate time)))
  
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defmethod open_sound ((item om::m_snd))
  (om::om-shell 
   (format nil "open ~S" (namestring (om::path item)))))

(defmethod open_sound ((item t))
  (open_sound (inputsndfile item)))