(in-package "OM-AURO")

;;;;;;;; Signal Generators

(setf 
 *Additive*
 (mapcar #'list
         (list
          "ares adsyn kamod, kfmod, ksmod, ifilcod"
          "ares adsynt kamp, kcps, iwfn, ifreqfn, iampfn, icnt [, iphs]"
          "ar adsynt2 kamp, kcps, iwfn, ifreqfn, iampfn, icnt [, iphs]"
          "ares hsboscil kamp, ktone, kbrite, ibasfreq, iwfn, ioctfn [, ioctcnt] [, iphs]")
         (list
          "adsyn - Output is an additive set of individually controlled sinusoids, using an oscillator bank"
          "adsynt - Performs additive synthesis with an arbitrary number of partials, not necessarily harmonic"
          "adsynt2 - Performs additive synthesis with an arbitrary number of partials -not necessarily harmonic- with interpolation"
          "hsboscil - An oscillator which takes tonality and brightness as arguments")))

(setf *Additive_menu* nil)
(csman2om *Additive* '*Additive_menu*)

(setf 
 *basic_oscillators*
 (mapcar #'list
         (list
          "ares oscbnk  kcps, kamd, kfmd, kpmd, iovrlap, iseed, kl1minf, kl1maxf, \
      kl2minf, kl2maxf, ilfomode, keqminf, keqmaxf, keqminl, keqmaxl, \
      keqminq, keqmaxq, ieqmode, kfn [, il1fn] [, il2fn] [, ieqffn]   \
      [, ieqlfn] [, ieqqfn] [, itabl] [, ioutfn]"
          "ares oscil xamp, xcps, ifn [, iphs]"
          "kres oscil kamp, kcps, ifn [, iphs]"
          "ares oscil3 xamp, xcps, ifn [, iphs]"
          "kres oscil3 kamp, kcps, ifn [, iphs]"
          "ares oscili xamp, xcps, ifn [, iphs]"
          "kres oscili kamp, kcps, ifn [, iphs]"
          "ares oscils iamp, icps, iphs [, iflg]"
          "ares poscil xamp, xcps, ifn [, iphs]"
          "ires poscil kamp, kcps, ifn [, iphs]"
          "kres poscil kamp, kcps, ifn [, iphs]"
          "ares poscil3 kamp, kcps, ifn [, iphs]"
          "kres poscil3 kamp, kcps, ifn [, iphs]"
          "ares oscilikt xamp, xcps, kfn [, iphs] [, istor]"
          "kres oscilikt kamp, kcps, kfn [, iphs] [, istor]"
          "ares osciliktp kcps, kfn, kphs [, istor]"
          "ares oscilikts xamp, xcps, kfn, async, kphs [, istor]"
          "ares osciln kamp, ifrq, ifn, itimes"
          "ares oscilx kamp, ifrq, ifn, itimes"
          "kres lfo kamp, kcps [, itype]"
          "ares lfo kamp, kcps [, itype]"
          "kout vibr kAverageAmp, kAverageFreq, ifn"
          "kout vibrato kAverageAmp, kAverageFreq, kRandAmountAmp, \
      kRandAmountFreq, kAmpMinRate, kAmpMaxRate, kcpsMinRate, \
      kcpsMaxRate, ifn [, iphs]")
         (list
          "oscbnk - Mixes the output of any number of oscillators"
          "oscil - A simple oscillator"
          "oscil - A simple oscillator"
          "oscil3 - A simple oscillator with cubic interpolation"
          "oscil3 - A simple oscillator with cubic interpolation"
          "oscili - A simple oscillator with linear interpolation"
          "oscili - A simple oscillator with linear interpolation"
          "oscils - A simple, fast sine oscillator"
          "poscil - High precision oscillator"
          "poscil - High precision oscillator"
          "poscil - High precision oscillator"
          "poscil3 - High precision oscillator with cubic interpolation"
          "poscil3 - High precision oscillator with cubic interpolation"
          "oscilikt - A linearly interpolated oscillator that allows changing the table number at k-rate"
          "oscilikt - A linearly interpolated oscillator that allows changing the table number at k-rate"
          "osciliktp - A linearly interpolated oscillator that allows allows phase modulation"
          "oscilikts - A linearly interpolated oscillator with sync status that allows changing the table number at k-rate"
          "osciln - Accesses table values at a user-defined frequency"
          "oscilx - Same as the osciln opcode"
          "lfo - A low frequency oscillator of various shapes"
          "lfo - A low frequency oscillator of various shapes"
          "vibr - Easier-to-use user-controllable vibrato"
          "vibrato - Generates a natural-sounding user-controllable vibrato")))

(setf *basic_oscillators_menu* nil)
(csman2om *basic_oscillators* '*basic_oscillators_menu*)

(setf 
 *dynamic_oscillators*
 (mapcar #'list
         (list
          "ares buzz xamp, xcps, knh, ifn [, iphs]"
          "ares gbuzz xamp, xcps, knh, klh, kmul, ifn [, iphs]"
          "ares mpulse kamp, kintvl [, ioffset]"
          "ares vco xamp, xcps, iwave, kpw [, ifn] [, imaxd] [, ileak] [, inyx] \
      [, iphs] [, iskip]"
          "ares vco2 kamp, kcps [, imode] [, kpw] [, kphs] [, inyx]"
          "ifn vco2init iwave [, ibasfn] [, ipmul] [, iminsiz] [, imaxsiz] [, isrcft]"
          "kfn vco2ft kcps, iwave [, inyx]"
          "ifn vco2ift icps, iwave [, inyx]"
          )
         (list
          "buzz - Output is a set of harmonically related sine partials"
          "gbuzz - Output is a set of harmonically related cosine partials"
          "mpulse - Generates a set of impulses"
          "vco - Implementation of a band limited, analog modeled oscillator"
          "vco2 - Implementation of a band-limited oscillator using pre-calculated tables"
          "vco2init - Calculates tables for use by vco2 opcode"
          "vco2ft - Returns a table number at k-time for a given oscillator frequency and wavform"
          "vco2ift - Returns a table number at i-time for a given oscillator frequency and wavform")))

(setf *dynamic_oscillators_menu* nil)
(csman2om *dynamic_oscillators* '*dynamic_oscillators_menu*)

(setf 
 *FM*
 (mapcar #'list
         (list
          "ares foscil xamp, kcps, xcar, xmod, kndx, ifn [, iphs]"
          "ares foscili xamp, kcps, xcar, xmod, kndx, ifn [, iphs]"
          "ares fmb3 kamp, kfreq, kc1, kc2, kvdepth, kvrate, ifn1, ifn2, ifn3, ifn4, ivfn"
          "ares fmbell kamp, kfreq, kc1, kc2, kvdepth, kvrate, ifn1, ifn2, ifn3, ifn4, ivfn"
          "ares fmmetal kamp, kfreq, kc1, kc2, kvdepth, kvrate, ifn1, ifn2, ifn3, ifn4, ivfn"
          "ares fmpercfl kamp, kfreq, kc1, kc2, kvdepth, kvrate, ifn1, ifn2, ifn3, ifn4, ivfn"
          "ares fmrhode kamp, kfreq, kc1, kc2, kvdepth, kvrate, ifn1, ifn2, ifn3, ifn4, ivfn"
          "ares fmvoice kamp, kfreq, kvowel, ktilt, kvibamt, kvibrate, ifn1, ifn2, ifn3, ifn4, ivibfn"
          "ares fmwurlie kamp, kfreq, kc1, kc2, kvdepth, kvrate, ifn1, ifn2, ifn3, ifn4, ivfn")
         (list
          "foscil - A basic frequency modulated oscillator"
          "foscili - Basic frequency modulated oscillator with linear interpolation"
          "fmb3 - Uses FM synthesis to create a Hammond B3 organ sound"
          "fmbell - Uses FM synthesis to create a tublar bell sound"
          "fmmetal - Uses FM synthesis to create a \"Heavy Metal\" sound"
          "fmpercfl - Uses FM synthesis to create a percussive flute sound"
          "fmrhode - Uses FM synthesis to create a Fender Rhodes electric piano sound"
          "fmvoice - FM Singing Voice Synthesis"
          "fmwurlie - Uses FM synthesis to create a Wurlitzer electric piano sound")))
          
(setf *FM_menu* nil)
(csman2om *FM* '*FM_menu*)

(setf 
 *Hyper_Vectorial_Synthesis*
 (mapcar #'list
         (list
          "vphaseseg kphase, ioutab, ielems, itab1,idist1,itab2 [, idist2] [, itab3] [...]"
          "hvs1 kx, inumParms, inumPointsX, iOutTab, iPositionsTab, iSnapTab [, iConfigTab]"
          "hvs2 kx, ky, inumParms, inumPointsX, iOutTab, iPositionsTab, iSnapTab [, iConfigTab]"
          "hvs3 kx, ky, kz, inumParms, inumPointsX, iOutTab, iPositionsTab, iSnapTab [, iConfigTab]"
          "ihandle FLhvsBox inumlinesX, inumlinesY, iwidth, iheight, ix, iy [, image]")
         (list
          "vphaseseg - Allows one-dimensional HVS (Hyper-Vectorial Synthesis)"
          "hvs1 - Allows one-dimensional Hyper Vectorial Synthesis (HVS) controlled by externally-updated k-variables"
          "hvs2 - Allows two-dimensional Hyper Vectorial Synthesis (HVS) controlled by externally-updated k-variables"
          "hvs3 - allows three-dimensional Hyper Vectorial Synthesis (HVS) controlled by externally-updated k-variables"
          "FLhvsBox - Displays a box with a grid useful for visualizing two-dimensional Hyper Vectorial Synthesis")))

(setf *Hyper_Vectorial_Synthesis_menu* nil)
(csman2om *Hyper_Vectorial_Synthesis* '*Hyper_Vectorial_Synthesis_menu*)

(setf 
 *Scanned_Synthesis*
 (mapcar #'list
         (list
          "scanu init, irate, ifnvel, ifnmass, ifnstif, ifncentr, ifndamp, kmass, kstif, kcentr, kdamp, ileft, iright, kpos, kstrngth, ain, idisp, id"
          "ares scans kamp, kfreq, ifn, id [, iorder]"
          "scanhammer isrc, idst, ipos, imult"
          "aout scantable kamp, kpch, ipos, imass, istiff, idamp, ivel" )
         (list
          "scanu - Compute the waveform and the wavetable for use in scanned synthesis"
          "scans - Generate audio output using scanned synthesis"
          "scanhammer - Copies from one table to another with a gain control"
          "scantable - A simpler scanned synthesis implementation" )))

(setf *Scanned_Synthesis_menu* nil)
(csman2om *Scanned_Synthesis* '*Scanned_Synthesis_menu*)

(setf 
 *Granular_Synth*
 (mapcar #'list
         (list
          "asig diskgrain Sfname, kamp, kfreq, kpitch, kgrsize, kprate, ifun, iolaps[, ioffset, imaxgrsize]"
          "ares fof xamp, xfund, xform, koct, kband, kris, kdur, kdec, iolaps, ifna, ifnb, itotdur [, iphs] [, ifmode] [, iskip]"
          "ares fof2 xamp, xfund, xform, koct, kband, kris, kdur, kdec, iolaps, ifna, ifnb, itotdur, kphs, kgliss [, iskip]"
          "ares fog xamp, xdens, xtrans, aspd, koct, kband, kris, kdur, kdec, iolaps, ifna, ifnb, itotdur [, iphs] [, itmode] [, iskip]"
          "ares grain xamp, xpitch, xdens, kampoff, kpitchoff, kgdur, igfn, iwfn, imgdur [, igrnd]"
          "ares grain2 kcps, kfmd, kgdur, iovrlp, kfn, iwfn [, irpow] [, iseed] [, imode]"
          "ares grain3 kcps, kphs, kfmd, kpmd, kgdur, kdens, imaxovr, kfn, iwfn, kfrpow, kprpow [, iseed] [, imode]"
          "ares granule xamp, ivoice, iratio, imode, ithd, ifn, ipshift, igskip, igskip_os, ilength, kgap, igap_os, kgsize, igsize_os, iatt, idec [, iseed] [, ipitch1] [, ipitch2] [, ipitch3] [, ipitch4] [, ifnenv]"
          "ares sndwarp xamp, xtimewarp, xresample, ifn1, ibeg, iwsize, irandw, ioverlap, ifn2, itimemode"
          "ar1, ar2 sndwarpst xamp, xtimewarp, xresample, ifn1, ibeg, iwsize, irandw, ioverlap, ifn2, itimemode"
          "asig syncgrain kamp, kfreq, kpitch, kgrsize, kprate, ifun1, ifun2, iolaps"
          "asig syncloop kamp, kfreq, kpitch, kgrsize, kprate, klstart, klend, ifun1, ifun2, iolaps[,istart, iskip]"
          "async, aphase partikkelsync iopcode_id"
          "asig paulstretch istretch, iwindowsize, ift")
         (list
          "diskgrain - Synchronous granular synthesis, using a soundfile as source"
          "fof - Produces sinusoid bursts useful for formant and granular synthesis"
          "fof2 - Produces sinusoid bursts including k-rate incremental indexing with each successive burst"
          "fog - Audio output is a succession of grains derived from data in a stored function table"
          "grain - Generates granular synthesis textures"
          "grain2 - Easy-to-use granular synthesis texture generator"
          "grain3 - Generate granular synthesis textures with more user control"
          "granule - A more complex granular synthesis texture generator"
          "sndwarp - Reads a mono sound sample from a table and applies time-stretching and/or pitch modification"
          "sndwarpst - Reads a stereo sound sample from a table and applies time-stretching and/or pitch modification"
          "syncgrain - Synchronous granular synthesis"
          "syncloop - Synchronous granular synthesis"
          "partikkelsync - Outputs partikkel's grain scheduler clock pulse and phase to synchronize several instances of the partikkel opcode to the same clock source"
          "paulstretch - Extreme time-stretching algorithm by Nasca Octavian Paul")))

(setf *Granular_Synth_menu* nil)
(csman2om *Granular_Synth* '*Granular_Synth_menu*)

(setf 
 *Granular_Synth_menu*
 (append
  (om::first-n *Granular_Synth_menu* 3)
  (list 
   (append 
    (fourth *Granular_Synth_menu*)
    '(a_partikkel))
   nil)))

;;;;;; manca partikkel e partikkelsync ;;;;;;

(setf 
 *Noise_Generators*
 (mapcar #'list
         (list
          "ares betarand krange, kalpha, kbeta" "ires betarand krange, kalpha, kbeta" "kres betarand krange, kalpha, kbeta"
          "ares bexprnd krange" "ires bexprnd krange" "kres bexprnd krange"
          "ares cauchy kalpha" "ires cauchy kalpha" "kres cauchy kalpha"
          "aout cuserrnd kmin, kmax, ktableNum" "iout cuserrnd imin, imax, itableNum" "kout cuserrnd kmin, kmax, ktableNum"
          "aout duserrnd ktableNum" "iout duserrnd itableNum" "kout duserrnd ktableNum"
          "ares exprand krange" "ires exprand krange" "kres exprand krange"
          "ares gauss krange" "ires gauss krange" "kres gauss krange"
          "ares linrand krange" "ires linrand krange" "kres linrand krange"
          "ares noise xamp, kbeta"
          "ares pcauchy kalpha" "ires pcauchy kalpha" "kres pcauchy kalpha"
          "ares pinkish xin [, imethod] [, inumbands] [, iseed] [, iskip]"
          "ares poisson klambda" "ires poisson klambda" "kres poisson klambda"
          "ares rand xamp [, iseed] [, isel] [, ioffset]"
          "kres rand xamp [, iseed] [, isel] [, ioffset]"
          "ares randh xamp, xcps [, iseed] [, isize] [, ioffset]" 
          "kres randh kamp, kcps [, iseed] [, isize] [, ioffset]"
          "ares randi xamp, xcps [, iseed] [, isize] [, ioffset]"
          "kres randi kamp, kcps [, iseed] [, isize] [, ioffset]"
          "ax rnd31 kscl, krpow [, iseed]" "ix rnd31 iscl, irpow [, iseed]" "kx rnd31 kscl, krpow [, iseed]"
          "ares random kmin, kmax" "ires random imin, imax" "kres random kmin, kmax"
          "ares randomh kmin, kmax, acps" "kres randomh kmin, kmax, kcps"
          "ares randomi kmin, kmax, acps" "kres randomi kmin, kmax, kcps"
          "ares trirand krange" "ires trirand krange" "kres trirand krange"
          "ares unirand krange" "ires unirand krange" "kres unirand krange"
          "ares weibull ksigma, ktau" "ires weibull ksigma, ktau" "kres weibull ksigma, ktau"
          "kout jitter kamp, kcpsMin, kcpsMax"
          "kout jitter2 ktotamp, kamp1, kcps1, kamp2, kcps2, kamp3, kcps3"
          "kout trandom ktrig, min, max"
          "ares fractalnoise kamp, kbeta"
          )
         (list
          "betarand - Beta distribution random number generator (positive values only)"
          "betarand - Beta distribution random number generator (positive values only)"
          "betarand - Beta distribution random number generator (positive values only)"
          "bexprnd - Exponential distribution random number generator"
          "bexprnd - Exponential distribution random number generator"
          "bexprnd - Exponential distribution random number generator"
          "cauchy - Cauchy distribution random number generator"
          "cauchy - Cauchy distribution random number generator"
          "cauchy - Cauchy distribution random number generator"
          "cuserrnd - Continuous USER-defined-distribution RaNDom generator"
          "cuserrnd - Continuous USER-defined-distribution RaNDom generator"
          "cuserrnd - Continuous USER-defined-distribution RaNDom generator"
          "duserrnd - Discrete USER-defined-distribution RaNDom generator"
          "duserrnd - Discrete USER-defined-distribution RaNDom generator"
          "duserrnd - Discrete USER-defined-distribution RaNDom generator"
          "exprand - Exponential distribution random number generator (positive values only)"
          "exprand - Exponential distribution random number generator (positive values only)"
          "exprand - Exponential distribution random number generator (positive values only)"
          "gauss - Gaussian distribution random number generator"
          "gauss - Gaussian distribution random number generator"
          "gauss - Gaussian distribution random number generator"
          "linrand - Linear distribution random number generator (positive values only)"
          "linrand - Linear distribution random number generator (positive values only)"
          "linrand - Linear distribution random number generator (positive values only)"
          "noise - A white noise generator with an IIR lowpass filter"
          "pcauchy - Cauchy distribution random number generator (positive values only)"
          "pcauchy - Cauchy distribution random number generator (positive values only)"
          "pcauchy - Cauchy distribution random number generator (positive values only)"
          "pinkish - Generates approximate pink noise"
          "poisson - Poisson distribution random number generator (positive values only)"
          "poisson - Poisson distribution random number generator (positive values only)"
          "poisson - Poisson distribution random number generator (positive values only)"
          "rand - Generates a controlled random number series"
          "rand - Generates a controlled random number series"
          "randh - Generates random numbers and holds them for a period of time"
          "randh - Generates random numbers and holds them for a period of time"
          "randi - Generates a controlled random number series with interpolation between each new number"
          "randi - Generates a controlled random number series with interpolation between each new number"
          "rnd31 - 31-bit bipolar random opcodes with controllable distribution"
          "rnd31 - 31-bit bipolar random opcodes with controllable distribution"
          "rnd31 - 31-bit bipolar random opcodes with controllable distribution"
          "random - Generates a controlled pseudo-random number series between min and max values"
          "random - Generates a controlled pseudo-random number series between min and max values"
          "random - Generates a controlled pseudo-random number series between min and max values"
          "randomh - Generates random numbers with a user-defined limit and holds them for a period of time"
          "randomh - Generates random numbers with a user-defined limit and holds them for a period of time"
          "randomi - Generates a user-controlled random number series with interpolation between each new number"
          "randomi - Generates a user-controlled random number series with interpolation between each new number"
          "trirand - Linear distribution random number generator"
          "trirand - Linear distribution random number generator"
          "trirand - Linear distribution random number generator"
          "unirand - Uniform distribution random number generator (positive values only)"
          "unirand - Uniform distribution random number generator (positive values only)"
          "unirand - Uniform distribution random number generator (positive values only)"
          "weibull - Weibull distribution random number generator (positive values only)"
          "weibull - Weibull distribution random number generator (positive values only)"
          "weibull - Weibull distribution random number generator (positive values only)"
          "jitter - Generates a segmented line whose segments are randomly generated"
          "jitter2 - Generates a segmented line with user-controllable random segments"
          "trandom - Generates a controlled pseudo-random number series between min and max values according to a trigger"
          "fractalnoise - A fractal noise generator")))

(setf *Noise_Generators_menu* nil)
(csman2om *Noise_Generators* '*Noise_Generators_menu*)

;;;;;; manca "urd"

(setf 
 *Lin_and_Expt_Gens*
 (mapcar #'list
         (list
          "ares expon ia, idur1, ib"
          "kres expon ia, idur1, ib"
          "kout expcurve kindex, ksteepness"
          "ares expseg ia, idur1, ib [, idur2] [, ic] [...]"
          "kres expseg ia, idur1, ib [, idur2] [, ic] [...]"
          "ares expsega ia, idur1, ib [, idur2] [, ic] [...]"
          "ares expsegr ia, idur1, ib [, idur2] [, ic] [...]"
          "kres expsegr ia, idur1, ib [, idur2] [, ic] [...]"
          "ares jspline xamp, kcpsMin, kcpsMax"
          "kres jspline kamp, kcpsMin, kcpsMax"
          "ares line ia, idur1, ib"
          "kres line ia, idur1, ib"
          "ares linseg ia, idur1, ib [, idur2] [, ic] [...]"
          "kres linseg ia, idur1, ib [, idur2] [, ic] [...]"
          "ares linsegr ia, idur1, ib [, idur2] [, ic] [...]"
          "kres linsegr ia, idur1, ib [, idur2] [, ic] [...]"
          "kout logcurve kindex, ksteepness"
          "ksig loopseg kfreq, ktrig, ktime0, kvalue0 [, ktime1] [, kvalue1] \ [, ktime2] [, kvalue2] [...]"
          "ksig loopsegp  kphase, kvalue0, ktime0, kvalue1, ktime1 \ [...]"
          "ksig lpshold kfreq, ktrig, ktime0, kvalue0  [, ktime1] [, kvalue1] \ [, ktime2] [, kvalue2] [...]"
          "ksig lpsholdp  kphase, ktrig, ktime0, kvalue0  [, ktime1] [, kvalue1] \ [, ktime2] [, kvalue2] [...]"
          "ares rspline xrangeMin, xrangeMax, kcpsMin, kcpsMax"
          "kres rspline krangeMin, krangeMax, kcpsMin, kcpsMax"
          "kscl scale kinput, kmax, kmin"
          "ares transeg ia, idur, itype, ib [, idur2] [, itype2] [, ic] [...]"
          "kres transeg ia, idur, itype, ib [, idur2] [, itype2] [, ic] [...]")
         (list
          "expon - Trace an exponential curve between specified points"
          "expon - Trace an exponential curve between specified points"
          "expcurve - This opcode implements a formula for generating a normalised exponential curve in range 0 - 1"
          "expseg - Trace a series of exponential segments between specified points"
          "expseg - Trace a series of exponential segments between specified points"
          "expsega - An exponential segment generator operating at a-rate"
          "expsegr - Trace a series of exponential segments between specified points including a release segment"
          "expsegr - Trace a series of exponential segments between specified points including a release segment"
          "jspline - A jitter-spline generator"
          "jspline - A jitter-spline generator"
          "line - Trace a straight line between specified points"
          "line - Trace a straight line between specified points"
          "linseg - Trace a series of line segments between specified points"
          "linseg - Trace a series of line segments between specified points"
          "linsegr - Trace a series of line segments between specified points including a release segment"
          "linsegr - Trace a series of line segments between specified points including a release segment"
          "logcurve - This opcode implements a formula for generating a normalised logarithmic curve in range 0 - 1"
          "loopseg - Generate control signal consisting of linear segments delimited by two or more specified points"
          "loopsegp - Control signals based on linear segments"
          "lpshold - Generate control signal consisting of held segments"
          "lpsholdp - Control signals based on held segments"
          "rspline - Generate random spline curves"
          "rspline - Generate random spline curves"
          "scale - Arbitrary signal scaling"
          "transeg - Constructs a user-definable envelope"
          "transeg - Constructs a user-definable envelope")))
         
(setf *Lin_and_Expt_Gens_menu* nil)
(csman2om *Lin_and_Expt_Gens* '*Lin_and_Expt_Gens_menu*)

;;;;;;; manca "gainslider"

(setf 
 *Env_Generators*
 (mapcar #'list
         (list
          "ares adsr iatt, idec, islev, irel [, idel]"
          "kres adsr iatt, idec, islev, irel [, idel]"
          "ares madsr iatt, idec, islev, irel [, idel] [, ireltim]"
          "kres madsr iatt, idec, islev, irel [, idel] [, ireltim]"
          "ares mxadsr iatt, idec, islev, irel [, idel] [, ireltim]"
          "kres mxadsr iatt, idec, islev, irel [, idel] [, ireltim]"
          "ares xadsr iatt, idec, islev, irel [, idel]"
          "kres xadsr iatt, idec, islev, irel [, idel]"
          "ares linen xamp, irise, idur, idec"
          "kres linen kamp, irise, idur, idec"
          "ares linenr xamp, irise, idec, iatdec"
          "kres linenr kamp, irise, idec, iatdec"
          "ares envlpx xamp, irise, idur, idec, ifn, iatss, iatdec [, ixmod]"
          "kres envlpx kamp, irise, idur, idec, ifn, iatss, iatdec [, ixmod]"
          "ares envlpxr xamp, irise, idec, ifn, iatss, iatdec [, ixmod] [,irind]"
          "kres envlpxr kamp, irise, idec, ifn, iatss, iatdec [, ixmod] [,irind]")
         (list
          "adsr - Calculates the classical ADSR envelope using linear segments"
          "adsr - Calculates the classical ADSR envelope using linear segments"
          "madsr - Calculates the classical ADSR envelope using the linsegr mechanism"
          "madsr - Calculates the classical ADSR envelope using the linsegr mechanism"
          "mxadsr - Calculates the classical ADSR envelope using the expsegr mechanism"
          "mxadsr - Calculates the classical ADSR envelope using the expsegr mechanism"
          "xadsr - Calculates the classical ADSR envelope"
          "xadsr - Calculates the classical ADSR envelope"
          "linen - Applies a straight line rise and decay pattern to an input amp signal"
          "linen - Applies a straight line rise and decay pattern to an input amp signal"
          "linenr - The linen opcode extended with a final release segment"
          "linenr - The linen opcode extended with a final release segment"
          "envlpx - Applies an envelope consisting of 3 segments"
          "envlpx - Applies an envelope consisting of 3 segments"
          "envlpxr - The envlpx opcode with a final release segment"
          "envlpxr - The envlpx opcode with a final release segment")))

(setf *Env_Generators_menu* nil)
(csman2om *Env_Generators* '*Env_Generators_menu*)

(setf 
 *Models*
 (mapcar #'list
         (list
          "ares bamboo kamp, idettack [, inum] [, idamp] [, imaxshake] [, ifreq] [, ifreq1] [, ifreq2]"
          "ares barmodel kbcL, kbcR, iK, ib, kscan, iT30, ipos, ivel, iwid"
          "ares cabasa iamp, idettack [, inum] [, idamp] [, imaxshake]"
          "ares crunch iamp, idettack [, inum] [, idamp] [, imaxshake]"
          "ares dripwater kamp, idettack [, inum] [, idamp] [, imaxshake] [, ifreq] [, ifreq1] [, ifreq2]"
          "ares gogobel kamp, kfreq, ihrd, ipos, imp, kvibf, kvamp, ivfn"
          "ares guiro kamp, idettack [, inum] [, idamp] [, imaxshake] [, ifreq] [, ifreq1]"
          "ax, ay, az lorenz ksv, krv, kbv, kh, ix, iy, iz, iskip [, iskipinit]"
          "ares mandol kamp, kfreq, kpluck, kdetune, kgain, ksize, ifn [, iminfreq]"
          "ares marimba kamp, kfreq, ihrd, ipos, imp, kvibf, kvamp, ivibfn, idec [, idoubles] [, itriples]"
          "ares moog kamp, kfreq, kfiltq, kfiltrate, kvibf, kvamp, iafn, iwfn, ivfn"
          "ax, ay, az planet kmass1, kmass2, ksep, ix, iy, iz, ivx, ivy, ivz, idelta [, ifriction] [, iskip]"
          "ares sandpaper iamp, idettack [, inum] [, idamp] [, imaxshake]"
          "ares sekere iamp, idettack [, inum] [, idamp] [, imaxshake]"
          "ares shaker kamp, kfreq, kbeans, kdamp, ktimes [, idecay]"
          "ares sleighbells kamp, idettack [, inum] [, idamp] [, imaxshake] [, ifreq] [, ifreq1] [, ifreq2]"
          "ares stix iamp, idettack [, inum] [, idamp] [, imaxshake]"
          "ares tambourine kamp, idettack [, inum] [, idamp] [, imaxshake] [, ifreq] [, ifreq1] [, ifreq2]"
          "ares vibes kamp, kfreq, ihrd, ipos, imp, kvibf, kvamp, ivibfn, idec"
          "ares voice kamp, kfreq, kphoneme, kform, kvibf, kvamp, ifn, ivfn"
          "kiter, koutrig mandel  ktrig, kx, ky, kmaxIter"
          "ares wguide2 asig, xfreq1, xfreq2, kcutoff1, kcutoff2, kfeedback1, kfeedback2"
          "ares stix iamp, idettack [, inum] [, idamp] [, imaxshake]"
          "aout mode ain, kfreq, kQ [, iskip]"
          "aI3, aV2, aV1 chuap kL, kR0, kC1, kG, kGa, kGb, kE, kC2, iI3, iV2, iV1, ktime_step" )
         (list
          "bamboo - Semi-physical model of a bamboo sound"
          "barmodel - Creates a tone similar to a stuck metal bar"
          "cabasa - Semi-physical model of a cabasa sound"
          "crunch - Semi-physical model of a crunch sound"
          "dripwater - Semi-physical model of a water drop"
          "gogobel - Audio output is a tone related to the striking of a cow bell or similar"
          "guiro - Semi-physical model of a guiro sound"
          "lorenz - Implements the Lorenz system of equations"
          "mandol - An emulation of a mandolin"
          "marimba - Physical model related to the striking of a wooden block"
          "moog - An emulation of a mini-Moog synthesizer"
          "planet - Simulates a planet orbiting in a binary star system"
          "sandpaper - Semi-physical model of a sandpaper sound"
          "sekere - Semi-physical model of a sekere sound"
          "shaker - Sounds like the shaking of a maraca or similar gourd instrument"
          "sleighbells - Semi-physical model of a sleighbell sound"
          "stix - Semi-physical model of a stick sound"
          "tambourine - Semi-physical model of a tambourine sound"
          "vibes - Physical model related to the striking of a metal block"
          "voice - An emulation of a human voice"
          "mandel - Mandelbrot set"
          "wguide2 - A model of beaten plate consisting of two parallel delay-lines and two first-order lowpass filters"
          "stix - Semi-physical model of a stick sound"
          "mode - A filter that simulates a mass-spring-damper system"
          "chuap - Simulates Chua's oscillator, an LRC oscillator with an active resistor, proved capable of bifurcation and chaotic attractors, with k-rate control of circuit elements" )))

(setf *Models_menu* nil)
(csman2om *Models* '*Models_menu*)

(setf 
 *Sample_Playback*
 (mapcar #'list
         (list
          "a1 bbcutm asource, ibps, isubdiv, ibarlength, iphrasebars, inumrepeats [, istutterspeed] [, istutterchance] [, ienvchoice ]"
          "a1,a2 bbcuts asource1, asource2, ibps, isubdiv, ibarlength, iphrasebars, inumrepeats [, istutterspeed] [, istutterchance] [, ienvchoice]"
          "asig flooper kamp, kpitch, istart, idur, ifad, ifn"
          "asig flooper2 kamp, kpitch, kloopstart, kloopend, kcrossfade, ifn [, istart] [, imode] [, ifenv] [, iskip]"
          "ares lphasor xtrns [, ilps] [, ilpe] [, imode] [, istrt] [, istor]"
          "ares lposcil kamp, kfreqratio, kloop, kend, ifn [, iphs]"
          "ares lposcil3 kamp, kfreqratio, kloop, kend, ifn [, iphs]"
          "ar lposcila aamp, kfreqratio, kloop, kend, ift [,iphs] "
          "ar1, ar2 lposcilsa aamp, kfreqratio, kloop, kend, ift [,iphs]"
          "ar1, ar2 lposcilsa2 aamp, kfreqratio, kloop, kend, ift [,iphs]"
          "asig, krec sndloop ain, kpitch, ktrig, idur, ifad"
          "ares waveset ain, krep [, ilen]")
         (list
          "bbcutm - Generates breakbeat-style cut-ups of a mono audio stream"
          "bcuts - Generates breakbeat-style cut-ups of a stereo audio stream"
          "flooper - Function-table-based crossfading looper"
          "flooper2 - Function-table-based crossfading looper"
          "lphasor - Generates a table index for sample playback"
          "lposcil - Read sampled sound from a table with optional looping and high precision"
          "lposcil3 - Read sampled sound from a table with high precision and cubic interpolation"
          "lposcila - Read sampled sound from a table with optional looping and high precision"
          "lposcilsa - Read stereo sampled sound from a table with optional looping and high precision"
          "lposcilsa2 - Read stereo sampled sound from a table with optional looping and high precision"
          "sndloop - A sound looper with pitch control"
          "waveset - A simple time stretch by repeating cycles")))

(setf *Sample_Playback_menu* nil)
(csman2om *Sample_Playback* '*Sample_Playback_menu*)

(setf 
 *Sample_Playback_menu*
 (append
  (om::first-n *Sample_Playback_menu* 3)
  (list 
   (append 
    (list 'a_loscil 'a_loscil3 'a_loscilx)
    (fourth *Sample_Playback_menu*))
   nil)))

(setf 
 *Phasors*
 (mapcar #'list
         (list
          "ares phasor xcps [, iphs]"
          "kres phasor kcps [, iphs]"
          "ares phasorbnk xcps, kndx, icnt [, iphs]"
          "kres phasorbnk kcps, kndx, icnt [, iphs]"
          "aout pdhalf ain, kShapeAmount [, ibipolar] [, ifullscale]"
          "aout pdhalfy ain, kShapeAmount [, ibipolar] [, ifullscale]")
         (list
          "phasor - Produce a normalized moving phase value"
          "phasor - Produce a normalized moving phase value"
          "phasorbnk - Produce an arbitrary number of normalized moving phase values"
          "phasorbnk - Produce an arbitrary number of normalized moving phase values"
          "pdhalf - Distorts a phasor for reading the two halves of a table at different rates"
          "pdhalfy - Distorts a phasor for reading two unequal portions of a table in equal periods" )))

(setf *Phasors_menu* nil)
(csman2om *Phasors* '*Phasors_menu*)

(setf 
 *Table_Access*
 (mapcar #'list
         (list
          "kres oscil1 idel, kamp, idur, ifn"
          "kres oscil1i idel, kamp, idur, ifn"
          "ares table andx, ifn [, ixmode] [, ixoff] [, iwrap]"
          "ires table indx, ifn [, ixmode] [, ixoff] [, iwrap]"
          "kres table kndx, ifn [, ixmode] [, ixoff] [, iwrap]"
          "ares table3 andx, ifn [, ixmode] [, ixoff] [, iwrap]"
          "ires table3 indx, ifn [, ixmode] [, ixoff] [, iwrap]"
          "kres table3 kndx, ifn [, ixmode] [, ixoff] [, iwrap]"
          "ares tablei andx, ifn [, ixmode] [, ixoff] [, iwrap]"
          "ires tablei indx, ifn [, ixmode] [, ixoff] [, iwrap]"
          "kres tablei kndx, ifn [, ixmode] [, ixoff] [, iwrap]"
          "kr tab kndx, ifn [, ixmode]"
          "ar tab xndx, ifn [, ixmode]"
          "ir tab_i indx, ifn [, ixmode]"
          "aout wterrain kamp, kpch, k_xcenter, k_ycenter, k_xradius, k_yradius, itabx, itaby"
          "ires tableng ifn"
          "kres tableng kfn"
          "ktrig_out seqtime ktime_unit, kstart, kloop, kinitndx, kfn_times"
          "ktrig_out seqtime2 ktrig_in, ktime_unit, kstart, kloop, kinitndx, kfn_times")
         (list
          "oscil1 - Accesses table values by incremental sampling"
          "oscil1i - Accesses table values by incremental sampling with linear interpolation"
          "table - Accesses table values by direct indexing"
          "table - Accesses table values by direct indexing"
          "table - Accesses table values by direct indexing"
          "table3 - Accesses table values by direct indexing with cubic interpolation"
          "table3 - Accesses table values by direct indexing with cubic interpolation"
          "table3 - Accesses table values by direct indexing with cubic interpolation"
          "tablei - Accesses table values by direct indexing with linear interpolation"
          "tablei - Accesses table values by direct indexing with linear interpolation"
          "tablei - Accesses table values by direct indexing with linear interpolation"
          "tab - Fast table opcode"
          "tab - Fast table opcode"
          "tab_i - Fast table opcode"
          "wterrain - A simple wave-terrain synthesis opcode"
          "tableng - Interrogates a function table for length"
          "tableng - Interrogates a function table for length"
          "seqtime - Generates a trigger signal according to the values stored in a table"
          "seqtime2 - Generates a trigger signal according to the values stored in a table")))

(setf *Table_Access_menu* nil)
(csman2om *Table_Access* '*Table_Access_menu*)

(setf 
 *Waveguides*
 (mapcar #'list
         (list
          "ares pluck kamp, kcps, icps, ifn, imeth [, iparm1] [, iparm2]"
          "ares repluck iplk, kamp, icps, kpick, krefl, axcite"
          "ares wgbow kamp, kfreq, kpres, krat, kvibf, kvamp, ifn [, iminfreq]"
          "ares wgbowedbar kamp, kfreq, kpos, kbowpres, kgain [, iconst] [, itvel] [, ibowpos] [, ilow]"
          "ares wgbrass kamp, kfreq, ktens, iatt, kvibf, kvamp, ifn [, iminfreq]"
          "ares wgclar kamp, kfreq, kstiff, iatt, idetk, kngain, kvibf, kvamp, ifn [, iminfreq]"
          "ares wgflute kamp, kfreq, kjet, iatt, idetk, kngain, kvibf, kvamp, ifn [, iminfreq] [, ijetrf] [, iendrf]"
          "ares wgpluck icps, iamp, kpick, iplk, idamp, ifilt, axcite"
          "ares wgpluck2 iplk, kamp, icps, kpick, krefl"
          "ares wguide1 asig, xfreq, kcutoff, kfeedback"
          "ares wguide2 asig, xfreq1, xfreq2, kcutoff1, kcutoff2, kfeedback1, kfeedback2"
          "ares streson asig, kfr, ifdbgain")
         (list
          "pluck - Produces a naturally decaying plucked string or drum sound"
          "repluck - Physical model of the plucked string"
          "wgbow - Creates a tone similar to a bowed string"
          "wgbowedbar - A physical model of a bowed bar"
          "wgbrass - Creates a tone related to a brass instrument"
          "wgclar - Creates a tone similar to a clarinet"
          "wgflute - Creates a tone similar to a flute"
          "wgpluck - A high fidelity simulation of a plucked string"
          "wgpluck2 - Physical model of the plucked string"
          "wguide1 - A simple waveguide model consisting of one delay-line and one first-order lowpass filter"
          "wguide2 - A model of beaten plate consisting of two parallel delay-lines and two first-order lowpass filters"
          "streson - A string resonator with variable fundamental frequency")))

(setf *Waveguides_menu* nil)
(csman2om *Waveguides* '*Waveguides_menu*)

;;;;;;;; Signal Modifiers ;;;;;;;;

(setf 
 *Filters*
 (mapcar #'list
         (list
          "ares areson asig, kcf, kbw [, iscl] [, iskip]"
          "ares lowpass2 asig, kcf, kq [, iskip]"
          "ares lowres asig, kcutoff, kresonance [, iskip]"
          "ares lowresx asig, kcutoff, kresonance [, inumlayer] [, iskip]"
          "ares lpf18 asig, kfco, kres, kdist"
          "ares moogvcf asig, xfco, xres [,iscale] [, iskip]"
          "asig moogladder ain, kcf, kres [, istor]"
          "ares reson asig, kcf, kbw [, iscl] [, iskip]"
          "ares resonr asig, kcf, kbw [, iscl] [, iskip]"
          "ares resonx asig, kcf, kbw [, inumlayer] [, iscl] [, iskip]"
          "ares resony asig, kbf, kbw, inum, ksep [, isepmode] [, iscl] [, iskip]"
          "ares resonz asig, kcf, kbw [, iscl] [, iskip]"
          "ares rezzy asig, xfco, xres [, imode, iskip]"
          "ahp,alp,abp,abr statevar ain, kcf, kq [, iosamps, istor]"
          "alow, ahigh, aband svfilter  asig, kcf, kq [, iscl]"
          "ares tbvcf asig, xfco, xres, kdist, kasym [, iskip]"
          "ares vlowres asig, kfco, kres, iord, ksep"
          "ares bqrez asig, xfco, xres [, imode] [, iskip]"
          "ares atone asig, khp [, iskip]"
          "ares atonex asig, khp [, inumlayer] [, iskip]"
          "ares tone asig, khp [, iskip]" 
          "ares tonex  asig, khp [, inumlayer] [, iskip]"
          "ares biquad asig, kb0, kb1, kb2, ka0, ka1, ka2 [, iskip]"
          "ares biquada asig, ab0, ab1, ab2, aa0, aa1, aa2 [, iskip]"
          "ares butterbp asig, kfreq, kband [, iskip]" "ares butbp asig, kfreq, kband [, iskip]"
          "ares butterbr asig, kfreq, kband [, iskip]" "ares butbr asig, kfreq, kband [, iskip]"
          "ares butterhp asig, kfreq [, iskip]" "ares buthp asig, kfreq [, iskip]"
          "ares butterlp asig, kfreq [, iskip]" "ares butlp asig, kfreq [, iskip]"
          "ares clfilt asig, kfreq, itype, inpol [, ikind] [, ipbr] [, isba] [, iskip]"
          "kres aresonk ksig, kcf, kbw [, iscl] [, iskip]"
          "kres atonek ksig, khp [, iskip]"
          "kres lineto ksig, ktime"
          "kres port ksig, ihtim [, isig]"
          "kres portk ksig, khtim [, isig]"
          "kres resonk ksig, kcf, kbw [, iscl] [, iskip]"
          "kres resonxk ksig, kcf, kbw [, inumlayer] [, iscl] [, istor]"
          "kres tlineto ksig, ktime, ktrig"
          "kres tonek ksig, khp [, iskip]"
          "ares dcblock ain [, igain]"
          "ares pareq asig, kc, kv, kq [, imode] [, iskip]"
          "ar rbjeq asig, kfco, klvl, kQ, kS [, imode]"
          "asig eqfil ain, kcf, kbw, kgain [, istor]"
          "ares nlfilt ain, ka, kb, kd, kC, kL"
          "asig fofilter ain, kcf, kris, kdec [, istor]"
          "ar1, ar2 hilbert asig"
          "ares moogvcf2 asig, xfco, xres [,iscale] [, iskip]"
          "ares dcblock2 ain [, iorder] [, iskip]"
          "ares filter2 asig, iM, iN, ib0, ib1, [, ibM] [...]"
          "kres filter2 ksig, iM, iN, ib0, ib1, [, ibM] [...]")
         (list
          "areson - A notch filter whose transfer functions are the complements of the reson opcode"
          "lowpass2 - A resonant lowpass filter"
          "lowres - Another resonant lowpass filter"
          "lowresx - Simulates layers of serially connected resonant lowpass filters"
          "lpf18 - A 3-pole sweepable resonant lowpass filter"
          "moogvcf - A digital emulation of the Moog diode ladder filter configuration"
          "moogladder - Moog ladder lowpass filter"
          "reson - A second-order resonant filter"
          "resonr - A bandpass filter with variable frequency response"
          "resonx - Emulates a stack of filters using the reson opcode"
          "resony - A bank of second-order bandpass filters, connected in parallel"
          "resonz - A bandpass filter with variable frequency response"
          "rezzy - A resonant low-pass filter"
          "statevar - State-variable filter"
          "svfilter - A resonant second order filter, with simultaneous lowpass, highpass and bandpass outputs"
          "tbvcf - Models some of the filter characteristics of a Roland TB303 voltage-controlled filter"
          "vlowres - A bank of filters in which the cutoff frequency can be separated under user control"
          "bqrez - A second-order multi-mode filter"
          "atone - A hi-pass filter whose transfer functions are the complements of the tone opcode"
          "atonex - Emulates a stack of filters using the atone opcode"
          "tone - A first-order recursive low-pass with variable frequency response"
          "tonex - Emulates a stack of filters using the tone opcode"
          "biquad - A sweepable general purpose biquadratic digital filter"
          "biquada - A sweepable general purpose biquadratic digital filter with a-rate parameters"
          "butterbp - A band-pass Butterworth filter." "butbp - A band-pass Butterworth filter."
          "butterbr - A band-reject Butterworth filter" "butbr - A band-reject Butterworth filter"
          "butterhp - A high-pass Butterworth filter" "buthp - A high-pass Butterworth filter"
          "butterlp - A low-pass Butterworth filter" "butlp - A low-pass Butterworth filter"
          "clfilt - Implements low-pass and high-pass filters of different styles"
          "aresonk - A notch filter whose transfer functions are the complements of the reson opcode"
          "atonek - A hi-pass filter whose transfer functions are the complements of the tonek opcode"
          "lineto - Generate glissandos starting from a control signal"
          "port - Applies portamento to a step-valued control signal"
          "portk - Applies portamento to a step-valued control signal"
          "resonk - A second-order resonant filter"
          "resonxk - Control signal resonant filter stack"
          "tlineto - Generate glissandos starting from a control signal"
          "tonek - A first-order recursive low-pass filter with variable frequency response"
          "dcblock - A DC blocking filter"
          "pareq - Implementation of Zoelzer's parametric equalizer filters"
          "rbjeq - Parametric equalizer and filter opcode with 7 filter types, based on algorithm by Robert Bristow-Johnson"
          "eqfil - Equalizer filter"
          "nlfilt - A filter with a non-linear effect"
          "fofilter - Formant filter"
          "hilbert - A Hilbert transformer"
          "moogvcf2 - A digital emulation of the Moog diode ladder filter configuration"
          "dcblock2 - A DC blocking filter" 
          "filter2 - Performs filtering using a transposed form-II digital filter lattice with no time-varying control"
          "filter2 - Performs filtering using a transposed form-II digital filter lattice with no time-varying control" )))

(setf *Filters_menu* nil)
(csman2om *Filters* '*Filters_menu*)

(setf 
 *Amplitude_Modifiers*
 (mapcar #'list
         (list
          "ares balance asig, acomp [, ihp] [, iskip]"
          "ar compress aasig, acsig, kthresh, kloknee, khiknee, kratio, katt, krel, ilook"
          "ares clip asig, imeth, ilimit [, iarg]"
          "ares dam asig, kthreshold, icomp1, icomp2, irtime, iftime"
          "ares gain asig, krms [, ihp] [, iskip]"
          "ares limit asig, klow, khigh"
          "ires limit isig, ilow, ihigh"
          "kres limit ksig, klow, khigh"
          "ares mirror asig, klow, khigh"
          "ires mirror isig, ilow, ihigh"
          "kres mirror ksig, klow, khigh"
          "ares wrap asig, klow, khigh"
          "ires wrap isig, ilow, ihigh"
          "kres wrap ksig, klow, khigh")
         (list
          "balance - Adjust one audio signal according to the values of another"
          "compress - Compress, limit, expand, duck or gate an audio signal"
          "clip - Clips a signal to a predefined limit"
          "dam - A dynamic compressor/expander"
          "gain - Adjusts the amplitude audio signal according to a root-mean-square value"
          "limit - Sets the lower and upper limits of the value it processes"
          "limit - Sets the lower and upper limits of the value it processes"
          "limit - Sets the lower and upper limits of the value it processes"
          "mirror - Reflects the signal that exceeds the low and high thresholds"
          "mirror - Reflects the signal that exceeds the low and high thresholds"
          "mirror - Reflects the signal that exceeds the low and high thresholds"
          "wrap - Wraps-around the signal that exceeds the low and high thresholds"
          "wrap - Wraps-around the signal that exceeds the low and high thresholds"
          "wrap - Wraps-around the signal that exceeds the low and high thresholds")))

(setf *Amplitude_Modifiers_menu* nil)
(csman2om *Amplitude_Modifiers* '*Amplitude_Modifiers_menu*)

(setf 
 *Delays*
 (mapcar #'list
         (list
          "ares delay asig, idlt [, iskip]"
          "ares delay1 asig [, iskip]"
          "kr delayk   ksig, idel[, imode]"
          "kr vdel_k   ksig, kdel, imdel[, imode]"
          "ares delayr idlt [, iskip]"
          "delayw asig"
          "ares deltap kdlt"
          "ares deltap3 xdlt"
          "ares deltapi xdlt"
          "ares deltapn xnumsamps"
          "aout deltapx adel, iwsize"
          "deltapxw ain, adel, iwsize"
          "ares vdelay asig, adel, imaxdel [, iskip]"
          "ares vdelay3 asig, adel, imaxdel [, iskip]"
          "aout vdelayx ain, adl, imd, iws [, ist]"
          "aout1, aout2 vdelayxs ain1, ain2, adl, imd, iws [, ist]"
          "aout1, aout2, aout3, aout4 vdelayxq ain1, ain2, ain3, ain4, adl, imd, iws [, ist]"
          "aout vdelayxw ain, adl, imd, iws [, ist]"
          "aout1, aout2, aout3, aout4 vdelayxwq ain1, ain2, ain3, ain4, adl, imd, iws [, ist]"
          "aout1, aout2 vdelayxws ain1, ain2, adl, imd, iws [, ist]"
          "ares multitap asig [, itime1] [, igain1] [, itime2] [, igain2] [...]" )
         (list
          "delay - Delays an input signal by some time interval"
          "delay1 - Delays an input signal by one sample"
          "delayk - Delays an input signal by some time interval"
          "vdel_k - Delays an input signal by some time interval"
          "delayr - Reads from an automatically established digital delay line"
          "delayw - Writes the audio signal to a digital delay line"
          "deltap - Taps a delay line at variable offset times"
          "deltap3 - Taps a delay line at variable offset times, uses cubic interpolation"
          "deltapi - Taps a delay line at variable offset times, uses interpolation"
          "deltapn - Taps a delay line at variable offset times"
          "deltapx - Read to or write from a delay line with interpolation"
          "deltapxw - Mixes the input signal to a delay line"
          "vdelay - An interpolating variable time delay"
          "vdelay3 - An variable time delay with cubic interpolation"
          "vdelayx - A variable delay opcode with high quality interpolation"
          "vdelayxs - A stereo variable delay opcode with high quality interpolation"
          "vdelayxq - A 4-channel variable delay opcode with high quality interpolation"
          "vdelayxw - Variable delay opcodes with high quality interpolation"
          "vdelayxwq - Variable 4-channel delay opcode with high quality interpolation"
          "vdelayxws - Variable stereo delay opcode with high quality interpolation"
          "multitap - Multitap delay line implementation" )))

(setf *Delays_menu* nil)
(csman2om *Delays* '*Delays_menu*)

(setf 
 *Special_Effects*
 (mapcar #'list
         (list
          "ar distort asig, kdist, ifn[, ihp, istor]"
          "ares distort1 asig, kpregain, kpostgain, kshape1, kshape2[, imode]"
          "ares flanger asig, adel, kfeedback [, imaxd]"
          "ares harmon asig, kestfrq, kmaxvar, kgenfreq1, kgenfreq2, imode, iminfrq, iprd"
          "ares phaser1 asig, kfreq, kord, kfeedback [, iskip]"
          "ares phaser2 asig, kfreq, kq, kord, kmode, ksep, kfeedback"
          "ares harmon2 asig, koct, kfrq1, kfrq2, icpsmode, ilowest [, ipolarity]"
          "ares harmon3 asig, koct, kfrq1, kfrq2, kfrq3, icpsmode, ilowest [, ipolarity]"
          "ares harmon4 asig, koct, kfrq1, kfrq2, kfrq3, kfrq4, icpsmode, ilowest [, ipolarity]"
          "aout powershape ain, kShapeAmount [, ifullscale]" )
         (list
          "distort - Distort an audio signal via waveshaping and optional clipping"
          "distort1 - Modified hyperbolic tangent distortion"
          "flanger - A user controlled flanger"
          "harmon - Analyze an audio input and generate harmonizing voices in synchrony"
          "phaser1 - First-order allpass filters arranged in a series"
          "phaser2 - Second-order allpass filters arranged in a series"
          "harmon2 - Analyze an audio input and generate harmonizing voices in synchrony with formants preserved"
          "harmon3 - Analyze an audio input and generate harmonizing voices in synchrony with formants preserved"
          "harmon4 - Analyze an audio input and generate harmonizing voices in synchrony with formants preserved"
          "powershape - Waveshapes a signal by raising it to a variable exponent" )))

(setf *Special_Effects_menu* nil)
(csman2om *Special_Effects* '*Special_Effects_menu*)

(setf 
 *Convolution_&_Morph*
 (mapcar #'list
         (list
          "ares cross2 ain1, ain2, isize, ioverlap, iwin, kbias"
          "ares dconv asig, isize, ifn"
          "ftmorf kftndx, iftfn, iresfn")
         (list
          "cross2 - Cross synthesis using FFT's"
          "dconv - A direct convolution opcode"
          "ftmorf - Morphs between multiple ftables as specified in a list")))

(setf *Convolution_&_Morph_menu* nil)
(csman2om *Convolution_&_Morph* '*Convolution_&_Morph_menu*)

(setf *Convolution_&_Morph_menu*
      (list (car *Convolution_&_Morph_menu*)
            nil nil
            (append (cadddr *Convolution_&_Morph_menu*)
                    '(a_convolve a_pconvolve a_ftconv))
            nil))

(setf 
 *Reverberation*
 (mapcar #'list
         (list
          "ares alpass asig, krvt, ilpt [, iskip] [, insmps]"
          "a1, a2 babo asig, ksrcx, ksrcy, ksrcz, irx, iry, irz [, idiff] [, ifno]"
          "ares comb asig, krvt, ilpt [, iskip] [, insmps]"
          "aoutL, aoutR freeverb ainL, ainR, kRoomSize, kHFDamp [, iSRate] [, iSkip]"
          "ares nestedap asig, imode, imaxdel, idel1, igain1 [, idel2] [, igain2] [, idel3] [, igain3] [, istor]"
          "ares nreverb asig, ktime, khdif [, iskip] [,inumCombs] [, ifnCombs] [, inumAlpas] [, ifnAlpas]"
          "ares reverb2 asig, ktime, khdif [, iskip] [,inumCombs] [, ifnCombs] [, inumAlpas] [, ifnAlpas]"
          "ares reverb asig, krvt [, iskip]"
          "aoutL, aoutR reverbsc ainL, ainR, kfblvl, kfco [, israte] [, ipitchm] [, iskip]"
          "ares valpass asig, krvt, xlpt, imaxlpt [, iskip] [, insmps]"
          "ares vcomb asig, krvt, xlpt, imaxlpt [, iskip] [, insmps]")
         (list
          "alpass - Reverberates an input signal with a flat frequency response"
          "babo - A physical model reverberator"
          "comb - Reverberates an input signal with a colored frequency response"
          "freeverb - Opcode version of Jezar's Freeverb"
          "nestedap - Three different nested all-pass filters"
          "nreverb - A reverberator consisting of 6 parallel comb-lowpass filters"
          "reverb2 - A reverberator consisting of 6 parallel comb-lowpass filters"
          "reverb - Reverberates an input signal with a natural room frequency response"
          "reverbsc - 8 delay line stereo FDN reverb, based on work by Sean Costello"
          "valpass - Variably reverberates an input signal with a flat frequency response"
          "vcomb - Variably reverberates an input signal with a colored frequency response")))

(setf *Reverberation_menu* nil)
(csman2om *Reverberation* '*Reverberation_menu*)

(setf 
 *Sample_Level_Ops*
 (mapcar #'list
         (list
          "denorm a1 [ , a2] [ , a3] [...]"
          "ares diff asig [, iskip]"
          "kres diff ksig [, iskip]"
          "kres downsamp asig [, iwlen]"
          "ares fold asig, kincr"
          "ares integ asig [, iskip]"
          "kres integ ksig [, iskip]"
          "ares interp ksig [, iskip] [, imode]"
          "ares ntrpol asig1, asig2, kpoint [, imin] [, imax]"
          "ires ntrpol isig1, isig2, ipoint [, imin] [, imax]"
          "kres ntrpol ksig1, ksig2, kpoint [, imin] [, imax]"
          "ares samphold asig, agate [, ival] [, ivstor]"
          "kres samphold ksig, kgate [, ival] [, ivstor]"
          "ares upsamp ksig"
          "kval vaget kndx, avar"
          "vaset kval, kndx, avar")
         (list
          "denorm - Mixes low level noise to a list of a-rate signals"
          "diff - Modify a signal by differentiation"
          "diff - Modify a signal by differentiation"
          "downsamp - Modify a signal by down-sampling"
          "fold - Adds artificial foldover to an audio signal"
          "integ - Modify a signal by integration"
          "integ - Modify a signal by integration"
          "interp - Converts a control signal to an audio signal using linear interpolation"
          "ntrpol - Calculates the weighted mean value of two input signals"
          "ntrpol - Calculates the weighted mean value of two input signals"
          "ntrpol - Calculates the weighted mean value of two input signals"
          "samphold - Performs a sample-and-hold operation on its input"
          "samphold - Performs a sample-and-hold operation on its input"
          "upsamp - Modify a signal by up-sampling"
          "vaget - Access values of the current buffer of an a-rate variable by indexing"
          "vaset - Write value of into the current buffer of an a-rate variable by index")))

(setf *Sample_Level_Ops_menu* nil)
(csman2om *Sample_Level_Ops* '*Sample_Level_Ops_menu*)

(setf 
 *Math_Opcodes*
 (mapcar #'list
         (list
          "ares divz xa, xb, ksubst"
          "ires divz ia, ib, isubst"
          "kres divz ka, kb, ksubst"
          "ares pow aarg, kpow [, inorm]"
          "ires pow iarg, ipow [, inorm]"
          "kres pow karg, kpow [, inorm]"
          "ares product asig1, asig2 [, asig3] [...]"
          "ares sum asig1 [, asig2] [, asig3] [...]"
          "ares taninv2 ay, ax"
          "ires taninv2 iy, ix"
          "kres taninv2 ky, kx"
          "kres rms asig [, ihp] [, iskip]"
          "aout polynomial ain, k0 [, k1] [, k2] [...]"
          "aout chebyshevpoly ain, k0 [, k1] [, k2] [...]")
         (list
          "divz - Safely divides two numbers"
          "divz - Safely divides two numbers"
          "divz - Safely divides two numbers"
          "pow - Computes one argument to the power of another argument"
          "pow - Computes one argument to the power of another argument"
          "pow - Computes one argument to the power of another argument"
          "product - Multiplies any number of a-rate signals"
          "sum - Sums any number of a-rate signals"
          "taninv2 - Returns an arctangent"
          "taninv2 - Returns an arctangent"
          "taninv2 - Returns an arctangent"
          "rms - Determines the root-mean-square amplitude of an audio signal"
          "polynomial - Efficiently evaluates a polynomial of arbitrary order"
          "chebyshevpoly - Efficiently evaluates the sum of Chebyshev polynomials of arbitrary order")))

(setf *Math_Opcodes_menu* nil)
(csman2om *Math_Opcodes* '*Math_Opcodes_menu*)
(setf *Math_Opcodes_menu*
      (list (car *Math_Opcodes_menu*)
            nil nil
            (append '(make_cs_simple_operator cs_math_operation)
                    (cadddr *Math_Opcodes_menu*))
            nil))

(setf 
 *Comparators_&_Accumulators*
 (mapcar #'list
         (list
          "amax max ain1 [, ain2] [, ain3] [, ain4] [...]"
          "kmax max kin1 [, kin2] [, kin3] [, kin4] [...]"
          "knumkout max_k asig, ktrig, itype"
          "amax maxabs ain1 [, ain2] [, ain3] [, ain4] [...]"
          "kmax maxabs kin1 [, kin2] [, kin3] [, kin4] [...]"
          "maxabsaccum aAccumulator, aInput"
          "maxaccum aAccumulator, aInput"
          "amin min ain1 [, ain2] [, ain3] [, ain4] [...]"
          "kmin min kin1 [, kin2] [, kin3] [, kin4] [...]"
          "amin minabs ain1 [, ain2] [, ain3] [, ain4] [...]"
          "kmin minabs kin1 [, kin2] [, kin3] [, kin4] [...]"
          "minabsaccum aAccumulator, aInput"
          "minaccum aAccumulator, aInput"
          "ares mac asig1, ksig1 [, asig2] [, ksig2] [, asig3] [, ksig3] [...]"
          "ares maca asig1 , asig2 [, asig3] [, asig4] [, asig5] [...]" )
         (list
          "max - Produces a signal that is the maximum of any number of input signals"
          "max - Produces a signal that is the maximum of any number of input signals"
          "max_k - Local maximum (or minimum) value of an incoming asig signal"
          "maxabs - Produces a signal that is the maximum of the absolute values of any number of input signals"
          "maxabs - Produces a signal that is the maximum of the absolute values of any number of input signals"
          "maxabsaccum - Accumulates the maximum of the absolute values of audio signals"
          "maxaccum - Accumulates the maximum value of audio signals"
          "min - Produces a signal that is the minimum of any number of input signal"
          "min - Produces a signal that is the minimum of any number of input signal"
          "minabs - Produces a signal that is the minimum of the absolute values of any number of input signals"
          "minabs - Produces a signal that is the minimum of the absolute values of any number of input signals"
          "minabsaccum - Accumulates the minimum of the absolute values of audio signals"
          "minaccum - Accumulates the minimum value of audio signals"
          "mac - Multiplies and accumulates a- and k-rate signals"
          "maca - Multiply and accumulate a-rate signals only" )))

(setf *Comparators_&_Accumulators_menu* nil)
(csman2om *Comparators_&_Accumulators* '*Comparators_&_Accumulators_menu*)

(setf 
 *Signal_Input*
 (mapcar #'list
         (list
          "sndload Sfname [, ifmt] [, ichns] [, isr] [, ibas] [, iamp] [, istrt] [, ilpmod] [, ilps] [, ilpe]")
         (list
          "sndload - Loads a sound file into memory for use by loscilx")))

(setf *Signal_Input_menu* nil)
(csman2om *Signal_Input* '*Signal_Input_menu*)
(setf *Signal_Input_menu*
      (list (car *Signal_Input_menu*)
            nil nil
            (append '(a_soundin a_diskin a_diskin2)
                    (cadddr *Signal_Input_menu*))
            nil))

(setf 
 *Signal_Output_menu*
 '("signal output" nil nil (cs_out cs_easy-out) nil))

(setf 
 *Table_Read/Write*
 (mapcar #'list
         (list
          "tablecopy kdft, ksft"
          "tablegpw kfn"
          "tableicopy idft, isft"
          "tableigpw ifn"
          "tableimix idft, idoff, ilen, is1ft, is1off, is1g, is2ft, is2off, is2g"
          "tableiw isig, indx, ifn [, ixmode] [, ixoff] [, iwgmode]"
          "tablemix kdft, kdoff, klen, ks1ft, ks1off, ks1g, ks2ft, ks2off, ks2g"
          "ares tablera kfn, kstart, koff"
          "tablew asig, andx, ifn [, ixmode] [, ixoff] [, iwgmode]"
          "tablew isig, indx, ifn [, ixmode] [, ixoff] [, iwgmode]"
          "tablew ksig, kndx, ifn [, ixmode] [, ixoff] [, iwgmode]"
          "kstart tablewa kfn, asig, koff"
          "tablewkt asig, andx, kfn [, ixmode] [, ixoff] [, iwgmode]"
          "kout tabmorph kindex, kweightpoint, ktabnum1, ktabnum2, ifn1, ifn2 [, ifn3] [...]"
          "aout tabmorpha aindex, aweightpoint, atabnum1, atabnum2, ifn1, ifn2 [, ifn3] [...]"
          "aout tabmorphak aindex, kweightpoint, ktabnum1, ktabnum2, ifn1, ifn2 [, ifn3] [...]"
          "kout tabmorphi kindex, kweightpoint, ktabnum1, ktabnum2, ifn1, ifn2 [, ifn3] [...]"
          "tabrec   ktrig_start, ktrig_stop, knumtics, kfn, kin1 [, kin2] [...]"
          "tabplay  ktrig, knumtics, kfn, kout1 [, kout2] [...]"
          "ares tableikt xndx, kfn [, ixmode] [, ixoff] [, iwrap]"
          "kres tableikt kndx, kfn [, ixmode] [, ixoff] [, iwrap]"
          "ares tablekt xndx, kfn [, ixmode] [, ixoff] [, iwrap]"
          "kres tablekt kndx, kfn [, ixmode] [, ixoff] [, iwrap]"
          "ares tablexkt xndx, kfn, kwarp, iwsize [, ixmode] [, ixoff] [, iwrap]")
         (list
          "tablecopy - Simple, fast table copy opcode"
          "tablegpw - Writes a table's guard point"
          "tableicopy - Simple, fast table copy opcode"
          "tableigpw - Writes a table's guard point"
          "tableimix - Mixes two tables"
          "tableiw - Change the contents of existing function tables"
          "tablemix - Mixes two tables"
          "tablera - Reads tables in sequential locations"
          "tablew - Change the contents of existing function tables"
          "tablew - Change the contents of existing function tables"
          "tablew - Change the contents of existing function tables"
          "tablewa - Writes tables in sequential locations"
          "tablewkt - Change the contents of existing function tables"
          "tabmorph - Allow morphing between a set of tables"
          "tabmorpha - Allow morphing between a set of tables at audio rate with interpolation"
          "tabmorphak - Allow morphing between a set of tables at audio rate with interpolation"
          "tabmorphi - Allow morphing between a set of tables with interpolation"
          "tabrec - Recording of control signals"
          "tabplay - Playing-back control signals"
          "tableikt - Provides k-rate control over table numbers"
          "tableikt - Provides k-rate control over table numbers"
          "tablekt - Provides k-rate control over table numbers"
          "tablekt - Provides k-rate control over table numbers"
          "tablexkt - Reads function tables with linear, cubic, or sinc interpolation")))

(setf *Table_Read/Write_menu* nil)
(csman2om *Table_Read/Write* '*Table_Read/Write_menu*)

(setf *Table_Read/Write_menu*
      (list (car *Table_Read/Write_menu*)
            nil nil
            (append (cadddr *Table_Read/Write_menu*)
                    '(cs_gen_info))
            nil))

(setf 
 *Spectral_Processing*
 (mapcar #'list
         (list
          "tableseg ifn1, idur1, ifn2 [, idur2] [, ifn3] [...]"
          "ares pvadd ktimpnt, kfmod, ifilcod, ifn, ibins [, ibinoffset] [, ibinincr] [, iextractmode] [, ifreqlim] [, igatefn]"
          "pvbufread ktimpnt, ifile"
           "ares pvcross ktimpnt, kfmod, ifile, kampscale1, kampscale2 [, ispecwp]"
           "ares pvinterp ktimpnt, kfmod, ifile, kfreqscale1, kfreqscale2, kampscale1, kampscale2, kfreqinterp, kampinterp"
           "ares pvoc ktimpnt, kfmod, ifilcod [, ispecwp] [, iextractmode] [, ifreqlim] [, igatefn]"
           "kfreq, kamp pvread ktimpnt, ifile, ibin"
           "tablexseg ifn1, idur1, ifn2 [, idur2] [, ifn3] [...]"
           "ares vpvoc ktimpnt, kfmod, ifile [, ispecwp] [, ifn]"
           "ares lpfreson asig, kfrqratio"
           "lpinterp islot1, islot2, kmix"
           "krmsr, krmso, kerr, kcps lpread ktimpnt, ifilcod [, inpoles] [, ifrmrate]"
           "ares lpreson asig"
           "lpslot islot"
           "idata ATSinfo iatsfile, ilocation"
           "kfreq, kamp ATSread ktimepnt, iatsfile, ipartial"
           "kenergy ATSreadnz ktimepnt, iatsfile, iband"
           "ATSbufread ktimepnt, kfmod, iatsfile, ipartials [, ipartialoffset] [, ipartialincr]"
           "kamp ATSinterpread kfreq"
           "kfrq, kamp ATSpartialtap ipartialnum"
           "ar ATSadd ktimepnt, kfmod, iatsfile, ifn, ipartials [, ipartialoffset] [, ipartialincr] [, igatefn]"
           "ar ATSaddnz ktimepnt, iatsfile, ibands [, ibandoffset] [, ibandincr]"
           "ar ATScross ktimepnt, kfmod, iatsfile, ifn, kmylev, kbuflev, ipartials [, ipartialoffset] [, ipartialincr]"
           "ar ATSsinnoi ktimepnt, ksinlev, knzlev, kfmod, iatsfile, ipartials [, ipartialoffset] [, ipartialincr]"
           "lorisread ktimpnt, ifilcod, istoreidx, kfreqenv, kampenv, kbwenv [, ifadetime]"
           "lorismorph isrcidx, itgtidx, istoreidx, kfreqmorphenv, kampmorphenv, kbwmorphenv"
           "ar lorisplay ireadidx, kfreqenv, kampenv, kbwenv"
           "wsig spectrum xsig, iprd, iocts, ifrqa [, iq] [, ihann] [, idbout] [, idsprd] [, idsinrs]"
           "wsig specscal wsigin, ifscale, ifthresh"
           "wsig spechist wsigin"
           "wsig specfilt wsigin, ifhtim"
           "wsig specaddm wsig1, wsig2 [, imul2]" 
           "fsiglow, fsighi trsplit fin, ksplit [, kgainlow] [, kgainhigh]"
           "fsig trshift fin, kpshift [, kgain]"
           "fsig trmix fin1, fin2"
           "fsig, kfr,kamp trlowest fin1, kscal"
           "fsig, kfr,kamp trhighest fin1, kscal"
           "fsig trfilter fin, kamnt, ifn"
           "fsig trcross fin1, fin2, ksearch, kdepth [,kmode]"
           "asig sinsyn fin, kscal,  kmaxtracks, ifn"
           "asig resyn fin, kscal, kpitch, kmaxtracks, ifn"
           "ares pvsynth fsrc, [iinit]"
           "fsig pvsvoc famp, fexc, kdepth, kgain"
           "fsig pvstencil fsigin, kgain, klevel, iftable"
           "kfr, kamp pvspitch fsig, kthresh"
           "fsig pvsosc kamp, kfreq, ktype, isize [, ioverlap] [, iwinsize] [, iwintype] [, iformat]"
           "pvsout fsig, kchan"
           "fsig pvsmooth fsigin, kacf, kfcf"
           "fsig pvsmorph fsig1, fsig2, kampint, kfrqint"
           "fsig pvsmix fsigin1, fsigin2"
           "fsig pvsmaska fsrc, ifn, kdepth"
           "fsig pvsinit isize [,iolap] [,iwinsize] [,iwintype] [, iformat]"
           "ioverlap, inumbins, iwinsize, iformat pvsinfo fsrc"
           "ffr, fphs pvsifd ain, ifftsize, ihopsize, iwintype [,iscal]"
           "fsig pvshift fsigin, kshift, klowest [, ikeepform] [, igain]"
           "fsig pvsfreeze fsigin, kfreeza, kfreezf"
           "fsig pvsfilter fsigin, fsigfil, kdepth [, igain]"
           "fsig pvsdemix fleft, fright, kpos, kwidth, ipoints"
           "fsig pvscross fsrc, fdest, kamp1, kamp2"
           "kcent pvscent fsig"
           "fsig pvsbufread  ktime, khandle [, ilo] [, ihi]"
           "ihandle, ktime  pvsbuffer fsig, ilen"
           "fsig pvsblur fsigin, kblurtime, imaxdel"
           "kamp, kfr pvsbin fsig, kbin"
           "fsig pvsbandr fsigin, xlowcut, xlowfull, xhighfull, xhighcut [, ktype]"
           "fsig pvsbandp fsigin, xlowcut, xlowfull, xhighfull, xhighcut [, ktype]"
           "fsig pvsarp fsigin, kbin, kdepth, kgain"
           "fsig pvsanal ain, ifftsize, ioverlap, iwinsize, iwintype [, iformat] [, iinit]"
           "ares pvsadsyn fsrc, inoscs, kfmod [, ibinoffset] [, ibinincr] [, iinit]"
           "fsig binit fin, isize"
           "fsig pvscale fsigin, kscal [, ikeepform] [, igain]")
         (list
          "tableseg - Creates a new function table by making linear segments between values in stored function tables"
          "pvadd - Reads from a pvoc file and uses the data to perform additive synthesis"
          "pvbufread - Reads from a phase vocoder analysis file and makes the retrieved data available"
          "pvcross - Applies the amplitudes from one phase vocoder analysis file to the data from a second file"
          "pvinterp - Interpolates between the amplitudes and frequencies of two phase vocoder analysis files"
          "pvoc - Implements signal reconstruction using an fft-based phase vocoder"
          "pvread - Reads from a phase vocoder analysis file and returns the frequency and amplitude from a single analysis channel or bin"
          "tablexseg - Creates a new function table by making exponential segments between values in stored function tables"
          "vpvoc - Implements signal reconstruction using an fft-based phase vocoder and an extra envelope"
          "lpfreson - Resynthesises a signal from the data passed internally by a previous lpread, applying formant shifting"
          "lpinterp - Computes a new set of poles from the interpolation between two analysis"
          "lpread - Reads a control file of time-ordered information frames"
          "lpreson - Resynthesises a signal from the data passed internally by a previous lpread"
          "lpslot - Selects the slot to be use by further lp opcodes"
          "ATSinfo - reads data out of the header of an ATS file"
          "ATSread - reads data from an ATS file"
          "ATSreadnz - reads data from an ATS file"
          "ATSbufread - reads data from and ATS data file and stores it in an internal data table of frequency, amplitude pairs"
          "ATSinterpread - allows a user to determine the frequency envelope of any ATSbufread"
          "ATSpartialtap - returns a frequency, amplitude pair from an ATSbufread opcode"
          "ATSadd - uses the data from an ATS analysis file to perform additive synthesis"
          "ATSaddnz - uses the data from an ATS analysis file to perform noise resynthesis"
          "ATScross - perform cross synthesis from ATS analysis files"
          "ATSsinnoi - uses the data from an ATS analysis file to perform resynthesis"
          "lorisread - Imports a set of bandwidth-enhanced partials from a SDIF-format data file, applying control-rate frequency, amplitude, and bandwidth scaling envelopes, and stores the modified partials in memory"
          "lorismorph - Morphs two stored sets of bandwidth-enhanced partials and stores a new set of partials representing the morphed sound"
          "lorisplay - renders a stored set of bandwidth-enhanced partials using the method of Bandwidth-Enhanced Additive Synthesis implemented in the Loris software"
          "spectrum - Generate a constant-Q, exponentially-spaced DFT"
          "specscal - Scales an input spectral datablock with spectral envelopes"
          "spechist - Accumulates the values of successive spectral frames"
          "specfilt - Filters each channel of an input spectrum"
          "specaddm - Perform a weighted add of two input spectra" 
          "trsplit - Streaming partial track frequency splitting"
          "trshift - Streaming partial track frequency scaling"
          "trmix - Streaming partial track mixing"
          "trlowest - Extracts the lowest-frequency track from a streaming track input signal"
          "trhighest - Extracts the highest-frequency track from a streaming track input signal"
          "trfilter - Streaming partial track filtering"
          "trcross - Streaming partial track cross-synthesis"
          "sinsyn - Streaming partial track additive synthesis with cubic phase interpolation"
          "resyn - Streaming partial track additive synthesis with cubic phase interpolation with pitch control and support for timescale-modified input"
          "pvsynth - Resynthesise using a FFT overlap-add"
          "pvsvoc - Combine the spectral envelope of one fsig with the excitation (frequencies) of another"
          "pvstencil - Transforms a pvoc stream according to a masking function table"
          "pvspitch - Track the pitch and amplitude of a PVS signal"
          "pvsosc - PVS-based oscillator simulator"
          "pvsout - Write a fsig to the pvs output bus"
          "pvsmooth - Smooth the amplitude and frequency time functions of a pv stream using parallel 1st order lowpass IIR filters with time-varying cutoff frequency"
          "pvsmorph - Performs morphing (or interpolation) between two source fsigs"
          "pvsmix - Mix 'seamlessly' two pv signals"
          "pvsmaska - Modify amplitudes using a function table, with dynamic scaling"
          "pvsinit - Initialise a spectral (f) variable to zero"
          "pvsinfo - Get information from a PVOC-EX formatted source"
          "pvsifd - Instantaneous Frequency Distribution, magnitude and phase analysis"
          "pvshift - Shift the frequency components of a pv stream, stretching/compressing its spectrum"
          "pvsfreeze - Freeze the amplitude and frequency time functions of a pv stream according to a control-rate trigger"
          "pvsfilter - Multiply amplitudes of a pvoc stream by those of a second pvoc stream, with dynamic scaling"
          "pvsdemix - Spectral azimuth-based de-mixing of stereo sources"
          "pvscross - Performs cross-synthesis between two source fsigs"
          "pvscent - Calculate the spectral centroid of a signal"
          "pvsbufread - This opcode creates and writes to a circular buffer for streaming PV signals"
          "pvsbuffer - This opcode creates and writes to a circular buffer for streaming PV signals"
          "pvsblur - Average the amp/freq time functions of each analysis channel for a specified time" 
          "pvsbin - Obtain the amp and freq values off a PVS signal bin"
          "pvsbandr - A band reject filter working in the spectral domain"
          "pvsbandp - A band pass filter working in the spectral domain"
          "pvsarp - Arpeggiate the spectral components of a streaming pv signal"
          "pvsanal - Generate an fsig from a mono audio source ain, using phase vocoder overlap-add analysis"
          "pvsadsyn - Resynthesize using a fast oscillator-bank"
          "binit - PVS tracks to amplitude+frequency conversion"
          "pvscale - Scale the frequency components of a pv stream")))

(setf *Spectral_Processing_menu* nil)
(csman2om *Spectral_Processing* '*Spectral_Processing_menu*)

(om::defmethod! lpanal ((sound t) (outfile t)
                        &optional 
                        (alternate_storage nil) 
                        (sample_rate nil)
                        (channel nil)
                        (begin nil)
                        (duration nil)
                        (npoles nil)
                        (hopsize nil)
                        (string nil)
                        (mincps nil)
                        (maxcps nil))
                        
  :icon 606
  :indoc '("a sound" "name of the output file"
           "asks lpanal to write a file with filter poles values rather than the usual filter coefficient files"
           "sampling rate of the audio input file. This will over-ride the srate of the soundfile header, which otherwise applies"
           "channel number sought. The default is 1"
           "beginning time (in seconds) of the audio segment to be analyzed"
           "duration (in seconds) of the audio segment to be analyzed"
           "number of poles for analysis. The default is 34, the maximum 50"
           "hop size (in samples) between frames of analysis"
           "text for the comments field of the lpfile header"
           "lowest frequency (in Hz) of pitch tracking"
           "highest frequency (in Hz) of pitch tracking")
           
  :doc "lpanal performs both lpc and pitch-tracking analysis on a soundfile to produce a time-ordered sequence of frames of control information suitable for Csound resynthesis. Analysis is conditioned by the control flags below. A space is optional between the flag and its value.

-a - [alternate storage] asks lpanal to write a file with filter poles values rather than the usual filter coefficient files. When lpread / lpreson are used with pole files, automatic stabilization is performed and the filter should not get wild. (This is the default in the Windows GUI) - Changed by Marc Resibois.

-s srate - sampling rate of the audio input file. This will over-ride the srate of the soundfile header, which otherwise applies. If neither is present, the default is 10000.

-c channel - channel number sought. The default is 1.

-b begin - beginning time (in seconds) of the audio segment to be analyzed. The default is 0.0

-d duration - duration (in seconds) of the audio segment to be analyzed. The default of 0.0 means to the end of the file.

-p npoles - number of poles for analysis. The default is 34, the maximum 50.

-h hopsize - hop size (in samples) between frames of analysis. This determines the number of frames per second (srate / hopsize) in the output control file. The analysis framesize is hopsize * 2 samples. The default is 200, the maximum 500.

-C string - text for the comments field of the lpfile header. The default is the null string.

-P mincps - lowest frequency (in Hz) of pitch tracking. -P0 means no pitch tracking.

-Q maxcps - highest frequency (in Hz) of pitch tracking. The narrower the pitch range, the more accurate the pitch estimate. The defaults are -P70, -Q200."

  :menuins `((2 (("yes" t)
                 ("no" nil))))

  :initvals (list nil (om::nth-random *default_sf_out_name*) nil nil)

  (let ((out (outfile! outfile "lpa")))

    (progn
      (om::om-shell 
       (om::string+
        (format nil "~S" (om::om-path2cmdpath om::*CSOUND-PATH*))
        " -U lpanal"
        (if alternate_storage " -a" "")
        (if sample_rate (format nil " -s~D" sample_rate) "")
        (if channel (format nil " -c~D" channel) "")
        (if begin (format nil " -b~D" begin) "")
        (if duration (format nil " -d~D" duration) "")
        (if npoles (format nil " -p~D" npoles) "")
        (if hopsize (format nil " -h~D" hopsize) "")
        (if string (format nil " -C~S" string) "")
        (if mincps (format nil " -P~D" mincps) "")
        (if maxcps (format nil " -Q~D" maxcps) "")
        " "
        (2string (inputsndfile sound)) 
        " "
        (2string out)))
      out)))
    

(om::defmethod! pvanal ((sound t) (outfile t)
                        &optional   
                        (sample_rate nil)
                        (channel nil)
                        (begin nil)
                        (duration nil)
                        (frmsiz nil)
                        (windfact nil)
                        (hopsize nil)
                        (Hamming? nil)
                        (Kaiser? nil)
                        (beta nil))
                                     
  :icon 606
  :indoc '("a sound" "name of the output file"
           "sampling rate of the audio input file. This will over-ride the srate of the soundfile header, which otherwise applies"
           "channel number sought. The default is 1"
           "beginning time (in seconds) of the audio segment to be analyzed"
           "duration (in seconds) of the audio segment to be analyzed"
           "STFT frame size, the number of samples in each Fourier analysis frame"
           "Window overlap factor"
           "hop size (in samples) between frames of analysis"
           "Use a Hamming window instead of the default von Hann window"
           "se a Kaiser window instead of the default von Hann window"
           "Set the beta parameter for any Kaiser window used to the floating point value beta")
           
  :doc "pvanal converts a soundfile into a series of short-time Fourier transform (STFT) frames at regular timepoints (a frequency-domain representation). The output file can be used by pvoc to generate audio fragments based on the original sample, with timescales and pitches arbitrarily and dynamically modified. Analysis is conditioned by the flags below. A space is optional between the flag and its argument.

-s srate -- sampling rate of the audio input file. This will over-ride the srate of the soundfile header, which otherwise applies. If neither is present, the default is 10000.

-c channel -- channel number sought. The default is 1.

-b begin -- beginning time (in seconds) of the audio segment to be analyzed. The default is 0.0

-d duration -- duration (in seconds) of the audio segment to be analyzed. The default of 0.0 means to the end of the file.

-n frmsiz -- STFT frame size, the number of samples in each Fourier analysis frame. Must be a power of two, in the range 16 to 16384. For clean results, a frame must be larger than the longest pitch period of the sample. However, very long frames result in temporal \"smearing\" or reverberation. The bandwidth of each STFT bin is determined by sampling rate / frame size. The default framesize is the smallest power of two that corresponds to more than 20 milliseconds of the source (e.g. 256 points at 10 kHz sampling, giving a 25.6 ms frame).

-w windfact -- Window overlap factor. This controls the number of Fourier transform frames per second. Csound's pvoc will interpolate between frames, but too few frames will generate audible distortion; too many frames will result in a huge analysis file. A good compromise for windfact is 4, meaning that each input point occurs in 4 output windows, or conversely that the offset between successive STFT frames is framesize/4. The default value is 4. Do not use this flag with -h.

-h hopsize -- STFT frame offset. Converse of above, specifying the increment in samples between successive frames of analysis (see also lpanal). Do not use with -w.

-H -- Use a Hamming window instead of the default von Hann window.

-K -- Use a Kaiser window instead of the default von Hann window. The Kaiser parameter default is 6.8, but can be set with the -B option.

-B beta -- Set the beta parameter for any Kaiser window used to the floating point value beta"

  :initvals (list nil (om::nth-random *default_sf_out_name*) nil nil)
  :menuins `((9 (("yes" t)
                 ("no" nil)))
             (10 (("yes" t)
                  ("no" nil))))
  
  (let ((out (outfile! outfile "pva")))
 
    (progn
      (om::om-shell 
       (om::string+
        (format nil "~S" (om::om-path2cmdpath om::*CSOUND-PATH*))
        " -U pvanal"
        
        (if sample_rate (format nil " -s~D" sample_rate) "")
        (if channel (format nil " -c~D" channel) "")
        (if begin (format nil " -b~D" begin) "")
        (if duration (format nil " -d~D" duration) "")
        (if frmsiz (format nil " -n~D" frmsiz) "")
        (if windfact (format nil " -w~D" windfact) "")
        (if hopsize (format nil " -h~D" hopsize) "")
        (if Hamming? " -H" "")
        (if Kaiser? " -H" "")
        (if beta (format nil " -B~D" beta) "")
        " "
        (2string (inputsndfile sound)) 
        " "
        (2string out)))
      out)))

(om::defmethod! cvanal ((sound t) (outfile t)
                        &optional   
                        (sample_rate nil)
                        (channel nil)
                        (begin nil)
                        (duration nil))
                                                           
  :icon 606
  :indoc '("a sound" "name of the output file"
           "sampling rate of the audio input file. This will over-ride the srate of the soundfile header, which otherwise applies"
           "channel number sought. If omitted, the default is to process all channels. If a value is given, only the selected channel will be processed"
           "beginning time (in seconds) of the audio segment to be analyzed"
           "duration (in seconds) of the audio segment to be analyzed")     
           
  :doc "converts a soundfile into a single Fourier transform frame. The output file can be used by the convolve operator to perform Fast Convolution between an input signal and the original impulse response. Analysis is conditioned by the flags below. A space is optional between the flag and its argument"

  :initvals (list nil (om::nth-random *default_sf_out_name*) nil nil nil nil)

  (let ((out (outfile! outfile "cv")))
 
    (progn
      (om::om-shell 
       (om::string+
        (format nil "~S" (om::om-path2cmdpath om::*CSOUND-PATH*))
        " -U cvanal"
        
        (if sample_rate (format nil " -s~D" sample_rate) "")
        (if channel (format nil " -c~D" channel) "")
        (if begin (format nil " -b~D" begin) "")
        (if duration (format nil " -d~D" duration) "")
        " "
        (2string (inputsndfile sound)) 
        " "
        (2string out)))
      out)))

(om::defmethod! hetro ((sound t) (outfile t)
                       &optional   
                       (sample_rate nil) (channel nil)
                       (begin nil) (duration nil)
                       (begfreq nil)
                       (partials nil)
                       (maxamp nil) (minamp nil)
                       (brkpts nil)
                       (cutfreq nil))
                                                           
  :icon 606
  :indoc '("a sound" "name of the output file"
           "sampling rate of the audio input file. This will over-ride the srate of the soundfile header, which otherwise applies"
           "channel number sought. If omitted, the default is to process all channels. If a value is given, only the selected channel will be processed"
           "beginning time (in seconds) of the audio segment to be analyzed"
           "duration (in seconds) of the audio segment to be analyzed" 
           "estimated starting frequency of the fundamental, necessary to initialize the filter analysis. The default is 100 (cps)"
           "number of harmonic partials sought in the audio file. Default is 10, maximum is a function of memory available"
           "maximum amplitude summed across all concurrent tracks. The default is 32767"
           "amplitude threshold below which a single pair of amplitude/frequency tracks is considered dormant and will not contribute to output summation. Typical values: 128 (48 db down from full scale), 64 (54 db down), 32 (60 db down), 0 (no thresholding). The default threshold is 64 (54 db down)"
           "initial number of analysis breakpoints in each amplitude and frequency track, prior to thresholding (-m) and linear breakpoint consolidation. The initial points are spread evenly over the duration. The default is 256"
           "substitute a 3rd order Butterworth low-pass filter with cutoff frequency cutfreq (in Hz), in place of the default averaging comb filter. The default is 0 (don't use)")
           
  :doc "hetro takes an input soundfile, decomposes it into component sinusoids, and outputs a description of the components in the form of breakpoint amplitude and frequency tracks. Analysis is conditioned by the control flags below. A space is optional between flag and value"

  :initvals (list nil (om::nth-random *default_sf_out_name*) nil nil nil nil)

  (let ((out (outfile! outfile "cv")))
 
    (progn
      (om::om-shell 
       (om::string+
        (format nil "~S" (om::om-path2cmdpath om::*CSOUND-PATH*))
        " -U hetro"
        
        (if sample_rate (format nil " -s~D" sample_rate) "")
        (if channel (format nil " -c~D" channel) "")
        (if begin (format nil " -b~D" begin) "")
        (if duration (format nil " -d~D" duration) "")
        (if begfreq (format nil " -f~D" begfreq) "")
        (if partials (format nil " -h~D" partials) "")
        (if maxamp (format nil " -M~D" maxamp) "")
        (if minamp (format nil " -m~D" minamp) "")
        (if brkpts (format nil " -n~D" brkpts) "")
        (if cutfreq (format nil " -l~D" cutfreq) "")
        " "
        (2string (inputsndfile sound)) 
        " "
        (2string out)))
      out)))

(om::defmethod! atsa ((sound t) (outfile t)
                       &optional   
                       (start nil)
                       (duration nil)
                       (lowest_frequency nil)
                       (highest_frequency nil)
                       (frequency_deviation nil)
                       (window_cycles nil)
                       (window_type nil)
                       (hop_size nil)
                       (lowest_magnitude nil)
                       (track_length nil)
                       (min_segment_length nil)
                       (min_gap_length nil)
                       (SMR_threshold nil)
                       (min_segment_SMR nil)
                       (last_peak_contribution nil)
                       (SMR_contribution nil)
                       (File_Type nil))                                        
  :icon 606
  :indoc '("Start (secs.): the starting time of the analysis in seconds"
           "Duration (secs.): the duration time of the analysis in seconds. A zero means the whole duration of the input sound file"
           "Lowest Frequency (Hz.): this parameter will partially determine the size of the Analysis Window to be used. To compute the size of the Analysis Window, the period of the Lowest Frequency in samples (SR / LF) is multiplied by the number of cycles of it the user wants to fit in the Analysis Window (see parameter 6). This value is rounded to the next power of two to determine the size of the FFT for the analysis. The remaining samples are zero-padded. If the signal is a single, harmonic sound, then the value of the Lowest Frequency should be its fundamental frequency or a sub-harmonic of it. If it is not harmonic, then its lowest significant frequency component may be a good starting value"
           "Highest Frequency (Hz.): highest frequency to be taken into account for Peak Detection. Once it is determined that no relevant information is found beyond a certain frequency, the analysis may be faster and more accurate setting the Highest Frequency parameter to that value"
           "Frequency Deviation (Ratio): frequency deviation allowed for each peak in the Peak Continuation Algorithm, as a ratio of the frequency involved. For instance, considering a peak at 440 Hz and a Deviation of .1 will produce that the Peak Continuation Algorithm will only try to find candidates for its continuation between 396 and 484 Hz (10% above and below the frequency of the peak). A small value is likely to produce more trajectories whilst a large value will reduce them, but at the cost of rendering information difficult to be further processed"
           "Number of Cycles of Lowest Frequency to fit in Analysis Window: this will also partially determine the size of the Fourier Analysis Window to be used. See Parameter 3. For single harmonic signals, it is supposed to be more than one (typically 4)"
           "Window Type: the shape of the smoothing function to be used for the Fourier Analysis. There are four choices available at present: Blackman, Blackman-Harris, Von Hann, and Hanning. Precise specifications about them are easily found on D.S.P. bibliography"
           "Hop Size (Ratio): size of the gap between one Analysis Window and the next expressed as a ratio of the Window Size. For instance, a Hop Size value of .25 will 'jump' by 512 samples (Windows will overlap for a 75% of their size). This parameter will also determine the size of the analysis frames obtained. Signals that change their spectra very fast (such as Speech sounds) may need a high frame rate in order to properly track their changes"
           "Amplitude Threshold (dB): the highest amplitude value to be taken into account for Peak Detection"
           "Track Length (Frames): The Peak Continuation Algorithm will 'look-back' by Length frames in order to do its job better, preventing frequency trajectories from curving too much and loosing stability. However, a large value for this parameter will slow down the analysis significantly"
           "Minimal Segment Length (Frames): once the analysis is done, the spectral data can be further 'cleaned' up during post-processing. Trajectories shorter than this value are suppressed if their average SMR is below Minimal Segment SMR (see parameters 16 and 14). This might help to avoid non-relevant sudden changes while keeping a high frame rate, reducing also the number of intermittent sinusoids during synthesis"
           "Minimal Gap Length (Frames): as parameter 11, this one is also used to clean up the data during post-processing. In this case, gaps (zero amplitude values, i.e. theoretical 'silence') longer than Length frames are filled up with amplitude/frequency values obtained by linear interpolation of the adjacent active frames. This parameter prevents sudden interruptions of stable trajectories while keeping a high frame rate"
           "SMR Threshold (dB SPL): also a post-processing parameter, the SMR Threshold is used to eliminate partials with low averages"
           "Minimal Segment SMR (dB SPL): this parameter is used in combination with parameter 11. Short segments with SMR average below this value will be removed during post-processing"
           "Last Peak Contribution (0 to 1): as explained in Parameter 10, the Peak Continuation Algorithm 'looks-back' several number of frames to do its job better. This parameter will help to weight the contribution of the first precedent peak over the others. A zero value means that all precedent peaks (to the size of Parameter 10) are equally taken in account"
           "SMR Contribution (0 to 1): In addition to the proximity in frequency of the peaks, the ATS Peak Continuation Algorithm may use psycho-acoustic information (the Signal-to-Mask-Ratio, or SMR) to improve the perceptual results. This parameter indicates how much the SMR information is used during tracking. For instance, a value of .5 makes the Peak Continuation Algorithm to use a 50% of SMR information and a 50% of Frequency Proximity information to decide which is the best candidate to continue a sinusoidal track"
           "Options: 1=amp.and freq. only, 2=amp.,freq. and phase, 3=amp.,freq. and residual, 4=amp.,freq.,phase, and residual")
          
  :doc "ATS analysis for use with the Csound ATS Resynthesis opcodes"

  :initvals (list nil (om::nth-random *default_sf_out_name*) nil nil nil nil)

  (let* ((fun #'(lambda (sx)
                  (let ((out (outfile! outfile "ats")))
                    (progn
                      (om::om-shell 
                       (om::string+
                        (format nil "~S" (om::om-path2cmdpath om::*CSOUND-PATH*))
                        " -U atsa"
                        (if start (format nil " -b~D" start) "")
                        (if duration (format nil " -e~D" duration) "")
                        (if lowest_frequency (format nil " -l~D" lowest_frequency) "")
                        (if highest_frequency (format nil " -H~D" highest_frequency) "")
                        (if frequency_deviation (format nil " -d~D" frequency_deviation) "")
                        (if window_cycles (format nil " -c~D" window_cycles) "")
                        (if window_type (format nil " -w~D" window_type) "")
                        (if hop_size (format nil " -h~D" hop_size) "")
                        (if lowest_magnitude (format nil " -m~D" lowest_magnitude) "")
                        (if track_length (format nil " -t~D" track_length) "")
                        (if min_segment_length (format nil " -s~D" min_segment_length) "")
                        (if min_gap_length (format nil " -g~D" min_gap_length) "")
                        (if SMR_threshold (format nil " -T~D" SMR_threshold) "")
                        (if min_segment_SMR (format nil " -S~D" min_segment_SMR) "")
                        (if last_peak_contribution (format nil " -P~D" last_peak_contribution) "")
                        (if SMR_contribution (format nil " -M~D" SMR_contribution) "")
                        (if File_Type (format nil " -F~D" File_Type) "")     
                        " "
                        (2string sx) 
                        " "
                        (2string out)))
                      out))))
         (snd (inputsndfile sound))
         (n (om::om-sound-n-channels snd)))
    (if (= n 1)
        (funcall fun snd)
      (mapcar fun
              (split_soundfile snd)))))

(setf 
 *Analysis*
 (mapcar #'list
         (list
          "ktemp tempest kin, iprd, imindur, imemdur, ihp, ithresh, ihtim, ixfdbak, istartempo, ifn [, idisprd] [, itweek]"
          "kcps, kamp ptrack asig, ihopsize [,ipeaks]"
          "kcps, krms pitchamdf asig, imincps, imaxcps [, icps] [, imedi] [, idowns] [, iexcps] [, irmsmedi]"
          "koct, kamp pitch asig, iupdte, ilo, ihi, idbthresh [, ifrqs] [, iconf] [, istrt] [, iocts] [, iq] [, inptls] [, irolloff] [, iskip]"
          "ftrks partials ffr, fphs, kthresh, kminpts, kmaxgap, imaxtracks"
          "ares follow asig, idt"
          "ares follow2 asig, katt, krel")
         (list
          "tempest - Estimate the tempo of beat patterns in a control signal"
          "ptrack - Tracks the pitch of a signal"
          "pitchamdf - Follows the pitch of a signal based on the AMDF method"
          "pitch - Tracks the pitch of a signal"
          "partials - Partial track spectral analysis"
          "follow - Envelope follower unit generator"
          "follow2 - Another controllable envelope extractor")))

(setf *Analysis_menu* nil)
(csman2om *Analysis* '*Analysis_menu*)

(setf *Analysis_menu*
      (list (car *Analysis_menu*)
            nil nil
            (append (cadddr *Analysis_menu*)
                    '(lpanal pvanal cvanal hetro atsa))
            nil))

(setf 
 *Tools*
 (mapcar #'list
         (list
          "ktrig  metro  kfreq [, initphase]")
         (list
          "metro - Trigger Metronome")))

(setf *Tools_menu* nil)
(csman2om *Tools* '*Tools_menu*)

(setf *Tools_menu*
      (list (car *Tools_menu*)
            nil nil
            (append (cadddr *Tools_menu*)
                    '(csif cs_change_rate))
            nil))

