(in-package "OM-AURO")

;:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:- User Defined Opcodes -:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:;

(defun cs_udo (stringa)
  (make-instance 'cs_opcode
                 :opcode_name "opcode"
                 :args_name '("istringa")
                 :var_name '("")
                 :args (list 
                        stringa)))

(defun string2method_udo (stringa opcode_string &optional (docstring ""))
  (let* ((n (string2nvar stringa docstring))
         (stringaaa (clean-string stringa))
         (arglist0 (stringa2stringhe stringaaa))
         (arglist (read-string stringaaa))
         (opcname (nth n arglist0))
         (cddrarglist (om::flat (nthcdr (1+ n) arglist)))
         (args (cons 'list cddrarglist))
         (methodname (args->methodname arglist n))
         (methodinputs (args->methodinputs arglist n))
         (initvals (make-list (car (args->real_and_optional arglist n)) :initial-element 0))
         (varname (car (args->varname arglist n))))
    (if (not (numberp (car (last args))))
      (eval
       `(om::defmethod! ,methodname ,methodinputs
          :icon ,(methodname2icon_number methodname)
          :doc ,docstring
          :initvals ',initvals
          :numouts 2
          (if (mono_dimension_p ,args)
              (om::values
               (cs_udo ,opcode_string)
               (make-instance 'cs_opcode
                              :var_name (args->varname ',arglist ,n)
                              :opcode_name ,opcname
                              :args_name ',(mapcar #'(lambda (x)
                                                       (format nil "~D" x))
                                                   cddrarglist)
                              :args (removenilfromend ,args)))
            (error "args have to be mono-dimensional"))))
      (eval
       `(om::defmethod! ,methodname ,methodinputs
          :icon ,(methodname2icon_number methodname)
          :doc ,docstring
          :initvals ',initvals
          :numouts 2
          (if (mono_dimension_p ,args)
              (om::values
               (cs_udo ,opcode_string)
               (make-instance 'cs_opcode
                              :var_name (args->varname ',arglist ,n)
                              :opcode_name ,opcname
                              :args_name 
                              (append
                               ',(mapcar #'(lambda (x)
                                             (format nil "~D" x))
                                         (butlast cddrarglist))
                               (mapcar #'(lambda (x) (format nil "irest~D" x))
                                       (om::arithm-ser 1 (length opt_args) 1)))                     
                              :args (append (butlast ,args) opt_args)))
            (error "args have to be mono-dimensional")))))))
    

;====================================================================================================================================;


(string2method_udo 
"asig vowgen kfreq, kmorf, koct, imode"
"opcode vowgen, a, kkki

kfund,kmorf,koct,imode xin

imorf	ftgentmp 0, 0, 16, 10, 1; must be 16 elements long because vowels are in tables of length 16
ifenv	ftgentmp 0, 0, 4096, 19, .5, .5, 270, .5
ivib	ftgentmp 0, 0, 4096, 10, 1
if imode == 0 igoto bass
if imode == 1 igoto tenor
if imode == 2 igoto countertenor
if imode == 3 igoto alto
if imode == 4 igoto soprano
bass:
ia	ftgentmp 0, 0, 16, -2, 600, 1040, 2250, 2450, 2750, 0,  -7,  -9,  -9, -20, 60, 70, 110, 120, 130
ie	ftgentmp 0, 0, 16, -2, 400, 1620, 2400, 2800, 3100, 0, -12,  -9, -12, -18, 40, 80, 100, 120, 120
ii	ftgentmp 0, 0, 16, -2, 350, 1700, 2700, 3700, 4950, 0, -20, -30, -22, -28, 60, 90, 100, 120, 120
io	ftgentmp 0, 0, 16, -2, 450, 800,  2830, 3500, 4950, 0, -11, -21, -20, -40, 40, 80, 100, 120, 120
iu	ftgentmp 0, 0, 16, -2, 325, 700,  2530, 3500, 4950, 0, -20, -32, -28, -36, 40, 80, 100, 120, 120
igoto ind
tenor:
ia	ftgentmp 0, 0, 16, -2, 650, 1080, 2650, 2900, 3250, 0,  -6,  -7,  -8, -22, 80, 90, 120, 130, 140	
ie	ftgentmp 0, 0, 16, -2, 400, 1700, 2600, 3200, 3580, 0, -14, -12, -14, -20, 70, 80, 100, 120, 120	
ii	ftgentmp 0, 0, 16, -2, 290, 1870, 2800, 3250, 3540, 0, -15, -18, -20, -30, 40, 90, 100, 120, 120	
io	ftgentmp 0, 0, 16, -2, 400,  800, 2600, 2800, 3000, 0, -10, -12, -12, -26, 70, 80, 100, 130, 135	
iu	ftgentmp 0, 0, 16, -2, 350,  600, 2700, 2900, 3300, 0, -20, -17, -14, -26, 40, 60, 100, 120, 120
igoto ind
countertenor:
ia	ftgentmp 990, 0, 16, -2, 660, 1120, 2750, 3000, 3350, 0,  -6, -23, -24, -38, 80, 90, 120, 130, 140	
ie	ftgentmp 991, 0, 16, -2, 440, 1800, 2700, 3000, 3300, 0, -14, -18, -20, -20, 70, 80, 100, 120, 120	
ii	ftgentmp 992, 0, 16, -2, 270, 1850, 2900, 3350, 3590, 0, -24, -24, -36, -36, 40, 90, 100, 120, 120	
io	ftgentmp 993, 0, 16, -2, 430,  820, 2700, 3000, 3300, 0, -10, -26, -22, -34, 40, 80, 100, 120, 120	
iu	ftgentmp 994, 0, 16, -2, 370,  630, 2750, 3000, 3400, 0, -20, -23, -30, -34, 40, 60, 100, 120, 120
igoto ind
alto:
ia	ftgentmp 0, 0, 16, -2, 800, 1150, 2800, 3500, 4950, 0,  -4, -20, -36, -60, 80,  90, 120, 130, 140
ie	ftgentmp 0, 0, 16, -2, 400, 1600, 2700, 3300, 4950, 0, -24, -30, -35, -60, 60,  80, 120, 150, 200
ii	ftgentmp 0, 0, 16, -2, 350, 1700, 2700, 3700, 4950, 0, -20, -30, -36, -60, 50, 100, 120, 150, 200
io	ftgentmp 0, 0, 16, -2, 450, 800,  2830, 3500, 4950, 0,  -9, -16, -28, -55, 70,  80, 100, 130, 135
iu	ftgentmp 0, 0, 16, -2, 325, 700,  2530, 3500, 4950, 0, -12, -30, -40, -64, 50,  60, 170, 180, 200
igoto ind
soprano:
ia	ftgentmp 0, 0, 16, -2, 800, 1150, 2900, 3900, 4950, 0,  -6, -32, -20, -50, 80,  90, 120, 130, 140	
ie	ftgentmp 0, 0, 16, -2, 350, 2000, 2800, 3600, 4950, 0, -20, -15, -40, -56, 60, 100, 120, 150, 200	
ii	ftgentmp 0, 0, 16, -2, 270, 2140, 2950, 3900, 4950, 0, -12, -26, -26, -44, 60,  90, 100, 120, 120	
io	ftgentmp 0, 0, 16, -2, 450,  800, 2830, 3800, 4950, 0, -11, -22, -22, -50, 40,  80, 100, 120, 120	
iu	ftgentmp 0, 0, 16, -2, 325,  700, 2700, 3800, 4950, 0, -16, -35, -40, -60, 50,  60, 170, 180, 200
igoto ind

ind:
index	ftgentmp 0, 0, 16, -2, ia, ie, ii, ia, io, iu, ie, io, ii, iu, ia, io, ia, ia, ia, ia, ia


	ftmorf	kmorf, index, imorf

kfx	=	0
kform1	table	kfx,   imorf
kform2	table	kfx+1, imorf
kform3	table	kfx+2, imorf
kform4	table	kfx+3, imorf
kform5	table	kfx+4, imorf
kamp1	table	kfx+5, imorf
kamp2	table	kfx+6, imorf
kamp3	table	kfx+7, imorf
kamp4	table	kfx+8, imorf
kamp5	table	kfx+9, imorf
kbw1	table	kfx+10,imorf
kbw2	table	kfx+11,imorf
kbw3	table	kfx+12, imorf
kbw4	table	kfx+13, imorf
kbw5	table	kfx+14, imorf

iolaps	=	200
a1	fof	ampdbfs(kamp1),  kfund,  kform1,  koct, kbw1, .003,  .02,  .007,  iolaps,  ivib, ifenv,  p3
a2	fof	ampdbfs(kamp2),  kfund,  kform2,  koct, kbw2, .003,  .02,  .007,  iolaps,  ivib, ifenv,  p3
a3	fof	ampdbfs(kamp3),  kfund,  kform3,  koct, kbw3, .003,  .02,  .007,  iolaps,  ivib, ifenv,  p3
a4	fof	ampdbfs(kamp4),  kfund,  kform4,  koct, kbw4, .003,  .02,  .007,  iolaps,  ivib, ifenv,  p3
a5	fof	ampdbfs(kamp5),  kfund,  kform5,  koct, kbw5, .003,  .02,  .007,  iolaps,  ivib, ifenv,  p3
asig	=	a1+a2+a3+a4+a5

	xout	asig
endop"
"fof-based vocal generator with morfable vowels")

(string2method_udo 
"aout randomwalka kstep, imin, imax, iseed"
"opcode randomwalka, a, kiii
        setksmps 1
kstep, imin, imax, iseed        xin
k1      init (imin + imax) * 0.5
k2      rnd31 kstep, 0, iseed
k3      =  k1 + k2
k1      =  ((k3 < imin) || (k3 > imax) ? k1 - k2 : k3)
aout    upsamp k1
        xout aout
        endop "
"Generate random walk at a-rate. rnd31 outputs in range kstep and output is bound within imin and imax")

(string2method_udo 
"kout randomwalkk kstep, imin, imax, iseed"
"opcode randomwalkk, k, kiii
kstep, imin, imax, iseed        xin
k1      init (imin + imax) * 0.5
k2      rnd31 kstep, 0, iseed
k3      =  k1 + k2
k1      =  ((k3 < imin) || (k3 > imax) ? k1 - k2 : k3)
        xout k1
        endop "
"Generate random walk at k-rate. rnd31 outputs in range kstep and output is bound within imin and imax")

(string2method_udo
"aout decimator ain, kbitdepth, ksrate"
"opcode	decimator, a, akk
	setksmps	1
ain, kbit, ksrate		xin

kbits    = 2^kbit			; Bit depth (1 to 16)
kfold    = (sr/ksrate)			; Sample rate
kin      downsamp  ain			; Convert to kr
kin      = (kin + 32768)		; Add DC to avoid (-)
kin      = kin*(kbits / 65536)		; Divide signal level
kin      = int(kin)			; Quantise
aout     upsamp  kin			; Convert to sr
aout     = aout * (65536/kbits) - 32768	; Scale and remove DC

a0ut     fold  aout, kfold		; Resample

	xout      a0ut

		endop"
"Sample rate / Bit depth reduce. Based on the work of Steven Cook. k-rate parameters")

(string2method_udo
"al, ar ensemblechorus ain, kdelay, kdpth, kminrate, kmaxrate, inumvoice, iwave"
"opcode ensemblechorus, aa, akkkkiip
ain, kdelay, kdpth, kmin, kmax, inumvoice, iwave, icount xin
incr = 1/(inumvoice)

if (icount == inumvoice) goto out
ainl, ainr ensemblechorus ain, kdelay, kdpth, kmin, kmax, inumvoice, iwave, icount + 1

out:

max:
imax = i(kmax)
if (kmax != imax) then 
reinit max
endif

iratemax unirand imax
rireturn
alfo oscil kdpth, iratemax + kmin, iwave
adel vdelay3 ain/(inumvoice * .5), (kdelay + alfo) * 1000, 1000
al = ainl + adel * incr * icount
ar = ainr + adel * (1 - incr * icount)
xout al, ar
	endop"
"A stereo chorus opcode with multiple voices")

(string2method_udo
"aout freqshift ain, kfreq"
"opcode freqshift, a, ak
  
	ain, kfreq	xin
	
	; Phase quadrature output derived from input signal.
	areal, aimag hilbert ain
	 
	; Sine table for quadrature oscillator.
	iSineTable ftgen	0, 0, 16384, 10, 1

	; Quadrature oscillator.
	asin oscili 1, kfreq, iSineTable
	acos oscili 1, kfreq, iSineTable, .25
	 
	; Use a trigonometric identity. 
	; See the references for further details.
	amod1 = areal * acos
	amod2 = aimag * asin
	
	; Both sum and difference frequencies can be 
	; output at once.
	; aupshift corresponds to the sum frequencies.
	aupshift = (amod1 + amod2) * 0.7
	; adownshift corresponds to the difference frequencies. 
	adownshift = (amod1 - amod2) * 0.7
	
	; Notice that the adding of the two together is
	; identical to the output of ring modulation.
	
	xout aupshift
endop"
"Frequency shifting, or single sideband amplitude modulation")

(string2method_udo
"asig vowel asig, kmorf, imode"
"opcode vowel, a,aki
asig,kmorf,imode xin

imorf	ftgentmp 0, 0, 16, 10, 1; must be 16 elements long because vowels are in tables of length 16
ifenv	ftgentmp 0, 0, 4096, 19, .5, .5, 270, .5
ivib	ftgentmp 0, 0, 4096, 10, 1
if imode == 0 igoto bass
if imode == 1 igoto tenor
if imode == 2 igoto countertenor
if imode == 3 igoto alto
if imode == 4 igoto soprano
bass:
ia	ftgentmp 0, 0, 16, -2, 600, 1040, 2250, 2450, 2750, 0,  -7,  -9,  -9, -20, 60, 70, 110, 120, 130
ie	ftgentmp 0, 0, 16, -2, 400, 1620, 2400, 2800, 3100, 0, -12,  -9, -12, -18, 40, 80, 100, 120, 120
ii	ftgentmp 0, 0, 16, -2, 350, 1700, 2700, 3700, 4950, 0, -20, -30, -22, -28, 60, 90, 100, 120, 120
io	ftgentmp 0, 0, 16, -2, 450, 800,  2830, 3500, 4950, 0, -11, -21, -20, -40, 40, 80, 100, 120, 120
iu	ftgentmp 0, 0, 16, -2, 325, 700,  2530, 3500, 4950, 0, -20, -32, -28, -36, 40, 80, 100, 120, 120
igoto ind
tenor:
ia	ftgentmp 0, 0, 16, -2, 650, 1080, 2650, 2900, 3250, 0,  -6,  -7,  -8, -22, 80, 90, 120, 130, 140	
ie	ftgentmp 0, 0, 16, -2, 400, 1700, 2600, 3200, 3580, 0, -14, -12, -14, -20, 70, 80, 100, 120, 120	
ii	ftgentmp 0, 0, 16, -2, 290, 1870, 2800, 3250, 3540, 0, -15, -18, -20, -30, 40, 90, 100, 120, 120	
io	ftgentmp 0, 0, 16, -2, 400,  800, 2600, 2800, 3000, 0, -10, -12, -12, -26, 70, 80, 100, 130, 135	
iu	ftgentmp 0, 0, 16, -2, 350,  600, 2700, 2900, 3300, 0, -20, -17, -14, -26, 40, 60, 100, 120, 120
igoto ind
countertenor:
ia	ftgentmp 990, 0, 16, -2, 660, 1120, 2750, 3000, 3350, 0,  -6, -23, -24, -38, 80, 90, 120, 130, 140	
ie	ftgentmp 991, 0, 16, -2, 440, 1800, 2700, 3000, 3300, 0, -14, -18, -20, -20, 70, 80, 100, 120, 120	
ii	ftgentmp 992, 0, 16, -2, 270, 1850, 2900, 3350, 3590, 0, -24, -24, -36, -36, 40, 90, 100, 120, 120	
io	ftgentmp 993, 0, 16, -2, 430,  820, 2700, 3000, 3300, 0, -10, -26, -22, -34, 40, 80, 100, 120, 120	
iu	ftgentmp 994, 0, 16, -2, 370,  630, 2750, 3000, 3400, 0, -20, -23, -30, -34, 40, 60, 100, 120, 120
igoto ind
alto:
ia	ftgentmp 0, 0, 16, -2, 800, 1150, 2800, 3500, 4950, 0,  -4, -20, -36, -60, 80,  90, 120, 130, 140
ie	ftgentmp 0, 0, 16, -2, 400, 1600, 2700, 3300, 4950, 0, -24, -30, -35, -60, 60,  80, 120, 150, 200
ii	ftgentmp 0, 0, 16, -2, 350, 1700, 2700, 3700, 4950, 0, -20, -30, -36, -60, 50, 100, 120, 150, 200
io	ftgentmp 0, 0, 16, -2, 450, 800,  2830, 3500, 4950, 0,  -9, -16, -28, -55, 70,  80, 100, 130, 135
iu	ftgentmp 0, 0, 16, -2, 325, 700,  2530, 3500, 4950, 0, -12, -30, -40, -64, 50,  60, 170, 180, 200
igoto ind
soprano:
ia	ftgentmp 0, 0, 16, -2, 800, 1150, 2900, 3900, 4950, 0,  -6, -32, -20, -50, 80,  90, 120, 130, 140	
ie	ftgentmp 0, 0, 16, -2, 350, 2000, 2800, 3600, 4950, 0, -20, -15, -40, -56, 60, 100, 120, 150, 200	
ii	ftgentmp 0, 0, 16, -2, 270, 2140, 2950, 3900, 4950, 0, -12, -26, -26, -44, 60,  90, 100, 120, 120	
io	ftgentmp 0, 0, 16, -2, 450,  800, 2830, 3800, 4950, 0, -11, -22, -22, -50, 40,  80, 100, 120, 120	
iu	ftgentmp 0, 0, 16, -2, 325,  700, 2700, 3800, 4950, 0, -16, -35, -40, -60, 50,  60, 170, 180, 200
igoto ind


ind:
index	ftgentmp 0, 0, 16, -2, ia, ie, ii, ia, io, iu, ie, io, ii, iu, ia, io, ia, ia, ia, ia, ia

	ftmorf	kmorf, index, imorf

kfx	=	0
kform1	table	kfx,   imorf
kform2	table	kfx+1, imorf
kform3	table	kfx+2, imorf
kform4	table	kfx+3, imorf
kform5	table	kfx+4, imorf
kamp1	table	kfx+5, imorf
kamp2	table	kfx+6, imorf
kamp3	table	kfx+7, imorf
kamp4	table	kfx+8, imorf
kamp5	table	kfx+9, imorf
kbw1	table	kfx+10,imorf
kbw2	table	kfx+11,imorf
kbw3	table	kfx+12, imorf
kbw4	table	kfx+13, imorf
kbw5	table	kfx+14, imorf

iolaps	=	200

a1 butbp asig*db(kamp1), kform1, kbw1
a2 butbp asig*db(kamp2), kform2, kbw2
a3 butbp asig*db(kamp3), kform3, kbw3
a4 butbp asig*db(kamp4), kform4, kbw4
a5 butbp asig*db(kamp5), kform5, kbw5

asig	=	a1+a2+a3+a4+a5

	xout	asig
	endop"
"vowel filter with morfable vowels")

(string2method_udo
"aout tap_tubewarmth ain, kdrive, kblend"
"opcode tap_tubewarmth,a,akk

setksmps 1

ain, kdrive, kblend xin

kdrive	 	limit kdrive, 0.1, 10
kblend 		limit kblend, -10, 10

kprevdrive init 0
kprevblend init 0

krdrive 	init 0
krbdr 		init 0
kkpa 		init 0
kkpb 		init 0
kkna 		init 0
kknb 		init 0
kap 		init 0
kan 		init 0
kimr 		init 0
kkc 		init 0
ksrct 		init 0
ksq 		init 0
kpwrq 		init 0

#define TAP_EPS # 0.000000001 # 
#define TAP_M(X) # $X = (($X > $TAP_EPS || $X < -$TAP_EPS) ? $X : 0) #
#define TAP_D(A) # 
if ($A > $TAP_EPS) then
	$A = sqrt($A)
elseif ($A < $TAP_EPS) then
	$A = sqrt(-$A)
else
	$A = 0
endif
#

if (kprevdrive != kdrive || kprevblend != kblend) then

krdrive = 12.0 / kdrive;
krbdr = krdrive / (10.5 - kblend) * 780.0 / 33.0;

kkpa = 2.0 * (krdrive*krdrive) - 1.0
$TAP_D(kkpa)
kkpa = kkpa + 1.0;

kkpb = (2.0 - kkpa) / 2.0;
kap = ((krdrive*krdrive) - kkpa + 1.0) / 2.0;

kkc = 2.0 * (krdrive*krdrive) - 1.0
$TAP_D(kkc)
kkc = 2.0 * kkc - 2.0 * krdrive * krdrive
$TAP_D(kkc)

kkc = kkpa / kkc

ksrct = (0.1 * sr) / (0.1 * sr + 1.0);
ksq = kkc*kkc + 1.0

kknb = ksq
$TAP_D(kknb)
kknb = -1.0 * krbdr / kknb

kkna = ksq
$TAP_D(kkna)
kkna = 2.0 * kkc * krbdr / kkna

kan = krbdr*krbdr / ksq

kimr = 2.0 * kkna + 4.0 * kan - 1.0
$TAP_D(kimr)
kimr = 2.0 * kknb + kimr


kpwrq = 2.0 / (kimr + 1.0)

kprevdrive = kdrive
kprevblend = kblend

endif

aprevmed 	init 0
amed 		init 0
aprevout	init 0

kin downsamp ain

if (kin >= 0.0) then
	kmed = kap + kin * (kkpa - kin)
	$TAP_D(kmed)
	amed = (kmed + kkpb) * kpwrq
else
	kmed = kap - kin * (kkpa + kin)
	$TAP_D(kmed)
	amed = (kmed + kkpb) * kpwrq * -1
endif

aout = ksrct * (amed - aprevmed + aprevout)

kout downsamp aout
kmed downsamp amed


if (kout < -1.0) then
	aout = -1.0
	kout = -1.0
endif

$TAP_M(kout)
$TAP_M(kmed)

aprevmed = kmed
aprevout = kout

#undef TAP_D
#undef TAP_M
#undef TAP_EPS

xout aout

	endop"
"TAP TubeWarmth adds the character of vacuum tube amplification to your audio tracks by emulating the sonically desirable nonlinear characteristics of triodes. In addition, this plugin also supports emulating analog tape saturation")

(string2method_udo
"asig residual ain, ifftsize"
"opcode residual, a, ai

ain,isiz  xin 
ihsiz = isiz/4

imsrsin	ftgen 0, 0, 8193, 10, 1

ffr,fphs  pvsifd   ain, isiz, ihsiz, 1
ftrk      partials ffr, fphs, 0, 1, 3, 500
aout      sinsyn   ftrk, 2, 500, imsrsin
asd       delayr   isiz/sr
asig      deltapn  isiz-ihsiz
          delayw   ain
          xout     asig-aout

endop"
"extracts stochastic components (transients etc) from a sound (using csound 5 opcodes)")

(string2method_udo
"aout sittinginaroom asig, imix, icount"
"opcode	sittinginaroom, a, aii

asig, imix, icount	xin

if icount==0 goto skip

asig sittinginaroom asig, imix, icount- 1

skip:

aout	convolve 	asig*imix, \"impulse.cv\"

xout	aout

	endop"
"A simple,recursive opcode that has pleasant effects. The name pretty much describes what it does")

(string2method_udo
"aout msrosc iamp, ifreq, ifn"
";Sine 
gimsrsin	ftgen 0, 0, 8193, 10, 1

;Triangle 
gimsrtri	ftgen 0, 0, 8193, 7, -1, 4096,1,4096,-1

;Square
gimsrsqr	ftgen 0, 0, 8193, 7, 1,  4096, 1, 0, -1, 4096, -1

;Saw
gimsrsaw	ftgen 0,0, 8193, 7, -1, 8192,1

;Tube Distortion from Hans Mikelson\\\'s multi-effects
gimsrtub        	ftgen 0, 0,  8193, 7, -.8, 934, -.79, 934, -.77, 934, -.64, 1034, -.48, 520, .47, 2300, .48, 1536, .48 

;Half Triangle
gimsrhtr	ftgen 0, 0, 8193, 7, 0, 4096,1,4096,0

;Half Square	
gimsrhsq	ftgen 0, 0, 8193, 7, 1,  4096, 1, 0, 0, 4096, 0

;Half Saw
gimsrhsw	ftgen 0, 0, 8193, 7, 0, 8192,1

; Noise
gimsrnse        	ftgen 0, 0, 8193, 21, 1

        opcode  msrosc, a,iii
iamp, ifreq, ifn xin
ifunc	= ifn
	if ifn >=1 igoto ifnok1
	ifunc = 1
ifnok1:
	if ifn < 10 igoto ifnok2
	ifunc = 1
ifnok2:
ifr	= ifreq
	if ifreq > 20 igoto freqok
		ifr = cpspch(ifreq)
freqok:
idur	= p3-.04
	if idur < 0 igoto durok
		idur = 0
durok:
iam	= iamp
	if iamp >= 0 igoto ampok
		iam = 0
ampok:

idur	= p3-.04

kamp      linseg    0, .02, 1, idur, 1, .02, 0                ; Declick
; Figure out asin depending on the oscilator type.
; the conditional structure is fairly efficient, testing max 3 conditions.
	if ifunc >4 goto tube
	if ifunc > 2 goto square
	if ifunc > 1 goto triangle  
;1
sine:
asin    oscil	iam, ifr, gimsrsin

	goto done

;2
triangle:
asin	oscil	iam, ifr, gimsrtri
	goto done
;3
square:
	if ifunc > 3 goto saw
asin	oscil	iam, ifr, gimsrsqr
	goto done
;4
saw:
	; no test	
asin	oscil	iam, ifr, gimsrsaw
	goto done
;5
tube:
	if ifunc > 7 goto hsaw
	if ifunc > 5 goto htriangle
asin	oscil	iam, ifr, gimsrtub
	goto done
;6
htriangle:
	if ifunc > 6 goto hsquare
asin	oscil	iam, ifr, gimsrhtr
	goto done
;7
hsquare:
asin	oscil	iam, ifr, gimsrhsq
	goto done
;8
hsaw:
	if ifunc > 8 goto noise
asin	oscil	iam, ifr, gimsrhsw
	goto done
;9
noise:
a2      oscil           iam,ifr,gimsrnse
asin      =( a2*2)-p4

done:
        xout      asin*kamp
        endop"
"Generators simplified. De-clicked envelopes")

(string2method_udo
 "aout LDoppler asig, adist, ic"

 "opcode LDoppler,a,aai 
asource,adist,ic xin 
adist tone adist, 10 ; smooth changes in direction 
adel = adist/ic 
adump delayr 1 ; max delay 
adopp deltap3 adel ; var delay 
delayw asource ; delay input 
amin init 1 ; min dist 1 m 
adist max adist, amin 
ampfac = 1/adist 
xout adopp*ampfac 
endop"
 "Doppler Effect Simulator")

(string2method_udo
 "aout BarberpoleFlanger ain, ilevel, idepth, irate, ifeed, imode"
 "opcode BarberpoleFlanger, a, aiiiii
ain, ilevel, idepth, irate, ifeed, imode xin

ilevl    = ilevel*.25                        ; Output level
idpth    = idepth/1000                       ; Depth in ms
irate    = p6                                ; Rate
ifeed    = p7                                ; Feedback

iramp ftgen 0, 0, 8192, -7, 1, 8192, imode
ihalfsine ftgen 0, 0, 8192, 19, .5, 1, 0, 0

asaw1    oscili  idpth, irate, iramp         ; Saw 0 degrees
asaw2    wrap  asaw1 + idpth*.25, 0, idpth   ; Saw 90 degrees
asaw3    wrap  asaw1 + idpth*.50, 0, idpth   ; Saw 180 degrees
asaw4    wrap  asaw1 + idpth*.75, 0, idpth   ; Saw 270 degrees
asin1    oscili  1, irate, ihalfsine         ; 1/2 Sine 0 degrees
asin2    oscili  1, irate, ihalfsine, .25    ; 1/2 Sine 90 degrees
asin3    oscili  1, irate, ihalfsine, .5     ; 1/2 Sine 180 degrees
asin4    oscili  1, irate, ihalfsine, .75    ; 1/2 Sine 270 degrees
adel1    flanger  ain, asaw1, ifeed, idpth   ; Flanger 1
adel2    flanger  ain, asaw2, ifeed, idpth   ; Flanger 2
adel3    flanger  ain, asaw3, ifeed, idpth   ; Flanger 3
adel4    flanger  ain, asaw4, ifeed, idpth   ; Flanger 4
aflange  maca  adel1, asin1, adel2, asin2, adel3, asin3, adel4, asin4
aflange  dcblock  aflange                    ; Remove offset
adirect  = ain*(asin1 + asin2 + asin3 + asin4)        ; Scale input 
aout      aflange*ilevl + adirect*ilevl       ; Output
endop" "Pseudo continuously rising or falling flanging")

(setf *udos_menu*
      '("UDOs"
        nil nil
        (a_randomwalka
         k_randomwalkk
         a_decimator
         a_ensemblechorus
         a_freqshift
         a_tap_tubewarmth
         a_residual
         a_vowel
         a_vowgen
         a_sittinginaroom
         a_msrosc) 
        nil))